// Code generated by protoc-gen-gogo. DO NOT EDIT.
// source: kv/kvserver/kvserverpb/lease_status.proto

package kvserverpb

import proto "github.com/gogo/protobuf/proto"
import fmt "fmt"
import math "math"
import roachpb "github.com/cockroachdb/cockroach/pkg/roachpb"
import hlc "github.com/cockroachdb/cockroach/pkg/util/hlc"

import io "io"

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.GoGoProtoPackageIsVersion2 // please upgrade the proto package

type LeaseState int32

const (
	// ERROR indicates that the lease can't be used or acquired.
	LeaseState_ERROR LeaseState = 0
	// VALID indicates that the lease can be used.
	LeaseState_VALID LeaseState = 1
	// STASIS indicates that the lease has not expired, but can't be
	// used because it is close to expiration (a stasis period at the
	// end of each lease is one of the ways we handle clock
	// uncertainty). A lease in STASIS may become VALID for the same
	// leaseholder after a successful RequestLease (for expiration-based
	// leases) or Heartbeat (for epoch-based leases). A lease may not
	// change hands while it is in stasis; would-be acquirers must wait
	// for the stasis period to expire.
	//
	// The point of the stasis period is to prevent reads on the old leaseholder
	// (the one whose stasis we're talking about) from missing to see writes
	// performed under the next lease (held by someone else) when these writes
	// should fall in the uncertainty window. Even without the stasis, writes
	// performed by the new leaseholder are guaranteed to have higher timestamps
	// than any reads served by the old leaseholder. However, a read at timestamp
	// T needs to observe all writes at timestamps [T, T+maxOffset] and so,
	// without the stasis, only the new leaseholder might have some of these
	// writes. In other words, without the stasis, a new leaseholder with a fast
	// clock could start performing writes ordered in real time before the old
	// leaseholder considers its lease to have expired.
	LeaseState_STASIS LeaseState = 2
	// EXPIRED indicates that the lease can't be used. An expired lease
	// may become VALID for the same leaseholder on RequestLease or
	// Heartbeat, or it may be replaced by a new leaseholder with a
	// RequestLease (for expiration-based leases) or
	// IncrementEpoch+RequestLease (for epoch-based leases).
	LeaseState_EXPIRED LeaseState = 3
	// PROSCRIBED indicates that the lease's proposed timestamp is
	// earlier than allowed. This is used to detect node restarts: a
	// node that has restarted will see its former incarnation's leases
	// as PROSCRIBED so it will renew them before using them. Note that
	// the PROSCRIBED state is only visible to the leaseholder; other
	// nodes will see this as a VALID lease.
	LeaseState_PROSCRIBED LeaseState = 4
)

var LeaseState_name = map[int32]string{
	0: "ERROR",
	1: "VALID",
	2: "STASIS",
	3: "EXPIRED",
	4: "PROSCRIBED",
}
var LeaseState_value = map[string]int32{
	"ERROR":      0,
	"VALID":      1,
	"STASIS":     2,
	"EXPIRED":    3,
	"PROSCRIBED": 4,
}

func (x LeaseState) String() string {
	return proto.EnumName(LeaseState_name, int32(x))
}
func (LeaseState) EnumDescriptor() ([]byte, []int) {
	return fileDescriptor_lease_status_c8125d34c8e4ebdc, []int{0}
}

// LeaseStatus holds the lease state, the timestamp at which the state
// is accurate, the lease and optionally the liveness if the lease is
// epoch-based.
type LeaseStatus struct {
	// Lease which this status describes.
	Lease roachpb.Lease `protobuf:"bytes,1,opt,name=lease,proto3" json:"lease"`
	// Timestamp that the lease was evaluated at.
	Timestamp hlc.Timestamp `protobuf:"bytes,2,opt,name=timestamp,proto3" json:"timestamp"`
	// State of the lease at timestamp.
	State LeaseState `protobuf:"varint,3,opt,name=state,proto3,enum=cockroach.kv.kvserver.storagepb.LeaseState" json:"state,omitempty"`
	// Liveness if this is an epoch-based lease.
	Liveness Liveness `protobuf:"bytes,4,opt,name=liveness,proto3" json:"liveness"`
}

func (m *LeaseStatus) Reset()         { *m = LeaseStatus{} }
func (m *LeaseStatus) String() string { return proto.CompactTextString(m) }
func (*LeaseStatus) ProtoMessage()    {}
func (*LeaseStatus) Descriptor() ([]byte, []int) {
	return fileDescriptor_lease_status_c8125d34c8e4ebdc, []int{0}
}
func (m *LeaseStatus) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *LeaseStatus) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	b = b[:cap(b)]
	n, err := m.MarshalTo(b)
	if err != nil {
		return nil, err
	}
	return b[:n], nil
}
func (dst *LeaseStatus) XXX_Merge(src proto.Message) {
	xxx_messageInfo_LeaseStatus.Merge(dst, src)
}
func (m *LeaseStatus) XXX_Size() int {
	return m.Size()
}
func (m *LeaseStatus) XXX_DiscardUnknown() {
	xxx_messageInfo_LeaseStatus.DiscardUnknown(m)
}

var xxx_messageInfo_LeaseStatus proto.InternalMessageInfo

func init() {
	proto.RegisterType((*LeaseStatus)(nil), "cockroach.kv.kvserver.storagepb.LeaseStatus")
	proto.RegisterEnum("cockroach.kv.kvserver.storagepb.LeaseState", LeaseState_name, LeaseState_value)
}
func (m *LeaseStatus) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalTo(dAtA)
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *LeaseStatus) MarshalTo(dAtA []byte) (int, error) {
	var i int
	_ = i
	var l int
	_ = l
	dAtA[i] = 0xa
	i++
	i = encodeVarintLeaseStatus(dAtA, i, uint64(m.Lease.Size()))
	n1, err := m.Lease.MarshalTo(dAtA[i:])
	if err != nil {
		return 0, err
	}
	i += n1
	dAtA[i] = 0x12
	i++
	i = encodeVarintLeaseStatus(dAtA, i, uint64(m.Timestamp.Size()))
	n2, err := m.Timestamp.MarshalTo(dAtA[i:])
	if err != nil {
		return 0, err
	}
	i += n2
	if m.State != 0 {
		dAtA[i] = 0x18
		i++
		i = encodeVarintLeaseStatus(dAtA, i, uint64(m.State))
	}
	dAtA[i] = 0x22
	i++
	i = encodeVarintLeaseStatus(dAtA, i, uint64(m.Liveness.Size()))
	n3, err := m.Liveness.MarshalTo(dAtA[i:])
	if err != nil {
		return 0, err
	}
	i += n3
	return i, nil
}

func encodeVarintLeaseStatus(dAtA []byte, offset int, v uint64) int {
	for v >= 1<<7 {
		dAtA[offset] = uint8(v&0x7f | 0x80)
		v >>= 7
		offset++
	}
	dAtA[offset] = uint8(v)
	return offset + 1
}
func (m *LeaseStatus) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	l = m.Lease.Size()
	n += 1 + l + sovLeaseStatus(uint64(l))
	l = m.Timestamp.Size()
	n += 1 + l + sovLeaseStatus(uint64(l))
	if m.State != 0 {
		n += 1 + sovLeaseStatus(uint64(m.State))
	}
	l = m.Liveness.Size()
	n += 1 + l + sovLeaseStatus(uint64(l))
	return n
}

func sovLeaseStatus(x uint64) (n int) {
	for {
		n++
		x >>= 7
		if x == 0 {
			break
		}
	}
	return n
}
func sozLeaseStatus(x uint64) (n int) {
	return sovLeaseStatus(uint64((x << 1) ^ uint64((int64(x) >> 63))))
}
func (m *LeaseStatus) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowLeaseStatus
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= (uint64(b) & 0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: LeaseStatus: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: LeaseStatus: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Lease", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowLeaseStatus
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= (int(b) & 0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthLeaseStatus
			}
			postIndex := iNdEx + msglen
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if err := m.Lease.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 2:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Timestamp", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowLeaseStatus
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= (int(b) & 0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthLeaseStatus
			}
			postIndex := iNdEx + msglen
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if err := m.Timestamp.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 3:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field State", wireType)
			}
			m.State = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowLeaseStatus
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.State |= (LeaseState(b) & 0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		case 4:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Liveness", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowLeaseStatus
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= (int(b) & 0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthLeaseStatus
			}
			postIndex := iNdEx + msglen
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if err := m.Liveness.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		default:
			iNdEx = preIndex
			skippy, err := skipLeaseStatus(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if skippy < 0 {
				return ErrInvalidLengthLeaseStatus
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func skipLeaseStatus(dAtA []byte) (n int, err error) {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return 0, ErrIntOverflowLeaseStatus
			}
			if iNdEx >= l {
				return 0, io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= (uint64(b) & 0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		wireType := int(wire & 0x7)
		switch wireType {
		case 0:
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return 0, ErrIntOverflowLeaseStatus
				}
				if iNdEx >= l {
					return 0, io.ErrUnexpectedEOF
				}
				iNdEx++
				if dAtA[iNdEx-1] < 0x80 {
					break
				}
			}
			return iNdEx, nil
		case 1:
			iNdEx += 8
			return iNdEx, nil
		case 2:
			var length int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return 0, ErrIntOverflowLeaseStatus
				}
				if iNdEx >= l {
					return 0, io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				length |= (int(b) & 0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			iNdEx += length
			if length < 0 {
				return 0, ErrInvalidLengthLeaseStatus
			}
			return iNdEx, nil
		case 3:
			for {
				var innerWire uint64
				var start int = iNdEx
				for shift := uint(0); ; shift += 7 {
					if shift >= 64 {
						return 0, ErrIntOverflowLeaseStatus
					}
					if iNdEx >= l {
						return 0, io.ErrUnexpectedEOF
					}
					b := dAtA[iNdEx]
					iNdEx++
					innerWire |= (uint64(b) & 0x7F) << shift
					if b < 0x80 {
						break
					}
				}
				innerWireType := int(innerWire & 0x7)
				if innerWireType == 4 {
					break
				}
				next, err := skipLeaseStatus(dAtA[start:])
				if err != nil {
					return 0, err
				}
				iNdEx = start + next
			}
			return iNdEx, nil
		case 4:
			return iNdEx, nil
		case 5:
			iNdEx += 4
			return iNdEx, nil
		default:
			return 0, fmt.Errorf("proto: illegal wireType %d", wireType)
		}
	}
	panic("unreachable")
}

var (
	ErrInvalidLengthLeaseStatus = fmt.Errorf("proto: negative length found during unmarshaling")
	ErrIntOverflowLeaseStatus   = fmt.Errorf("proto: integer overflow")
)

func init() {
	proto.RegisterFile("kv/kvserver/kvserverpb/lease_status.proto", fileDescriptor_lease_status_c8125d34c8e4ebdc)
}

var fileDescriptor_lease_status_c8125d34c8e4ebdc = []byte{
	// 367 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0x84, 0x91, 0xcf, 0x6a, 0xea, 0x40,
	0x18, 0xc5, 0x33, 0xfe, 0xbb, 0xd7, 0x11, 0x24, 0x0c, 0x77, 0x11, 0x84, 0x3b, 0x4a, 0xa1, 0xa0,
	0x6d, 0x99, 0x80, 0xed, 0x0b, 0xc4, 0x9a, 0x45, 0x50, 0x50, 0x26, 0x52, 0x4a, 0x37, 0x25, 0x49,
	0x07, 0x95, 0xc4, 0x26, 0x24, 0x63, 0x9e, 0xa3, 0xab, 0x3e, 0x93, 0x4b, 0x97, 0xae, 0x4a, 0x1b,
	0x5f, 0xa4, 0x64, 0x12, 0x93, 0x6e, 0x8a, 0xbb, 0xc3, 0xcc, 0x39, 0xe7, 0xfb, 0xf1, 0x7d, 0x70,
	0xe0, 0xc6, 0xaa, 0x1b, 0x47, 0x2c, 0x8c, 0x59, 0x58, 0x88, 0xc0, 0x56, 0x3d, 0x66, 0x45, 0xec,
	0x39, 0xe2, 0x16, 0xdf, 0x46, 0x24, 0x08, 0x7d, 0xee, 0xa3, 0xae, 0xe3, 0x3b, 0x6e, 0xe8, 0x5b,
	0xce, 0x8a, 0xb8, 0x31, 0x39, 0x79, 0x49, 0xc4, 0xfd, 0xd0, 0x5a, 0xb2, 0xc0, 0xee, 0x20, 0xf1,
	0x19, 0xd8, 0xea, 0x8b, 0xc5, 0xad, 0x2c, 0xd4, 0xb9, 0xfc, 0xad, 0x7f, 0x1d, 0xb3, 0x57, 0x16,
	0xe5, 0xdd, 0x1d, 0x65, 0xcb, 0xd7, 0x9e, 0xba, 0xf2, 0x1c, 0x95, 0xaf, 0x37, 0x2c, 0xe2, 0xd6,
	0x26, 0xc8, 0x7f, 0xfe, 0x2d, 0xfd, 0xa5, 0x2f, 0xa4, 0x9a, 0xaa, 0xec, 0xf5, 0xe2, 0xbd, 0x02,
	0x5b, 0xd3, 0x14, 0xd1, 0x14, 0x84, 0xe8, 0x0e, 0xd6, 0x05, 0xb1, 0x02, 0x7a, 0xa0, 0xdf, 0x1a,
	0x2a, 0xa4, 0x64, 0xcd, 0xa1, 0x88, 0xb0, 0x8f, 0x6a, 0xbb, 0x8f, 0xae, 0x44, 0x33, 0x33, 0xd2,
	0x60, 0xb3, 0x18, 0xa7, 0x54, 0x44, 0xf2, 0xff, 0x8f, 0x64, 0xca, 0x44, 0x56, 0x9e, 0x43, 0x16,
	0x27, 0x53, 0x1e, 0x2f, 0x53, 0x48, 0x83, 0xf5, 0x74, 0x49, 0x4c, 0xa9, 0xf6, 0x40, 0xbf, 0x3d,
	0xbc, 0x26, 0x67, 0x96, 0x44, 0x0a, 0x6a, 0x46, 0xb3, 0x24, 0x9a, 0xc0, 0xbf, 0xa7, 0x6d, 0x28,
	0x35, 0x01, 0x31, 0x38, 0xdf, 0x92, 0x07, 0x72, 0xa0, 0xa2, 0xe0, 0x6a, 0x02, 0x61, 0x39, 0x01,
	0x35, 0x61, 0x5d, 0xa7, 0x74, 0x46, 0x65, 0x29, 0x95, 0x0f, 0xda, 0xd4, 0x18, 0xcb, 0x00, 0x41,
	0xd8, 0x30, 0x17, 0x9a, 0x69, 0x98, 0x72, 0x05, 0xb5, 0xe0, 0x1f, 0xfd, 0x71, 0x6e, 0x50, 0x7d,
	0x2c, 0x57, 0x51, 0x1b, 0xc2, 0x39, 0x9d, 0x99, 0xf7, 0xd4, 0x18, 0xe9, 0x63, 0xb9, 0x36, 0xba,
	0xd9, 0x7d, 0x61, 0x69, 0x97, 0x60, 0xb0, 0x4f, 0x30, 0x38, 0x24, 0x18, 0x7c, 0x26, 0x18, 0xbc,
	0x1d, 0xb1, 0xb4, 0x3f, 0x62, 0xe9, 0x70, 0xc4, 0xd2, 0x13, 0x2c, 0x4f, 0x6a, 0x37, 0xc4, 0x69,
	0x6e, 0xbf, 0x03, 0x00, 0x00, 0xff, 0xff, 0x2c, 0xd3, 0xba, 0xbd, 0x53, 0x02, 0x00, 0x00,
}
