// Code generated by protoc-gen-gogo. DO NOT EDIT.
// source: sql/catalog/descpb/tenant.proto

package descpb

import proto "github.com/gogo/protobuf/proto"
import fmt "fmt"
import math "math"

import io "io"

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.GoGoProtoPackageIsVersion2 // please upgrade the proto package

// The state of the tenant. Dictates whether SQL sessions for the tenant
// should be allowed, although this is currently not enforced.
type TenantInfo_State int32

const (
	// Tenant is online and available for SQL sessions.
	TenantInfo_ACTIVE TenantInfo_State = 0
	// Tenant is being added. Not available for SQL sessions.
	TenantInfo_ADD TenantInfo_State = 1
	// Tenant is being dropped. Not available for SQL sessions.
	TenantInfo_DROP TenantInfo_State = 2
)

var TenantInfo_State_name = map[int32]string{
	0: "ACTIVE",
	1: "ADD",
	2: "DROP",
}
var TenantInfo_State_value = map[string]int32{
	"ACTIVE": 0,
	"ADD":    1,
	"DROP":   2,
}

func (x TenantInfo_State) Enum() *TenantInfo_State {
	p := new(TenantInfo_State)
	*p = x
	return p
}
func (x TenantInfo_State) String() string {
	return proto.EnumName(TenantInfo_State_name, int32(x))
}
func (x *TenantInfo_State) UnmarshalJSON(data []byte) error {
	value, err := proto.UnmarshalJSONEnum(TenantInfo_State_value, data, "TenantInfo_State")
	if err != nil {
		return err
	}
	*x = TenantInfo_State(value)
	return nil
}
func (TenantInfo_State) EnumDescriptor() ([]byte, []int) {
	return fileDescriptor_tenant_407090f618c5ec30, []int{0, 0}
}

// TenantInfo represents a tenant in a multi-tenant cluster and is
// stored in the "info" column of the "system.tenants" table. The
// TenantInfo has a globally-unique ID.
type TenantInfo struct {
	ID    uint64           `protobuf:"varint,1,opt,name=id" json:"id"`
	State TenantInfo_State `protobuf:"varint,2,opt,name=state,enum=cockroach.sql.sqlbase.TenantInfo_State" json:"state"`
}

func (m *TenantInfo) Reset()         { *m = TenantInfo{} }
func (m *TenantInfo) String() string { return proto.CompactTextString(m) }
func (*TenantInfo) ProtoMessage()    {}
func (*TenantInfo) Descriptor() ([]byte, []int) {
	return fileDescriptor_tenant_407090f618c5ec30, []int{0}
}
func (m *TenantInfo) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *TenantInfo) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	b = b[:cap(b)]
	n, err := m.MarshalTo(b)
	if err != nil {
		return nil, err
	}
	return b[:n], nil
}
func (dst *TenantInfo) XXX_Merge(src proto.Message) {
	xxx_messageInfo_TenantInfo.Merge(dst, src)
}
func (m *TenantInfo) XXX_Size() int {
	return m.Size()
}
func (m *TenantInfo) XXX_DiscardUnknown() {
	xxx_messageInfo_TenantInfo.DiscardUnknown(m)
}

var xxx_messageInfo_TenantInfo proto.InternalMessageInfo

func init() {
	proto.RegisterType((*TenantInfo)(nil), "cockroach.sql.sqlbase.TenantInfo")
	proto.RegisterEnum("cockroach.sql.sqlbase.TenantInfo_State", TenantInfo_State_name, TenantInfo_State_value)
}
func (this *TenantInfo) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*TenantInfo)
	if !ok {
		that2, ok := that.(TenantInfo)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if this.ID != that1.ID {
		return false
	}
	if this.State != that1.State {
		return false
	}
	return true
}
func (m *TenantInfo) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalTo(dAtA)
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *TenantInfo) MarshalTo(dAtA []byte) (int, error) {
	var i int
	_ = i
	var l int
	_ = l
	dAtA[i] = 0x8
	i++
	i = encodeVarintTenant(dAtA, i, uint64(m.ID))
	dAtA[i] = 0x10
	i++
	i = encodeVarintTenant(dAtA, i, uint64(m.State))
	return i, nil
}

func encodeVarintTenant(dAtA []byte, offset int, v uint64) int {
	for v >= 1<<7 {
		dAtA[offset] = uint8(v&0x7f | 0x80)
		v >>= 7
		offset++
	}
	dAtA[offset] = uint8(v)
	return offset + 1
}
func (m *TenantInfo) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	n += 1 + sovTenant(uint64(m.ID))
	n += 1 + sovTenant(uint64(m.State))
	return n
}

func sovTenant(x uint64) (n int) {
	for {
		n++
		x >>= 7
		if x == 0 {
			break
		}
	}
	return n
}
func sozTenant(x uint64) (n int) {
	return sovTenant(uint64((x << 1) ^ uint64((int64(x) >> 63))))
}
func (m *TenantInfo) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowTenant
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= (uint64(b) & 0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: TenantInfo: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: TenantInfo: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field ID", wireType)
			}
			m.ID = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowTenant
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.ID |= (uint64(b) & 0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		case 2:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field State", wireType)
			}
			m.State = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowTenant
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.State |= (TenantInfo_State(b) & 0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		default:
			iNdEx = preIndex
			skippy, err := skipTenant(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if skippy < 0 {
				return ErrInvalidLengthTenant
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func skipTenant(dAtA []byte) (n int, err error) {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return 0, ErrIntOverflowTenant
			}
			if iNdEx >= l {
				return 0, io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= (uint64(b) & 0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		wireType := int(wire & 0x7)
		switch wireType {
		case 0:
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return 0, ErrIntOverflowTenant
				}
				if iNdEx >= l {
					return 0, io.ErrUnexpectedEOF
				}
				iNdEx++
				if dAtA[iNdEx-1] < 0x80 {
					break
				}
			}
			return iNdEx, nil
		case 1:
			iNdEx += 8
			return iNdEx, nil
		case 2:
			var length int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return 0, ErrIntOverflowTenant
				}
				if iNdEx >= l {
					return 0, io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				length |= (int(b) & 0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			iNdEx += length
			if length < 0 {
				return 0, ErrInvalidLengthTenant
			}
			return iNdEx, nil
		case 3:
			for {
				var innerWire uint64
				var start int = iNdEx
				for shift := uint(0); ; shift += 7 {
					if shift >= 64 {
						return 0, ErrIntOverflowTenant
					}
					if iNdEx >= l {
						return 0, io.ErrUnexpectedEOF
					}
					b := dAtA[iNdEx]
					iNdEx++
					innerWire |= (uint64(b) & 0x7F) << shift
					if b < 0x80 {
						break
					}
				}
				innerWireType := int(innerWire & 0x7)
				if innerWireType == 4 {
					break
				}
				next, err := skipTenant(dAtA[start:])
				if err != nil {
					return 0, err
				}
				iNdEx = start + next
			}
			return iNdEx, nil
		case 4:
			return iNdEx, nil
		case 5:
			iNdEx += 4
			return iNdEx, nil
		default:
			return 0, fmt.Errorf("proto: illegal wireType %d", wireType)
		}
	}
	panic("unreachable")
}

var (
	ErrInvalidLengthTenant = fmt.Errorf("proto: negative length found during unmarshaling")
	ErrIntOverflowTenant   = fmt.Errorf("proto: integer overflow")
)

func init() {
	proto.RegisterFile("sql/catalog/descpb/tenant.proto", fileDescriptor_tenant_407090f618c5ec30)
}

var fileDescriptor_tenant_407090f618c5ec30 = []byte{
	// 249 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0xe2, 0x92, 0x2f, 0x2e, 0xcc, 0xd1,
	0x4f, 0x4e, 0x2c, 0x49, 0xcc, 0xc9, 0x4f, 0xd7, 0x4f, 0x49, 0x2d, 0x4e, 0x2e, 0x48, 0xd2, 0x2f,
	0x49, 0xcd, 0x4b, 0xcc, 0x2b, 0xd1, 0x2b, 0x28, 0xca, 0x2f, 0xc9, 0x17, 0x12, 0x4d, 0xce, 0x4f,
	0xce, 0x2e, 0xca, 0x4f, 0x4c, 0xce, 0xd0, 0x2b, 0x2e, 0xcc, 0x01, 0xe1, 0xa4, 0xc4, 0xe2, 0x54,
	0x29, 0x91, 0xf4, 0xfc, 0xf4, 0x7c, 0xb0, 0x0a, 0x7d, 0x10, 0x0b, 0xa2, 0x58, 0x69, 0x36, 0x23,
	0x17, 0x57, 0x08, 0x58, 0xb7, 0x67, 0x5e, 0x5a, 0xbe, 0x90, 0x14, 0x17, 0x53, 0x66, 0x8a, 0x04,
	0xa3, 0x02, 0xa3, 0x06, 0x8b, 0x13, 0xd7, 0x89, 0x7b, 0xf2, 0x0c, 0x8f, 0xee, 0xc9, 0x33, 0x79,
	0xba, 0x04, 0x31, 0x65, 0xa6, 0x08, 0x39, 0x73, 0xb1, 0x16, 0x97, 0x24, 0x96, 0xa4, 0x4a, 0x30,
	0x29, 0x30, 0x6a, 0xf0, 0x19, 0xa9, 0xeb, 0x61, 0xb5, 0x47, 0x0f, 0x61, 0x9a, 0x5e, 0x30, 0x48,
	0xb9, 0x13, 0x0b, 0xc8, 0x9c, 0x20, 0x88, 0x5e, 0x25, 0x35, 0x2e, 0x56, 0xb0, 0xa8, 0x10, 0x17,
	0x17, 0x9b, 0xa3, 0x73, 0x88, 0x67, 0x98, 0xab, 0x00, 0x83, 0x10, 0x3b, 0x17, 0xb3, 0xa3, 0x8b,
	0x8b, 0x00, 0xa3, 0x10, 0x07, 0x17, 0x8b, 0x4b, 0x90, 0x7f, 0x80, 0x00, 0x93, 0x15, 0xcb, 0x8b,
	0x05, 0xf2, 0x8c, 0x4e, 0x1a, 0x27, 0x1e, 0xca, 0x31, 0x9c, 0x78, 0x24, 0xc7, 0x78, 0xe1, 0x91,
	0x1c, 0xe3, 0x8d, 0x47, 0x72, 0x8c, 0x0f, 0x1e, 0xc9, 0x31, 0x4e, 0x78, 0x2c, 0xc7, 0x70, 0xe1,
	0xb1, 0x1c, 0xc3, 0x8d, 0xc7, 0x72, 0x0c, 0x51, 0x6c, 0x90, 0x10, 0x00, 0x04, 0x00, 0x00, 0xff,
	0xff, 0x15, 0x46, 0x27, 0xec, 0x16, 0x01, 0x00, 0x00,
}
