// Copyright 2019 The Cockroach Authors.
//
// Use of this software is governed by the Business Source License
// included in the file licenses/BSL.txt.
//
// As of the Change Date specified in that file, in accordance with
// the Business Source License, use of this software will be governed
// by the Apache License, Version 2.0, included in the file
// licenses/APL.txt.

package colexec

import (
	"testing"

	"github.com/cockroachdb/cockroach/pkg/testutils/buildutil"
	"github.com/cockroachdb/cockroach/pkg/util/leaktest"
	"github.com/cockroachdb/cockroach/pkg/util/log"
)

func TestNoLinkForbidden(t *testing.T) {
	defer leaktest.AfterTest(t)()
	defer log.Scope(t).Close(t)

	buildutil.VerifyNoImports(t,
		"github.com/cockroachdb/cockroach/pkg/sql/colexec", true,
		[]string{
			"github.com/cockroachdb/cockroach/pkg/sql/colflow",
			"github.com/cockroachdb/cockroach/pkg/sql/rowexec",
			"github.com/cockroachdb/cockroach/pkg/sql/rowflow",
		}, nil,
	)
	buildutil.VerifyNoImports(t,
		"github.com/cockroachdb/cockroach/pkg/sql/colexec/execgen/cmd/execgen", true,
		[]string{
			"github.com/cockroachdb/cockroach/pkg/sql/catalog",
			"github.com/cockroachdb/cockroach/pkg/sql/execinfrapb",
		}, nil,
	)
}
