// Copyright 2020 The Cockroach Authors.
//
// Use of this software is governed by the Business Source License
// included in the file licenses/BSL.txt.
//
// As of the Change Date specified in that file, in accordance with
// the Business Source License, use of this software will be governed
// by the Apache License, Version 2.0, included in the file
// licenses/APL.txt.

// Package nocopy defines an Analyzer that detects invalid uses of util.NoCopy.
package nocopy_test

import (
	"testing"

	"github.com/cockroachdb/cockroach/pkg/testutils/lint/passes/nocopy"
	"github.com/cockroachdb/cockroach/pkg/testutils/skip"
	"golang.org/x/tools/go/analysis/analysistest"
)

func Test(t *testing.T) {
	skip.UnderStress(t)
	testdata := analysistest.TestData()
	analysistest.Run(t, testdata, nocopy.Analyzer, "a")
}
