// Copyright 2019 The Cockroach Authors.
//
// Use of this software is governed by the Business Source License
// included in the file licenses/BSL.txt.
//
// As of the Change Date specified in that file, in accordance with
// the Business Source License, use of this software will be governed
// by the Apache License, Version 2.0, included in the file
// licenses/APL.txt.

package main

var pgjdbcBlocklists = blocklistsForVersion{
	{"v19.2", "pgjdbcBlockList19_2", pgjdbcBlockList19_2, "pgjdbcIgnoreList19_2", pgjdbcIgnoreList19_2},
	{"v20.1", "pgjdbcBlockList20_1", pgjdbcBlockList20_1, "pgjdbcIgnoreList20_1", pgjdbcIgnoreList20_1},
	{"v20.2", "pgjdbcBlockList20_2", pgjdbcBlockList20_2, "pgjdbcIgnoreList20_2", pgjdbcIgnoreList20_2},
	{"v21.1", "pgjdbcBlockList21_1", pgjdbcBlockList21_1, "pgjdbcIgnoreList21_1", pgjdbcIgnoreList21_1},
}

// Please keep these lists alphabetized for easy diffing.
// After a failed run, an updated version of this blocklist should be available
// in the test log.
var pgjdbcBlockList21_1 = pgjdbcBlockList20_2

var pgjdbcBlockList20_2 = blocklist{
	"org.postgresql.jdbc.DeepBatchedInsertStatementTest.testDeepInternalsBatchedQueryDecorator": "26508",
	"org.postgresql.jdbc.DeepBatchedInsertStatementTest.testUnspecifiedParameterType":           "26508",
	"org.postgresql.jdbc.DeepBatchedInsertStatementTest.testVaryingTypeCounts":                  "26508",
	"org.postgresql.jdbc.PgSQLXMLTest.setCharacterStream":                                       "43355",
	"org.postgresql.test.core.OptionsPropertyTest.testOptionsInProperties":                      "unknown",
	"org.postgresql.test.jdbc2.ArrayTest.testEscaping[binary = FORCE]":                          "32552",
	"org.postgresql.test.jdbc2.ArrayTest.testEscaping[binary = REGULAR]":                        "32552",
	"org.postgresql.test.jdbc2.ArrayTest.testMultiDimensionalArray[binary = FORCE]":             "32552",
	"org.postgresql.test.jdbc2.ArrayTest.testMultiDimensionalArray[binary = REGULAR]":           "32552",
	"org.postgresql.test.jdbc2.ArrayTest.testNonStandardBounds[binary = FORCE]":                 "41405",
	"org.postgresql.test.jdbc2.ArrayTest.testNonStandardBounds[binary = REGULAR]":               "41405",
	"org.postgresql.test.jdbc2.ArrayTest.testNonStandardDelimiter[binary = FORCE]":              "21286",
	"org.postgresql.test.jdbc2.ArrayTest.testNonStandardDelimiter[binary = REGULAR]":            "21286",
	"org.postgresql.test.jdbc2.ArrayTest.testNullValues[binary = FORCE]":                        "26925",
	"org.postgresql.test.jdbc2.ArrayTest.testNullValues[binary = REGULAR]":                      "26925",
	"org.postgresql.test.jdbc2.ArrayTest.testRecursiveResultSets[binary = FORCE]":               "32552",
	"org.postgresql.test.jdbc2.ArrayTest.testRecursiveResultSets[binary = REGULAR]":             "32552",
	"org.postgresql.test.jdbc2.ArrayTest.testRetrieveArrays[binary = FORCE]":                    "41405",
	"org.postgresql.test.jdbc2.ArrayTest.testRetrieveArrays[binary = REGULAR]":                  "41405",
	"org.postgresql.test.jdbc2.ArrayTest.testRetrieveResultSets[binary = FORCE]":                "41405",
	"org.postgresql.test.jdbc2.ArrayTest.testRetrieveResultSets[binary = REGULAR]":              "41405",
	"org.postgresql.test.jdbc2.ArrayTest.testSetArray[binary = FORCE]":                          "26925",
	"org.postgresql.test.jdbc2.ArrayTest.testSetArray[binary = REGULAR]":                        "26925",
	"org.postgresql.test.jdbc2.ArrayTest.testSetPrimitiveArraysObjects[binary = FORCE]":         "26925",
	"org.postgresql.test.jdbc2.ArrayTest.testSetPrimitiveArraysObjects[binary = REGULAR]":       "26925",
	"org.postgresql.test.jdbc2.ArrayTest.testSetPrimitiveObjects[binary = FORCE]":               "26925",
	"org.postgresql.test.jdbc2.ArrayTest.testSetPrimitiveObjects[binary = REGULAR]":             "26925",
	"org.postgresql.test.jdbc2.ArrayTest.testWriteMultiDimensional[binary = FORCE]":             "32552",
	"org.postgresql.test.jdbc2.ArrayTest.testWriteMultiDimensional[binary = REGULAR]":           "32552",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[100: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                               "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[101: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                                "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[102: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":                   "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[103: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":                    "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[13: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=YES, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                                "41445",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[144: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                        "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[145: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                         "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[146: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":            "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[147: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":             "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[148: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                       "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[149: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                        "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[150: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[151: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":            "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[152: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                      "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[153: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                       "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[154: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":          "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[155: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[156: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                         "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[157: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                          "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[158: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":             "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[159: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":              "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[15: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=YES, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":                    "41445",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[160: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                        "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[161: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                         "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[162: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":            "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[163: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":             "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[177: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=YES, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                              "41445",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[179: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=YES, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":                  "41445",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[228: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                      "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[229: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                       "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[230: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":          "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[231: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[232: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                    "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[233: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                     "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[234: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":        "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[235: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":         "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[236: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                      "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[237: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                       "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[238: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":          "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[239: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[260: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                               "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[261: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                                "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[262: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":                   "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[263: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":                    "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[264: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                              "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[265: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                               "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[266: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":                  "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[267: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":                   "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[308: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                       "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[309: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                        "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[310: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[311: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":            "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[312: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                      "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[313: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                       "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[314: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":          "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[315: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[316: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                     "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[317: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                      "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[318: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":         "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[319: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":          "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[320: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                        "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[321: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                         "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[322: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":            "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[323: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":             "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[324: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                       "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[325: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                        "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[326: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[327: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":            "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[341: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                              "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[343: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":                  "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[348: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=DEALLOCATE, continueMode=COMMIT, flushOnDeallocate=false, hastransaction=false, sql=SELECT, columns=EXACT)]":                       "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[349: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=DEALLOCATE, continueMode=COMMIT, flushOnDeallocate=false, hastransaction=false, sql=SELECT, columns=STAR)]":                        "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[350: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=DEALLOCATE, continueMode=COMMIT, flushOnDeallocate=false, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[351: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=DEALLOCATE, continueMode=COMMIT, flushOnDeallocate=false, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":            "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[368: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=DISCARD, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[369: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=DISCARD, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                            "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[370: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=DISCARD, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":               "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[371: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=DISCARD, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":                "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[372: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=DISCARD, continueMode=COMMIT, flushOnDeallocate=false, hastransaction=false, sql=SELECT, columns=EXACT)]":                          "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[373: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=DISCARD, continueMode=COMMIT, flushOnDeallocate=false, hastransaction=false, sql=SELECT, columns=STAR)]":                           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[374: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=DISCARD, continueMode=COMMIT, flushOnDeallocate=false, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":              "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[375: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=DISCARD, continueMode=COMMIT, flushOnDeallocate=false, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":               "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[392: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                      "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[393: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                       "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[394: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":          "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[395: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[396: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                    "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[397: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                     "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[398: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":        "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[399: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":         "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[400: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                      "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[401: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                       "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[402: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":          "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[403: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[424: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                               "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[425: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                                "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[426: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":                   "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[427: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":                    "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[428: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                              "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[429: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                               "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[430: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":                  "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[431: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":                   "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[472: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                       "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[473: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                        "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[474: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[475: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":            "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[476: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                      "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[477: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                       "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[478: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":          "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[479: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[480: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                     "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[481: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                      "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[482: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":         "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[483: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":          "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[484: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                        "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[485: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                         "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[486: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":            "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[487: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":             "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[488: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                       "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[489: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                        "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[490: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[491: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":            "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[505: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                             "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[507: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":                 "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[512: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=DEALLOCATE, continueMode=COMMIT, flushOnDeallocate=false, hastransaction=false, sql=SELECT, columns=EXACT)]":                      "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[513: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=DEALLOCATE, continueMode=COMMIT, flushOnDeallocate=false, hastransaction=false, sql=SELECT, columns=STAR)]":                       "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[514: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=DEALLOCATE, continueMode=COMMIT, flushOnDeallocate=false, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":          "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[515: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=DEALLOCATE, continueMode=COMMIT, flushOnDeallocate=false, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[532: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=DISCARD, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                          "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[533: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=DISCARD, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[534: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=DISCARD, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":              "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[535: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=DISCARD, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":               "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[536: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=DISCARD, continueMode=COMMIT, flushOnDeallocate=false, hastransaction=false, sql=SELECT, columns=EXACT)]":                         "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[537: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=DISCARD, continueMode=COMMIT, flushOnDeallocate=false, hastransaction=false, sql=SELECT, columns=STAR)]":                          "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[538: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=DISCARD, continueMode=COMMIT, flushOnDeallocate=false, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":             "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[539: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=DISCARD, continueMode=COMMIT, flushOnDeallocate=false, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":              "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[556: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                     "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[557: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                      "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[558: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":         "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[559: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":          "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[560: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                   "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[561: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                    "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[562: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":       "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[563: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":        "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[564: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                     "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[565: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                      "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[566: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":         "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[567: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":          "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[588: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                              "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[589: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                               "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[590: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":                  "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[591: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":                   "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[592: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                             "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[593: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                              "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[594: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":                 "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[595: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":                  "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[636: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                      "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[637: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                       "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[638: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":          "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[639: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[640: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                     "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[641: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                      "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[642: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":         "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[643: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":          "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[644: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                    "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[645: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                     "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[646: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":        "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[647: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":         "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[648: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                       "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[649: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                        "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[64: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                        "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[650: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[651: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":            "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[652: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                      "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[653: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                       "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[654: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":          "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[655: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[65: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                         "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[669: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=YES, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                        "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[66: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":            "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[671: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=YES, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":            "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[67: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":             "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[68: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                      "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[69: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                       "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[70: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":          "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[71: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[720: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[721: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                 "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[722: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":    "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[723: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":     "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[724: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":              "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[725: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":               "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[726: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":  "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[727: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":   "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[728: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[729: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                 "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[72: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                        "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[730: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":    "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[731: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":     "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[73: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                         "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[74: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":            "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[752: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                         "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[753: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                          "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[754: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":             "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[755: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":              "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[756: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                        "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[757: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                         "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[758: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":            "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[759: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":             "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[75: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":             "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[800: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                 "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[801: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                  "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[802: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":     "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[803: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":      "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[804: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[805: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                 "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[806: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":    "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[807: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":     "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[808: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":               "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[809: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[810: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":   "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[811: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":    "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[812: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                  "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[813: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                   "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[814: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":      "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[815: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":       "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[816: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                 "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[817: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                  "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[818: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":     "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[819: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":      "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[833: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=YES, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                       "41445",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[835: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=YES, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":           "41445",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[884: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":               "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[885: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[886: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":   "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[887: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":    "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[888: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":             "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[889: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":              "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[890: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]": "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[891: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":  "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[892: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":               "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[893: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[894: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":   "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[895: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":    "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[916: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                        "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[917: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                         "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[918: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":            "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[919: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":             "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[920: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                       "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[921: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                        "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[922: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":           "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[923: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":            "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[964: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[965: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                 "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[966: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":    "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[967: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":     "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[968: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":               "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[969: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[96: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                                 "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[970: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":   "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[971: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":    "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[972: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":              "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[973: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":               "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[974: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":  "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[975: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":   "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[976: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                 "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[977: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                  "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[978: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":     "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[979: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":      "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[97: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                                  "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[980: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[981: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                 "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[982: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":    "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[983: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":     "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[98: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":                     "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[99: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":                      "26508",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithAlternatingTypes[binary = FORCE, insertRewrite = false]":                                                                                                                                                        "41513",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithAlternatingTypes[binary = FORCE, insertRewrite = true]":                                                                                                                                                         "41513",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithAlternatingTypes[binary = REGULAR, insertRewrite = false]":                                                                                                                                                      "41513",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithAlternatingTypes[binary = REGULAR, insertRewrite = true]":                                                                                                                                                       "41513",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithEmbeddedNulls[binary = FORCE, insertRewrite = false]":                                                                                                                                                           "26366",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithEmbeddedNulls[binary = FORCE, insertRewrite = true]":                                                                                                                                                            "26366",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithEmbeddedNulls[binary = REGULAR, insertRewrite = false]":                                                                                                                                                         "26366",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithEmbeddedNulls[binary = REGULAR, insertRewrite = true]":                                                                                                                                                          "26366",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testMixedBatch[binary = FORCE, insertRewrite = false]":                                                                                                                                                                       "31463",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testMixedBatch[binary = FORCE, insertRewrite = true]":                                                                                                                                                                        "31463",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testMixedBatch[binary = REGULAR, insertRewrite = false]":                                                                                                                                                                     "31463",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testMixedBatch[binary = REGULAR, insertRewrite = true]":                                                                                                                                                                      "31463",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testSelectInBatchThrowsAutoCommit[binary = FORCE, insertRewrite = false]":                                                                                                                                                    "44803",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testSelectInBatchThrowsAutoCommit[binary = FORCE, insertRewrite = true]":                                                                                                                                                     "44803",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testSelectInBatchThrowsAutoCommit[binary = REGULAR, insertRewrite = false]":                                                                                                                                                  "44803",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testSelectInBatchThrowsAutoCommit[binary = REGULAR, insertRewrite = true]":                                                                                                                                                   "44803",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testSelectInBatch[binary = FORCE, insertRewrite = false]":                                                                                                                                                                    "40195",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testSelectInBatch[binary = FORCE, insertRewrite = true]":                                                                                                                                                                     "40195",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testSelectInBatch[binary = REGULAR, insertRewrite = false]":                                                                                                                                                                  "40195",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testSelectInBatch[binary = REGULAR, insertRewrite = true]":                                                                                                                                                                   "40195",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testSmallBatchUpdateFailureSimple[binary = FORCE, insertRewrite = false]":                                                                                                                                                    "44803",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testSmallBatchUpdateFailureSimple[binary = REGULAR, insertRewrite = false]":                                                                                                                                                  "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[105: batchTest(mode=FAIL_VIA_DUP_KEY, position=SECOND_ROW, autoCommit=YES, batchType=PREPARED, generateKeys=YES, binary=REGULAR, insertRewrite=false)]":                                                                  "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[107: batchTest(mode=FAIL_VIA_DUP_KEY, position=SECOND_ROW, autoCommit=YES, batchType=PREPARED, generateKeys=YES, binary=FORCE, insertRewrite=false)]":                                                                    "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[112: batchTest(mode=FAIL_VIA_DUP_KEY, position=MIDDLE, autoCommit=YES, batchType=PREPARED, generateKeys=YES, binary=REGULAR, insertRewrite=true)]":                                                                       "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[113: batchTest(mode=FAIL_VIA_DUP_KEY, position=MIDDLE, autoCommit=YES, batchType=PREPARED, generateKeys=YES, binary=REGULAR, insertRewrite=false)]":                                                                      "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[114: batchTest(mode=FAIL_VIA_DUP_KEY, position=MIDDLE, autoCommit=YES, batchType=PREPARED, generateKeys=YES, binary=FORCE, insertRewrite=true)]":                                                                         "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[115: batchTest(mode=FAIL_VIA_DUP_KEY, position=MIDDLE, autoCommit=YES, batchType=PREPARED, generateKeys=YES, binary=FORCE, insertRewrite=false)]":                                                                        "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[120: batchTest(mode=FAIL_VIA_DUP_KEY, position=ALMOST_LAST_ROW, autoCommit=YES, batchType=PREPARED, generateKeys=YES, binary=REGULAR, insertRewrite=true)]":                                                              "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[121: batchTest(mode=FAIL_VIA_DUP_KEY, position=ALMOST_LAST_ROW, autoCommit=YES, batchType=PREPARED, generateKeys=YES, binary=REGULAR, insertRewrite=false)]":                                                             "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[122: batchTest(mode=FAIL_VIA_DUP_KEY, position=ALMOST_LAST_ROW, autoCommit=YES, batchType=PREPARED, generateKeys=YES, binary=FORCE, insertRewrite=true)]":                                                                "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[123: batchTest(mode=FAIL_VIA_DUP_KEY, position=ALMOST_LAST_ROW, autoCommit=YES, batchType=PREPARED, generateKeys=YES, binary=FORCE, insertRewrite=false)]":                                                               "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[128: batchTest(mode=FAIL_VIA_DUP_KEY, position=LAST_ROW, autoCommit=YES, batchType=PREPARED, generateKeys=YES, binary=REGULAR, insertRewrite=true)]":                                                                     "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[129: batchTest(mode=FAIL_VIA_DUP_KEY, position=LAST_ROW, autoCommit=YES, batchType=PREPARED, generateKeys=YES, binary=REGULAR, insertRewrite=false)]":                                                                    "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[130: batchTest(mode=FAIL_VIA_DUP_KEY, position=LAST_ROW, autoCommit=YES, batchType=PREPARED, generateKeys=YES, binary=FORCE, insertRewrite=true)]":                                                                       "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[131: batchTest(mode=FAIL_VIA_DUP_KEY, position=LAST_ROW, autoCommit=YES, batchType=PREPARED, generateKeys=YES, binary=FORCE, insertRewrite=false)]":                                                                      "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[16: batchTest(mode=FAIL_VIA_SELECT_PARSE, position=SECOND_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=REGULAR, insertRewrite=true)]":                                                                 "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[17: batchTest(mode=FAIL_VIA_SELECT_PARSE, position=SECOND_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=REGULAR, insertRewrite=false)]":                                                                "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[18: batchTest(mode=FAIL_VIA_SELECT_PARSE, position=SECOND_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=FORCE, insertRewrite=true)]":                                                                   "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[19: batchTest(mode=FAIL_VIA_SELECT_PARSE, position=SECOND_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=FORCE, insertRewrite=false)]":                                                                  "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[24: batchTest(mode=FAIL_VIA_SELECT_PARSE, position=MIDDLE, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=REGULAR, insertRewrite=true)]":                                                                     "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[25: batchTest(mode=FAIL_VIA_SELECT_PARSE, position=MIDDLE, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=REGULAR, insertRewrite=false)]":                                                                    "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[26: batchTest(mode=FAIL_VIA_SELECT_PARSE, position=MIDDLE, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=FORCE, insertRewrite=true)]":                                                                       "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[27: batchTest(mode=FAIL_VIA_SELECT_PARSE, position=MIDDLE, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=FORCE, insertRewrite=false)]":                                                                      "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[32: batchTest(mode=FAIL_VIA_SELECT_PARSE, position=ALMOST_LAST_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=REGULAR, insertRewrite=true)]":                                                            "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[33: batchTest(mode=FAIL_VIA_SELECT_PARSE, position=ALMOST_LAST_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=REGULAR, insertRewrite=false)]":                                                           "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[34: batchTest(mode=FAIL_VIA_SELECT_PARSE, position=ALMOST_LAST_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=FORCE, insertRewrite=true)]":                                                              "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[35: batchTest(mode=FAIL_VIA_SELECT_PARSE, position=ALMOST_LAST_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=FORCE, insertRewrite=false)]":                                                             "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[40: batchTest(mode=FAIL_VIA_SELECT_PARSE, position=LAST_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=REGULAR, insertRewrite=true)]":                                                                   "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[41: batchTest(mode=FAIL_VIA_SELECT_PARSE, position=LAST_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=REGULAR, insertRewrite=false)]":                                                                  "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[42: batchTest(mode=FAIL_VIA_SELECT_PARSE, position=LAST_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=FORCE, insertRewrite=true)]":                                                                     "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[43: batchTest(mode=FAIL_VIA_SELECT_PARSE, position=LAST_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=FORCE, insertRewrite=false)]":                                                                    "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[56: batchTest(mode=FAIL_VIA_SELECT_RUNTIME, position=SECOND_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=REGULAR, insertRewrite=true)]":                                                               "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[57: batchTest(mode=FAIL_VIA_SELECT_RUNTIME, position=SECOND_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=REGULAR, insertRewrite=false)]":                                                              "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[58: batchTest(mode=FAIL_VIA_SELECT_RUNTIME, position=SECOND_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=FORCE, insertRewrite=true)]":                                                                 "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[59: batchTest(mode=FAIL_VIA_SELECT_RUNTIME, position=SECOND_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=FORCE, insertRewrite=false)]":                                                                "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[64: batchTest(mode=FAIL_VIA_SELECT_RUNTIME, position=MIDDLE, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=REGULAR, insertRewrite=true)]":                                                                   "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[65: batchTest(mode=FAIL_VIA_SELECT_RUNTIME, position=MIDDLE, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=REGULAR, insertRewrite=false)]":                                                                  "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[66: batchTest(mode=FAIL_VIA_SELECT_RUNTIME, position=MIDDLE, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=FORCE, insertRewrite=true)]":                                                                     "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[67: batchTest(mode=FAIL_VIA_SELECT_RUNTIME, position=MIDDLE, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=FORCE, insertRewrite=false)]":                                                                    "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[72: batchTest(mode=FAIL_VIA_SELECT_RUNTIME, position=ALMOST_LAST_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=REGULAR, insertRewrite=true)]":                                                          "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[73: batchTest(mode=FAIL_VIA_SELECT_RUNTIME, position=ALMOST_LAST_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=REGULAR, insertRewrite=false)]":                                                         "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[74: batchTest(mode=FAIL_VIA_SELECT_RUNTIME, position=ALMOST_LAST_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=FORCE, insertRewrite=true)]":                                                            "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[75: batchTest(mode=FAIL_VIA_SELECT_RUNTIME, position=ALMOST_LAST_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=FORCE, insertRewrite=false)]":                                                           "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[80: batchTest(mode=FAIL_VIA_SELECT_RUNTIME, position=LAST_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=REGULAR, insertRewrite=true)]":                                                                 "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[81: batchTest(mode=FAIL_VIA_SELECT_RUNTIME, position=LAST_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=REGULAR, insertRewrite=false)]":                                                                "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[82: batchTest(mode=FAIL_VIA_SELECT_RUNTIME, position=LAST_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=FORCE, insertRewrite=true)]":                                                                   "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[83: batchTest(mode=FAIL_VIA_SELECT_RUNTIME, position=LAST_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=FORCE, insertRewrite=false)]":                                                                  "44803",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.test17000Binds[2: autoCommit=NO, binary=REGULAR]":                                                                                                                                                             "26508",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.test17000Binds[3: autoCommit=NO, binary=FORCE]":                                                                                                                                                               "26508",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.test32000Binds[2: autoCommit=NO, binary=REGULAR]":                                                                                                                                                             "26508",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.test32000Binds[3: autoCommit=NO, binary=FORCE]":                                                                                                                                                               "26508",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.testBatchWithReWrittenBatchStatementWithFixedParameter[2: autoCommit=NO, binary=REGULAR]":                                                                                                                     "26508",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.testBatchWithReWrittenBatchStatementWithFixedParameter[3: autoCommit=NO, binary=FORCE]":                                                                                                                       "26508",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.testBatchWithReWrittenBatchStatementWithFixedParametersOnly[2: autoCommit=NO, binary=REGULAR]":                                                                                                                "26508",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.testBatchWithReWrittenBatchStatementWithFixedParametersOnly[3: autoCommit=NO, binary=FORCE]":                                                                                                                  "26508",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.testBatchWithReWrittenRepeatedInsertStatementOptimizationEnabled[2: autoCommit=NO, binary=REGULAR]":                                                                                                           "26508",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.testBatchWithReWrittenRepeatedInsertStatementOptimizationEnabled[3: autoCommit=NO, binary=FORCE]":                                                                                                             "26508",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.testBindsInNestedParens[2: autoCommit=NO, binary=REGULAR]":                                                                                                                                                    "26508",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.testBindsInNestedParens[3: autoCommit=NO, binary=FORCE]":                                                                                                                                                      "26508",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.testConsistentOutcome[2: autoCommit=NO, binary=REGULAR]":                                                                                                                                                      "26508",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.testConsistentOutcome[3: autoCommit=NO, binary=FORCE]":                                                                                                                                                        "26508",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.testINSERTwithNamedColumnsNotBroken[2: autoCommit=NO, binary=REGULAR]":                                                                                                                                        "26508",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.testINSERTwithNamedColumnsNotBroken[3: autoCommit=NO, binary=FORCE]":                                                                                                                                          "26508",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.testMixedCaseInSeRtStatement[2: autoCommit=NO, binary=REGULAR]":                                                                                                                                               "26508",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.testMixedCaseInSeRtStatement[3: autoCommit=NO, binary=FORCE]":                                                                                                                                                 "26508",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.testMultiValues1bind[2: autoCommit=NO, binary=REGULAR]":                                                                                                                                                       "26508",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.testMultiValues1bind[3: autoCommit=NO, binary=FORCE]":                                                                                                                                                         "26508",
	"org.postgresql.test.jdbc2.BlobTest.testGetBytesOffset":                                                                                                                    "26725",
	"org.postgresql.test.jdbc2.BlobTest.testLargeLargeObject":                                                                                                                  "26725",
	"org.postgresql.test.jdbc2.BlobTest.testMarkResetStream":                                                                                                                   "26725",
	"org.postgresql.test.jdbc2.BlobTest.testMultipleStreams":                                                                                                                   "26725",
	"org.postgresql.test.jdbc2.BlobTest.testParallelStreams":                                                                                                                   "26725",
	"org.postgresql.test.jdbc2.BlobTest.testSet":                                                                                                                               "26725",
	"org.postgresql.test.jdbc2.BlobTest.testSetNull":                                                                                                                           "26725",
	"org.postgresql.test.jdbc2.BlobTest.testUploadBlob_LOOP":                                                                                                                   "26725",
	"org.postgresql.test.jdbc2.BlobTest.testUploadBlob_NATIVE":                                                                                                                 "26725",
	"org.postgresql.test.jdbc2.BlobTransactionTest.testConcurrentReplace":                                                                                                      "17511",
	"org.postgresql.test.jdbc2.CallableStmtTest.testBadStmt":                                                                                                                   "17511",
	"org.postgresql.test.jdbc2.CallableStmtTest.testBatchCall":                                                                                                                 "17511",
	"org.postgresql.test.jdbc2.CallableStmtTest.testFetchBeforeExecute":                                                                                                        "17511",
	"org.postgresql.test.jdbc2.CallableStmtTest.testFetchWithNoResults":                                                                                                        "17511",
	"org.postgresql.test.jdbc2.CallableStmtTest.testGetArray":                                                                                                                  "17511",
	"org.postgresql.test.jdbc2.CallableStmtTest.testGetDouble":                                                                                                                 "17511",
	"org.postgresql.test.jdbc2.CallableStmtTest.testGetInt":                                                                                                                    "17511",
	"org.postgresql.test.jdbc2.CallableStmtTest.testGetNumeric":                                                                                                                "17511",
	"org.postgresql.test.jdbc2.CallableStmtTest.testGetNumericWithoutArg":                                                                                                      "17511",
	"org.postgresql.test.jdbc2.CallableStmtTest.testGetShort":                                                                                                                  "17511",
	"org.postgresql.test.jdbc2.CallableStmtTest.testGetString":                                                                                                                 "17511",
	"org.postgresql.test.jdbc2.CallableStmtTest.testGetUpdateCount":                                                                                                            "17511",
	"org.postgresql.test.jdbc2.CallableStmtTest.testRaiseNotice":                                                                                                               "17511",
	"org.postgresql.test.jdbc2.CallableStmtTest.testWasNullBeforeFetch":                                                                                                        "17511",
	"org.postgresql.test.jdbc2.ClientEncodingTest.setEncodingAscii[allowEncodingChanges=false]":                                                                                "37129",
	"org.postgresql.test.jdbc2.ClientEncodingTest.setEncodingAscii[allowEncodingChanges=true]":                                                                                 "37129",
	"org.postgresql.test.jdbc2.ConcurrentStatementFetch.testFetchTwoStatements[6: fetch(autoCommit=NO, fetchSize=1, binaryMode=REGULAR)]":                                      "4035",
	"org.postgresql.test.jdbc2.ConcurrentStatementFetch.testFetchTwoStatements[7: fetch(autoCommit=NO, fetchSize=1, binaryMode=FORCE)]":                                        "4035",
	"org.postgresql.test.jdbc2.ConcurrentStatementFetch.testFetchTwoStatements[8: fetch(autoCommit=NO, fetchSize=2, binaryMode=REGULAR)]":                                      "4035",
	"org.postgresql.test.jdbc2.ConcurrentStatementFetch.testFetchTwoStatements[9: fetch(autoCommit=NO, fetchSize=2, binaryMode=FORCE)]":                                        "4035",
	"org.postgresql.test.jdbc2.ConnectionTest.testCreateStatement":                                                                                                             "41578",
	"org.postgresql.test.jdbc2.ConnectionTest.testDoubleClose":                                                                                                                 "41578",
	"org.postgresql.test.jdbc2.ConnectionTest.testIsClosed":                                                                                                                    "41578",
	"org.postgresql.test.jdbc2.ConnectionTest.testNativeSQL":                                                                                                                   "41578",
	"org.postgresql.test.jdbc2.ConnectionTest.testPrepareCall":                                                                                                                 "41578",
	"org.postgresql.test.jdbc2.ConnectionTest.testPrepareStatement":                                                                                                            "41578",
	"org.postgresql.test.jdbc2.ConnectionTest.testReadOnly_always":                                                                                                             "41578",
	"org.postgresql.test.jdbc2.ConnectionTest.testReadOnly_ignore":                                                                                                             "41578",
	"org.postgresql.test.jdbc2.ConnectionTest.testReadOnly_transaction":                                                                                                        "41578",
	"org.postgresql.test.jdbc2.ConnectionTest.testTransactionIsolation":                                                                                                        "41578",
	"org.postgresql.test.jdbc2.ConnectionTest.testTransactions":                                                                                                                "41578",
	"org.postgresql.test.jdbc2.ConnectionTest.testTypeMaps":                                                                                                                    "41578",
	"org.postgresql.test.jdbc2.ConnectionTest.testWarnings":                                                                                                                    "41578",
	"org.postgresql.test.jdbc2.CopyTest.testChangeDateStyle":                                                                                                                   "41608",
	"org.postgresql.test.jdbc2.CopyTest.testCopyOut":                                                                                                                           "41608",
	"org.postgresql.test.jdbc2.CopyTest.testCopyOutByRow":                                                                                                                      "41608",
	"org.postgresql.test.jdbc2.CopyTest.testCopyQuery":                                                                                                                         "41608",
	"org.postgresql.test.jdbc2.CopyTest.testLockReleaseOnCancelFailure":                                                                                                        "41608",
	"org.postgresql.test.jdbc2.CursorFetchTest.testMultistatement[binary = FORCE]":                                                                                             "40195",
	"org.postgresql.test.jdbc2.CursorFetchTest.testMultistatement[binary = REGULAR]":                                                                                           "40195",
	"org.postgresql.test.jdbc2.DatabaseEncodingTest.testEncoding":                                                                                                              "41771",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testArrayInt4DoubleDim":                                                                                                    "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testArrayTypeInfo":                                                                                                         "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testAscDescIndexInfo":                                                                                                      "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testBestRowIdentifier":                                                                                                     "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testCatalogs":                                                                                                              "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testColumnPrivileges":                                                                                                      "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testColumns":                                                                                                               "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testCrossReference":                                                                                                        "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testCustomArrayTypeInfo":                                                                                                   "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testDomainColumnSize":                                                                                                      "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testDroppedColumns":                                                                                                        "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testEscaping":                                                                                                              "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testForeignKeyActions":                                                                                                     "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testForeignKeys":                                                                                                           "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testForeignKeysToUniqueIndexes":                                                                                            "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testFuncReturningComposite":                                                                                                "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testFuncReturningTable":                                                                                                    "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testFuncWithDirection":                                                                                                     "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testFuncWithNames":                                                                                                         "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testFuncWithoutNames":                                                                                                      "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testFunctionColumns":                                                                                                       "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testGetSQLKeywords":                                                                                                        "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testGetUDT1":                                                                                                               "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testGetUDT2":                                                                                                               "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testGetUDT3":                                                                                                               "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testGetUDT4":                                                                                                               "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testGetUDTQualified":                                                                                                       "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testIdentityColumns":                                                                                                       "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testIndexInfo":                                                                                                             "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testInformationAboutArrayTypes":                                                                                            "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testMultiColumnForeignKeys":                                                                                                "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testNoTablePrivileges":                                                                                                     "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testNotNullDomainColumn":                                                                                                   "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testPartialIndexInfo":                                                                                                      "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testPartitionedTables":                                                                                                     "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testPrimaryKeys":                                                                                                           "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testProcedures":                                                                                                            "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testSameTableForeignKeys":                                                                                                  "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testSchemas":                                                                                                               "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testSearchStringEscape":                                                                                                    "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testSerialColumns":                                                                                                         "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testTablePrivileges":                                                                                                       "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testTableTypes":                                                                                                            "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testTables":                                                                                                                "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testTypeInfoQuoting":                                                                                                       "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testTypeInfoSigned":                                                                                                        "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testTypes":                                                                                                                 "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testVersionColumns":                                                                                                        "17511",
	"org.postgresql.test.jdbc2.DateStyleTest.conenct[dateStyle=ISO,ymd, shouldPass=true]":                                                                                      "41773",
	"org.postgresql.test.jdbc2.DateStyleTest.conenct[dateStyle=PostgreSQL, shouldPass=false]":                                                                                  "41773",
	"org.postgresql.test.jdbc2.GeometricTest.testPGbox[binary = FORCE]":                                                                                                        "21286",
	"org.postgresql.test.jdbc2.GeometricTest.testPGbox[binary = REGULAR]":                                                                                                      "21286",
	"org.postgresql.test.jdbc2.GeometricTest.testPGcircle[binary = FORCE]":                                                                                                     "21286",
	"org.postgresql.test.jdbc2.GeometricTest.testPGcircle[binary = REGULAR]":                                                                                                   "21286",
	"org.postgresql.test.jdbc2.GeometricTest.testPGline[binary = FORCE]":                                                                                                       "21286",
	"org.postgresql.test.jdbc2.GeometricTest.testPGline[binary = REGULAR]":                                                                                                     "21286",
	"org.postgresql.test.jdbc2.GeometricTest.testPGlseg[binary = FORCE]":                                                                                                       "21286",
	"org.postgresql.test.jdbc2.GeometricTest.testPGlseg[binary = REGULAR]":                                                                                                     "21286",
	"org.postgresql.test.jdbc2.GeometricTest.testPGpath[binary = FORCE]":                                                                                                       "21286",
	"org.postgresql.test.jdbc2.GeometricTest.testPGpath[binary = REGULAR]":                                                                                                     "21286",
	"org.postgresql.test.jdbc2.GeometricTest.testPGpoint[binary = FORCE]":                                                                                                      "21286",
	"org.postgresql.test.jdbc2.GeometricTest.testPGpoint[binary = REGULAR]":                                                                                                    "21286",
	"org.postgresql.test.jdbc2.GeometricTest.testPGpolygon[binary = FORCE]":                                                                                                    "21286",
	"org.postgresql.test.jdbc2.GeometricTest.testPGpolygon[binary = REGULAR]":                                                                                                  "21286",
	"org.postgresql.test.jdbc2.JBuilderTest.testMoney":                                                                                                                         "41578",
	"org.postgresql.test.jdbc2.NotifyTest.testAsyncNotify":                                                                                                                     "41522",
	"org.postgresql.test.jdbc2.NotifyTest.testAsyncNotifyWithEndlessTimeoutAndMessagesAvailableWhenStartingListening":                                                          "41522",
	"org.postgresql.test.jdbc2.NotifyTest.testAsyncNotifyWithEndlessTimeoutAndMessagesSendAfter":                                                                               "41522",
	"org.postgresql.test.jdbc2.NotifyTest.testAsyncNotifyWithTimeout":                                                                                                          "41522",
	"org.postgresql.test.jdbc2.NotifyTest.testAsyncNotifyWithTimeoutAndMessagesAvailableWhenStartingListening":                                                                 "41522",
	"org.postgresql.test.jdbc2.NotifyTest.testAsyncNotifyWithTimeoutAndMessagesSendAfter":                                                                                      "41522",
	"org.postgresql.test.jdbc2.NotifyTest.testAsyncNotifyWithTimeoutAndSocketThatBecomesClosed":                                                                                "41522",
	"org.postgresql.test.jdbc2.NotifyTest.testNotify":                                                                                                                          "41522",
	"org.postgresql.test.jdbc2.NotifyTest.testNotifyArgument":                                                                                                                  "41522",
	"org.postgresql.test.jdbc2.PGTimeTest.testTimeInsertAndSelect":                                                                                                             "41775",
	"org.postgresql.test.jdbc2.PGTimestampTest.testTimeInsertAndSelect":                                                                                                        "41775",
	"org.postgresql.test.jdbc2.ParameterStatusTest.transactionalParametersAutocommit":                                                                                          "32562",
	"org.postgresql.test.jdbc2.ParameterStatusTest.transactionalParametersCommit":                                                                                              "32562",
	"org.postgresql.test.jdbc2.ParameterStatusTest.transactionalParametersRollback":                                                                                            "32562",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testBatchWithPrepareThreshold5[binary = REGULAR]":                                                                         "5807",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testDollarQuotes[binary = FORCE]":                                                                                         "41777",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testDollarQuotes[binary = REGULAR]":                                                                                       "41777",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testDoubleQuestionMark[binary = FORCE]":                                                                                   "21286",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testDoubleQuestionMark[binary = REGULAR]":                                                                                 "21286",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testSingleQuotes[binary = FORCE]":                                                                                         "36215",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testSingleQuotes[binary = REGULAR]":                                                                                       "36215",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testUnknownSetObject[binary = FORCE]":                                                                                     "41779",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testUnknownSetObject[binary = REGULAR]":                                                                                   "41779",
	"org.postgresql.test.jdbc2.RefCursorTest.testEmptyResult[typeName = OTHER, cursorType = 1,111]":                                                                            "17511",
	"org.postgresql.test.jdbc2.RefCursorTest.testEmptyResult[typeName = REF_CURSOR, cursorType = 2,012]":                                                                       "17511",
	"org.postgresql.test.jdbc2.RefCursorTest.testMetaData[typeName = OTHER, cursorType = 1,111]":                                                                               "17511",
	"org.postgresql.test.jdbc2.RefCursorTest.testMetaData[typeName = REF_CURSOR, cursorType = 2,012]":                                                                          "17511",
	"org.postgresql.test.jdbc2.RefCursorTest.testResultType[typeName = OTHER, cursorType = 1,111]":                                                                             "17511",
	"org.postgresql.test.jdbc2.RefCursorTest.testResultType[typeName = REF_CURSOR, cursorType = 2,012]":                                                                        "17511",
	"org.postgresql.test.jdbc2.RefCursorTest.testResult[typeName = OTHER, cursorType = 1,111]":                                                                                 "17511",
	"org.postgresql.test.jdbc2.RefCursorTest.testResult[typeName = REF_CURSOR, cursorType = 2,012]":                                                                            "17511",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testCache[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = 0]":                                           "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testCache[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = null]":                                        "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testCache[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = 0]":                                        "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testCache[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = null]":                                     "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testClassesMatch[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = 0]":                                    "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testClassesMatch[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = null]":                                 "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testClassesMatch[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = 0]":                                 "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testClassesMatch[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = null]":                              "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testClosedResultSet[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = 0]":                                 "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testClosedResultSet[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = null]":                              "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testClosedResultSet[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = 0]":                              "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testClosedResultSet[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = null]":                           "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testColumnDisplaySize[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = 0]":                               "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testColumnDisplaySize[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = null]":                            "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testColumnDisplaySize[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = 0]":                            "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testColumnDisplaySize[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = null]":                         "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testComposite[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = 0]":                                       "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testComposite[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = null]":                                    "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testComposite[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = 0]":                                    "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testComposite[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = null]":                                 "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testDatabaseMetaDataNames[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = 0]":                           "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testDatabaseMetaDataNames[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = null]":                        "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testDatabaseMetaDataNames[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = 0]":                        "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testDatabaseMetaDataNames[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = null]":                     "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testIdentityColumn[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = 0]":                                  "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testIdentityColumn[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = null]":                               "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testIdentityColumn[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = 0]":                               "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testIdentityColumn[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = null]":                            "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testIsAutoIncrement[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = 0]":                                 "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testIsAutoIncrement[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = null]":                              "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testIsAutoIncrement[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = 0]":                              "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testIsAutoIncrement[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = null]":                           "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testPreparedResultSet[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = 0]":                               "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testPreparedResultSet[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = null]":                            "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testPreparedResultSet[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = 0]":                            "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testPreparedResultSet[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = null]":                         "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testPreparedUpdate[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = 0]":                                  "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testPreparedUpdate[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = null]":                               "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testPreparedUpdate[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = 0]":                               "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testPreparedUpdate[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = null]":                            "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testStandardResultSet[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = 0]":                               "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testStandardResultSet[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = null]":                            "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testStandardResultSet[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = 0]":                            "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testStandardResultSet[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = null]":                         "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testTimestampInfo[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = 0]":                                   "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testTimestampInfo[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = null]":                                "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testTimestampInfo[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = 0]":                                "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testTimestampInfo[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = null]":                             "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testUnexecutedStatement[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = 0]":                             "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testUnexecutedStatement[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = null]":                          "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testUnexecutedStatement[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = 0]":                          "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testUnexecutedStatement[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = null]":                       "32565",
	"org.postgresql.test.jdbc2.ResultSetTest.testgetBadBoolean":                                                                                                                "32552",
	"org.postgresql.test.jdbc2.SearchPathLookupTest.testSearchPathHiddenLookup":                                                                                                "unknown",
	"org.postgresql.test.jdbc2.SearchPathLookupTest.testSearchPathNormalLookup":                                                                                                "unknown",
	"org.postgresql.test.jdbc2.ServerCursorTest.testBasicFetch":                                                                                                                "41412",
	"org.postgresql.test.jdbc2.ServerCursorTest.testBinaryFetch":                                                                                                               "41412",
	"org.postgresql.test.jdbc2.ServerErrorTest.testColumn":                                                                                                                     "27796",
	"org.postgresql.test.jdbc2.ServerErrorTest.testDatatype":                                                                                                                   "27796",
	"org.postgresql.test.jdbc2.ServerErrorTest.testPrimaryKey":                                                                                                                 "27796",
	"org.postgresql.test.jdbc2.StatementTest.testClose":                                                                                                                        "17511",
	"org.postgresql.test.jdbc2.StatementTest.testCloseInProgressStatement":                                                                                                     "17511",
	"org.postgresql.test.jdbc2.StatementTest.testConcurrentWarningReadAndClear":                                                                                                "17511",
	"org.postgresql.test.jdbc2.StatementTest.testDateFuncWithParam":                                                                                                            "17511",
	"org.postgresql.test.jdbc2.StatementTest.testDateFunctions":                                                                                                                "17511",
	"org.postgresql.test.jdbc2.StatementTest.testDollarInComment":                                                                                                              "17511",
	"org.postgresql.test.jdbc2.StatementTest.testDollarInCommentTwoComments":                                                                                                   "17511",
	"org.postgresql.test.jdbc2.StatementTest.testDoubleClose":                                                                                                                  "17511",
	"org.postgresql.test.jdbc2.StatementTest.testEmptyQuery":                                                                                                                   "17511",
	"org.postgresql.test.jdbc2.StatementTest.testEscapeProcessing":                                                                                                             "17511",
	"org.postgresql.test.jdbc2.StatementTest.testExecuteUpdateFailsOnMultiStatementSelect":                                                                                     "17511",
	"org.postgresql.test.jdbc2.StatementTest.testExecuteUpdateFailsOnSelect":                                                                                                   "17511",
	"org.postgresql.test.jdbc2.StatementTest.testFastCloses":                                                                                                                   "17511",
	"org.postgresql.test.jdbc2.StatementTest.testJavascriptFunction":                                                                                                           "17511",
	"org.postgresql.test.jdbc2.StatementTest.testLongQueryTimeout":                                                                                                             "17511",
	"org.postgresql.test.jdbc2.StatementTest.testMultiExecute":                                                                                                                 "17511",
	"org.postgresql.test.jdbc2.StatementTest.testMultipleCancels":                                                                                                              "17511",
	"org.postgresql.test.jdbc2.StatementTest.testNumericFunctions":                                                                                                             "17511",
	"org.postgresql.test.jdbc2.StatementTest.testParsingDollarQuotes":                                                                                                          "17511",
	"org.postgresql.test.jdbc2.StatementTest.testParsingSemiColons":                                                                                                            "17511",
	"org.postgresql.test.jdbc2.StatementTest.testPreparedFunction":                                                                                                             "17511",
	"org.postgresql.test.jdbc2.StatementTest.testResultSetTwice":                                                                                                               "17511",
	"org.postgresql.test.jdbc2.StatementTest.testSetQueryTimeout":                                                                                                              "17511",
	"org.postgresql.test.jdbc2.StatementTest.testSetQueryTimeoutOnPrepared":                                                                                                    "17511",
	"org.postgresql.test.jdbc2.StatementTest.testSetQueryTimeoutWithSleep":                                                                                                     "17511",
	"org.postgresql.test.jdbc2.StatementTest.testSetQueryTimeoutWithoutExecute":                                                                                                "17511",
	"org.postgresql.test.jdbc2.StatementTest.testShortQueryTimeout":                                                                                                            "17511",
	"org.postgresql.test.jdbc2.StatementTest.testSideStatementFinalizers":                                                                                                      "17511",
	"org.postgresql.test.jdbc2.StatementTest.testStringFunctions":                                                                                                              "17511",
	"org.postgresql.test.jdbc2.StatementTest.testSystemFunctions":                                                                                                              "17511",
	"org.postgresql.test.jdbc2.StatementTest.testUnbalancedParensParseError":                                                                                                   "17511",
	"org.postgresql.test.jdbc2.StatementTest.testUnterminatedComment":                                                                                                          "17511",
	"org.postgresql.test.jdbc2.StatementTest.testUnterminatedDollarQuotes":                                                                                                     "17511",
	"org.postgresql.test.jdbc2.StatementTest.testUnterminatedIdentifier":                                                                                                       "17511",
	"org.postgresql.test.jdbc2.StatementTest.testUnterminatedLiteral":                                                                                                          "17511",
	"org.postgresql.test.jdbc2.StatementTest.testUnterminatedNamedDollarQuotes":                                                                                                "17511",
	"org.postgresql.test.jdbc2.StatementTest.testUpdateCount":                                                                                                                  "17511",
	"org.postgresql.test.jdbc2.StatementTest.testWarningsAreAvailableAsap":                                                                                                     "17511",
	"org.postgresql.test.jdbc2.StatementTest.testWarningsAreCleared":                                                                                                           "17511",
	"org.postgresql.test.jdbc2.StringTypeUnspecifiedArrayTest.testCreateArrayWithNonCachedType[binary = FORCE]":                                                                "21286",
	"org.postgresql.test.jdbc2.StringTypeUnspecifiedArrayTest.testCreateArrayWithNonCachedType[binary = REGULAR]":                                                              "21286",
	"org.postgresql.test.jdbc2.TimeTest.testGetTimeZone":                                                                                                                       "41775",
	"org.postgresql.test.jdbc2.TimestampTest.testGetTimestampWOTZ[binary = FORCE]":                                                                                             "41786",
	"org.postgresql.test.jdbc2.TimestampTest.testGetTimestampWOTZ[binary = REGULAR]":                                                                                           "41786",
	"org.postgresql.test.jdbc2.TimestampTest.testInfinity[binary = FORCE]":                                                                                                     "41786",
	"org.postgresql.test.jdbc2.TimestampTest.testInfinity[binary = REGULAR]":                                                                                                   "41786",
	"org.postgresql.test.jdbc2.TimestampTest.testSetTimestampWOTZ[binary = FORCE]":                                                                                             "41786",
	"org.postgresql.test.jdbc2.TimestampTest.testSetTimestampWOTZ[binary = REGULAR]":                                                                                           "41786",
	"org.postgresql.test.jdbc2.TimezoneTest.testGetDate":                                                                                                                       "41776",
	"org.postgresql.test.jdbc2.TimezoneTest.testGetTime":                                                                                                                       "41776",
	"org.postgresql.test.jdbc2.TimezoneTest.testGetTimestamp":                                                                                                                  "41776",
	"org.postgresql.test.jdbc2.TimezoneTest.testSetDate":                                                                                                                       "41776",
	"org.postgresql.test.jdbc2.TimezoneTest.testSetTime":                                                                                                                       "41776",
	"org.postgresql.test.jdbc2.TimezoneTest.testSetTimestamp":                                                                                                                  "41776",
	"org.postgresql.test.jdbc2.UpdateableResultTest.testArray":                                                                                                                 "26925",
	"org.postgresql.test.jdbc3.CompositeTest.testComplexArgumentSelect":                                                                                                        "27793",
	"org.postgresql.test.jdbc3.CompositeTest.testComplexSelect":                                                                                                                "27793",
	"org.postgresql.test.jdbc3.CompositeTest.testComplexTableNameMetadata":                                                                                                     "27793",
	"org.postgresql.test.jdbc3.CompositeTest.testCompositeFromTable":                                                                                                           "27793",
	"org.postgresql.test.jdbc3.CompositeTest.testNullArrayElement":                                                                                                             "27793",
	"org.postgresql.test.jdbc3.CompositeTest.testSimpleArgumentSelect":                                                                                                         "27793",
	"org.postgresql.test.jdbc3.CompositeTest.testSimpleSelect":                                                                                                                 "27793",
	"org.postgresql.test.jdbc3.CompositeTest.testTableMetadata":                                                                                                                "27793",
	"org.postgresql.test.jdbc3.DatabaseMetaDataTest.testGetColumnsForDomain":                                                                                                   "27796",
	"org.postgresql.test.jdbc3.EscapeSyntaxCallModeCallIfNoReturnTest.testInvokeFunction":                                                                                      "17511",
	"org.postgresql.test.jdbc3.EscapeSyntaxCallModeCallIfNoReturnTest.testInvokeFunctionHavingReturnParameter":                                                                 "17511",
	"org.postgresql.test.jdbc3.EscapeSyntaxCallModeCallIfNoReturnTest.testInvokeProcedure":                                                                                     "17511",
	"org.postgresql.test.jdbc3.EscapeSyntaxCallModeCallTest.testInvokeFunction":                                                                                                "17511",
	"org.postgresql.test.jdbc3.EscapeSyntaxCallModeCallTest.testInvokeFunctionHavingReturnParameter":                                                                           "17511",
	"org.postgresql.test.jdbc3.EscapeSyntaxCallModeCallTest.testInvokeProcedure":                                                                                               "17511",
	"org.postgresql.test.jdbc3.EscapeSyntaxCallModeSelectTest.testInvokeFunction":                                                                                              "17511",
	"org.postgresql.test.jdbc3.EscapeSyntaxCallModeSelectTest.testInvokeFunctionHavingReturnParameter":                                                                         "17511",
	"org.postgresql.test.jdbc3.EscapeSyntaxCallModeSelectTest.testInvokeProcedure":                                                                                             "17511",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testBatchGeneratedKeys[returningInQuery = A, binary = FORCE]":                                                                 "26925",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testBatchGeneratedKeys[returningInQuery = A, binary = REGULAR]":                                                               "26925",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testBatchGeneratedKeys[returningInQuery = AB, binary = FORCE]":                                                                "26925",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testBatchGeneratedKeys[returningInQuery = AB, binary = REGULAR]":                                                              "26925",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testBatchGeneratedKeys[returningInQuery = NO, binary = FORCE]":                                                                "26925",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testBatchGeneratedKeys[returningInQuery = NO, binary = REGULAR]":                                                              "26925",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testBatchGeneratedKeys[returningInQuery = STAR, binary = FORCE]":                                                              "26925",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testBatchGeneratedKeys[returningInQuery = STAR, binary = REGULAR]":                                                            "26925",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testSerialWorks[returningInQuery = A, binary = FORCE]":                                                                        "26925",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testSerialWorks[returningInQuery = A, binary = REGULAR]":                                                                      "26925",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testSerialWorks[returningInQuery = AB, binary = FORCE]":                                                                       "26925",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testSerialWorks[returningInQuery = AB, binary = REGULAR]":                                                                     "26925",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testSerialWorks[returningInQuery = NO, binary = FORCE]":                                                                       "26925",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testSerialWorks[returningInQuery = NO, binary = REGULAR]":                                                                     "26925",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testSerialWorks[returningInQuery = STAR, binary = FORCE]":                                                                     "26925",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testSerialWorks[returningInQuery = STAR, binary = REGULAR]":                                                                   "26925",
	"org.postgresql.test.jdbc3.Jdbc3BlobTest.test1Byte":                                                                                                                        "26725",
	"org.postgresql.test.jdbc3.Jdbc3BlobTest.test1ByteOffset":                                                                                                                  "26725",
	"org.postgresql.test.jdbc3.Jdbc3BlobTest.test1ByteOffsetStream":                                                                                                            "26725",
	"org.postgresql.test.jdbc3.Jdbc3BlobTest.test1ByteStream":                                                                                                                  "26725",
	"org.postgresql.test.jdbc3.Jdbc3BlobTest.testAllBytes":                                                                                                                     "26725",
	"org.postgresql.test.jdbc3.Jdbc3BlobTest.testAllBytesStream":                                                                                                               "26725",
	"org.postgresql.test.jdbc3.Jdbc3BlobTest.testManyBytes":                                                                                                                    "26725",
	"org.postgresql.test.jdbc3.Jdbc3BlobTest.testManyBytesOffset":                                                                                                              "26725",
	"org.postgresql.test.jdbc3.Jdbc3BlobTest.testManyBytesOffsetStream":                                                                                                        "26725",
	"org.postgresql.test.jdbc3.Jdbc3BlobTest.testManyBytesStream":                                                                                                              "26725",
	"org.postgresql.test.jdbc3.Jdbc3BlobTest.testPattern":                                                                                                                      "26725",
	"org.postgresql.test.jdbc3.Jdbc3BlobTest.testTruncate":                                                                                                                     "26725",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testAllInOut":                                                                                                        "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testFunctionNoParametersWithParentheses":                                                                             "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testFunctionNoParametersWithoutParentheses":                                                                          "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testGetBoolean01":                                                                                                    "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testGetByte01":                                                                                                       "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testGetBytes01":                                                                                                      "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testGetBytes02":                                                                                                      "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testGetDouble01":                                                                                                     "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testGetDoubleAsReal":                                                                                                 "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testGetInt01":                                                                                                        "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testGetLong01":                                                                                                       "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testGetObjectDecimal":                                                                                                "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testGetObjectFloat":                                                                                                  "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testGetObjectLongVarchar":                                                                                            "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testGetShort01":                                                                                                      "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testInOut":                                                                                                           "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testMultipleOutExecutions":                                                                                           "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testNotEnoughParameters":                                                                                             "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testNumeric":                                                                                                         "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testProcedureInOnlyNativeCall":                                                                                       "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testProcedureInOutNativeCall":                                                                                        "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testProcedureNoParametersWithParentheses":                                                                            "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testProcedureNoParametersWithoutParentheses":                                                                         "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testSetObjectBit":                                                                                                    "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testSomeInOut":                                                                                                       "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testSum":                                                                                                             "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testTooManyParameters":                                                                                               "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testUpdateDecimal":                                                                                                   "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testUpdateReal":                                                                                                      "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testVarcharBool":                                                                                                     "17511",
	"org.postgresql.test.jdbc3.ParameterMetaDataTest.testFailsOnBadIndex":                                                                                                      "21286",
	"org.postgresql.test.jdbc3.ParameterMetaDataTest.testMultiStatement":                                                                                                       "21286",
	"org.postgresql.test.jdbc3.ParameterMetaDataTest.testParameterMD":                                                                                                          "21286",
	"org.postgresql.test.jdbc3.ParameterMetaDataTest.testTypeChangeWithUnknown":                                                                                                "21286",
	"org.postgresql.test.jdbc3.StringTypeParameterTest.testMultipleEnumBinds[stringType = null]":                                                                               "27793",
	"org.postgresql.test.jdbc3.StringTypeParameterTest.testMultipleEnumBinds[stringType = unspecified]":                                                                        "27793",
	"org.postgresql.test.jdbc3.StringTypeParameterTest.testMultipleEnumBinds[stringType = varchar]":                                                                            "27793",
	"org.postgresql.test.jdbc3.StringTypeParameterTest.testOtherAsEnum[stringType = null]":                                                                                     "27793",
	"org.postgresql.test.jdbc3.StringTypeParameterTest.testOtherAsEnum[stringType = unspecified]":                                                                              "27793",
	"org.postgresql.test.jdbc3.StringTypeParameterTest.testOtherAsEnum[stringType = varchar]":                                                                                  "27793",
	"org.postgresql.test.jdbc3.StringTypeParameterTest.testParameterUnspecified[stringType = null]":                                                                            "27793",
	"org.postgresql.test.jdbc3.StringTypeParameterTest.testParameterUnspecified[stringType = unspecified]":                                                                     "27793",
	"org.postgresql.test.jdbc3.StringTypeParameterTest.testParameterUnspecified[stringType = varchar]":                                                                         "27793",
	"org.postgresql.test.jdbc3.StringTypeParameterTest.testVarcharAsEnum[stringType = null]":                                                                                   "27793",
	"org.postgresql.test.jdbc3.StringTypeParameterTest.testVarcharAsEnum[stringType = unspecified]":                                                                            "27793",
	"org.postgresql.test.jdbc3.StringTypeParameterTest.testVarcharAsEnum[stringType = varchar]":                                                                                "27793",
	"org.postgresql.test.jdbc3.TypesTest.testCallableBoolean":                                                                                                                  "17511",
	"org.postgresql.test.jdbc3.TypesTest.testPreparedBoolean":                                                                                                                  "17511",
	"org.postgresql.test.jdbc3.TypesTest.testPreparedByte":                                                                                                                     "17511",
	"org.postgresql.test.jdbc3.TypesTest.testUnknownType":                                                                                                                      "17511",
	"org.postgresql.test.jdbc4.ArrayTest.createNullArray[binary = FORCE]":                                                                                                      "32552",
	"org.postgresql.test.jdbc4.ArrayTest.createNullArray[binary = REGULAR]":                                                                                                    "32552",
	"org.postgresql.test.jdbc4.ArrayTest.multiDimIntArray[binary = FORCE]":                                                                                                     "32552",
	"org.postgresql.test.jdbc4.ArrayTest.multiDimIntArray[binary = REGULAR]":                                                                                                   "32552",
	"org.postgresql.test.jdbc4.ArrayTest.nullArray[binary = FORCE]":                                                                                                            "32552",
	"org.postgresql.test.jdbc4.ArrayTest.nullArray[binary = REGULAR]":                                                                                                          "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCasingBuiltinAlias[binary = FORCE]":                                                                                               "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCasingBuiltinAlias[binary = REGULAR]":                                                                                             "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCasingBuiltinNonAlias[binary = FORCE]":                                                                                            "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCasingBuiltinNonAlias[binary = REGULAR]":                                                                                          "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCasingComposite[binary = FORCE]":                                                                                                  "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCasingComposite[binary = REGULAR]":                                                                                                "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCreateArrayOfBool[binary = FORCE]":                                                                                                "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCreateArrayOfBool[binary = REGULAR]":                                                                                              "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCreateArrayOfInt[binary = FORCE]":                                                                                                 "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCreateArrayOfInt[binary = REGULAR]":                                                                                               "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCreateArrayOfMultiJson[binary = FORCE]":                                                                                           "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCreateArrayOfMultiJson[binary = REGULAR]":                                                                                         "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCreateArrayOfMultiString[binary = FORCE]":                                                                                         "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCreateArrayOfMultiString[binary = REGULAR]":                                                                                       "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCreateArrayOfNull[binary = FORCE]":                                                                                                "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCreateArrayOfNull[binary = REGULAR]":                                                                                              "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCreateArrayOfSmallInt[binary = FORCE]":                                                                                            "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCreateArrayOfSmallInt[binary = REGULAR]":                                                                                          "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCreateArrayWithNonStandardDelimiter[binary = FORCE]":                                                                              "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCreateArrayWithNonStandardDelimiter[binary = REGULAR]":                                                                            "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCreateArrayWithoutServer[binary = FORCE]":                                                                                         "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCreateArrayWithoutServer[binary = REGULAR]":                                                                                       "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCreateEmptyArrayOfIntViaAlias[binary = FORCE]":                                                                                    "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCreateEmptyArrayOfIntViaAlias[binary = REGULAR]":                                                                                  "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCreatePrimitiveArray[binary = FORCE]":                                                                                             "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCreatePrimitiveArray[binary = REGULAR]":                                                                                           "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testEvilCasing[binary = FORCE]":                                                                                                       "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testEvilCasing[binary = REGULAR]":                                                                                                     "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testGetArrayOfComposites[binary = FORCE]":                                                                                             "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testGetArrayOfComposites[binary = REGULAR]":                                                                                           "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testSetObjectFromJavaArray[binary = FORCE]":                                                                                           "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testSetObjectFromJavaArray[binary = REGULAR]":                                                                                         "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testToString[binary = FORCE]":                                                                                                         "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testToString[binary = REGULAR]":                                                                                                       "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testUUIDArray[binary = FORCE]":                                                                                                        "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testUUIDArray[binary = REGULAR]":                                                                                                      "32552",
	"org.postgresql.test.jdbc4.BlobTest.testFree":                                                                                                                              "26725",
	"org.postgresql.test.jdbc4.BlobTest.testGetBinaryStreamWithBoundaries":                                                                                                     "26725",
	"org.postgresql.test.jdbc4.BlobTest.testSetBlobWithStream":                                                                                                                 "26725",
	"org.postgresql.test.jdbc4.BlobTest.testSetBlobWithStreamAndLength":                                                                                                        "26725",
	"org.postgresql.test.jdbc4.DatabaseMetaDataHideUnprivilegedObjectsTest.org.postgresql.test.jdbc4.DatabaseMetaDataHideUnprivilegedObjectsTest":                              "unknown",
	"org.postgresql.test.jdbc4.DatabaseMetaDataTest.testGetClientInfoProperties":                                                                                               "unknown",
	"org.postgresql.test.jdbc4.DatabaseMetaDataTest.testGetColumnsForAutoIncrement":                                                                                            "41870",
	"org.postgresql.test.jdbc4.DatabaseMetaDataTest.testGetFunctionsInSchema":                                                                                                  "unknown",
	"org.postgresql.test.jdbc4.DatabaseMetaDataTest.testGetFunctionsWithBlankPatterns":                                                                                         "41872",
	"org.postgresql.test.jdbc4.DatabaseMetaDataTest.testGetFunctionsWithSpecificTypes":                                                                                         "17511",
	"org.postgresql.test.jdbc4.DatabaseMetaDataTest.testGetProceduresInSchema":                                                                                                 "unknown",
	"org.postgresql.test.jdbc4.DatabaseMetaDataTest.testGetSchemas":                                                                                                            "unknown",
	"org.postgresql.test.jdbc4.DatabaseMetaDataTest.testSortedDataTypes":                                                                                                       "unknown",
	"org.postgresql.test.jdbc4.IsValidTest.testIsValidRemoteClose":                                                                                                             "35897",
	"org.postgresql.test.jdbc4.PGCopyInputStreamTest.testReadBytesCorrectlyHandlesEof":                                                                                         "41608",
	"org.postgresql.test.jdbc4.PGCopyInputStreamTest.testReadBytesCorrectlyReadsDataInChunks":                                                                                  "41608",
	"org.postgresql.test.jdbc4.PGCopyInputStreamTest.testStreamCanBeClosedAfterReadUp":                                                                                         "41608",
	"org.postgresql.test.jdbc4.UUIDTest.testUUIDString[binary=FORCE, stringType=VARCHAR]":                                                                                      "5807",
	"org.postgresql.test.jdbc4.UUIDTest.testUUIDString[binary=REGULAR, stringType=VARCHAR]":                                                                                    "5807",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetArray":                                                                                                              "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetBigDecimal":                                                                                                         "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetBigInteger":                                                                                                         "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetBlob":                                                                                                               "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetBoolean":                                                                                                            "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetBooleanNull":                                                                                                        "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetBox":                                                                                                                "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetCalendar":                                                                                                           "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetCircle":                                                                                                             "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetClob":                                                                                                               "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetDate":                                                                                                               "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetDouble":                                                                                                             "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetDoubleNull":                                                                                                         "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetFloat":                                                                                                              "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetFloatNull":                                                                                                          "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetInet4Address":                                                                                                       "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetInet6Address":                                                                                                       "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetInetAddressNull":                                                                                                    "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetInteger":                                                                                                            "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetIntegerNull":                                                                                                        "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetInterval":                                                                                                           "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetJavaUtilDate":                                                                                                       "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetLine":                                                                                                               "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetLineseg":                                                                                                            "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetLong":                                                                                                               "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetLongNull":                                                                                                           "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetNullDate":                                                                                                           "21286",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetNullTimestamp":                                                                                                      "21286",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetPath":                                                                                                               "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetPoint":                                                                                                              "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetPolygon":                                                                                                            "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetSerial":                                                                                                             "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetShort":                                                                                                              "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetShortNull":                                                                                                          "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetString":                                                                                                             "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetTime":                                                                                                               "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetTimestamp":                                                                                                          "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetTimestampWithTimeZone":                                                                                              "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetUuid":                                                                                                               "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetXml":                                                                                                                "26097",
	"org.postgresql.test.jdbc4.jdbc41.SchemaTest.testCurrentSchemaPropertyNotVisibilityTableDuringFunctionCreation":                                                            "unknown",
	"org.postgresql.test.jdbc4.jdbc41.SchemaTest.testCurrentSchemaPropertyNotVisibilityTableInsideFunction":                                                                    "unknown",
	"org.postgresql.test.jdbc4.jdbc41.SchemaTest.testCurrentSchemaPropertyVisibilityFunction":                                                                                  "unknown",
	"org.postgresql.test.jdbc4.jdbc41.SchemaTest.testCurrentSchemaPropertyVisibilityTableDuringFunctionCreation":                                                               "unknown",
	"org.postgresql.test.jdbc4.jdbc41.SchemaTest.testMultipleSearchPath":                                                                                                       "unknown",
	"org.postgresql.test.jdbc4.jdbc41.SchemaTest.testSearchPathPreparedStatement":                                                                                              "unknown",
	"org.postgresql.test.jdbc4.jdbc41.SchemaTest.testSearchPathPreparedStatementAutoCommitFalse":                                                                               "unknown",
	"org.postgresql.test.jdbc4.jdbc41.SchemaTest.testSearchPathPreparedStatementAutoCommitTrue":                                                                                "unknown",
	"org.postgresql.test.jdbc42.GetObject310InfinityTests.test[binary = FORCE, expr = -infinity, pgType = timestamp with time zone, klass = class java.time.OffsetDateTime]":   "41786",
	"org.postgresql.test.jdbc42.GetObject310InfinityTests.test[binary = FORCE, expr = -infinity, pgType = timestamp, klass = class java.time.LocalDateTime]":                   "41786",
	"org.postgresql.test.jdbc42.GetObject310InfinityTests.test[binary = FORCE, expr = -infinity, pgType = timestamp, klass = class java.time.OffsetDateTime]":                  "41786",
	"org.postgresql.test.jdbc42.GetObject310InfinityTests.test[binary = FORCE, expr = infinity, pgType = timestamp with time zone, klass = class java.time.OffsetDateTime]":    "41786",
	"org.postgresql.test.jdbc42.GetObject310InfinityTests.test[binary = FORCE, expr = infinity, pgType = timestamp, klass = class java.time.LocalDateTime]":                    "41786",
	"org.postgresql.test.jdbc42.GetObject310InfinityTests.test[binary = FORCE, expr = infinity, pgType = timestamp, klass = class java.time.OffsetDateTime]":                   "41786",
	"org.postgresql.test.jdbc42.GetObject310InfinityTests.test[binary = REGULAR, expr = -infinity, pgType = timestamp with time zone, klass = class java.time.OffsetDateTime]": "41786",
	"org.postgresql.test.jdbc42.GetObject310InfinityTests.test[binary = REGULAR, expr = -infinity, pgType = timestamp, klass = class java.time.LocalDateTime]":                 "41786",
	"org.postgresql.test.jdbc42.GetObject310InfinityTests.test[binary = REGULAR, expr = -infinity, pgType = timestamp, klass = class java.time.OffsetDateTime]":                "41786",
	"org.postgresql.test.jdbc42.GetObject310InfinityTests.test[binary = REGULAR, expr = infinity, pgType = timestamp with time zone, klass = class java.time.OffsetDateTime]":  "41786",
	"org.postgresql.test.jdbc42.GetObject310InfinityTests.test[binary = REGULAR, expr = infinity, pgType = timestamp, klass = class java.time.LocalDateTime]":                  "41786",
	"org.postgresql.test.jdbc42.GetObject310InfinityTests.test[binary = REGULAR, expr = infinity, pgType = timestamp, klass = class java.time.OffsetDateTime]":                 "41786",
	"org.postgresql.test.jdbc42.GetObject310Test.testGetLocalTimeInvalidType[binary = FORCE]":                                                                                  "26097",
	"org.postgresql.test.jdbc42.GetObject310Test.testGetLocalTimeInvalidType[binary = REGULAR]":                                                                                "26097",
	"org.postgresql.test.jdbc42.GetObject310Test.testProlepticCalendarTimestamptz[binary = FORCE]":                                                                             "26097",
	"org.postgresql.test.jdbc42.GetObject310Test.testProlepticCalendarTimestamptz[binary = REGULAR]":                                                                           "26097",
	"org.postgresql.test.jdbc42.Jdbc42CallableStatementTest.testGetResultSetWithoutArg":                                                                                        "17511",
	"org.postgresql.test.jdbc42.Jdbc42CallableStatementTest.testGetResultSetWithoutArgUnsupportedConversion":                                                                   "17511",
	"org.postgresql.test.xa.XADataSourceTest.testAutoCommit":                                                                                                                   "22329",
	"org.postgresql.test.xa.XADataSourceTest.testCloseBeforeCommit":                                                                                                            "22329",
	"org.postgresql.test.xa.XADataSourceTest.testCommitByDifferentConnection":                                                                                                  "22329",
	"org.postgresql.test.xa.XADataSourceTest.testCommitUnknownXid":                                                                                                             "22329",
	"org.postgresql.test.xa.XADataSourceTest.testCommitingCommittedXid":                                                                                                        "22329",
	"org.postgresql.test.xa.XADataSourceTest.testDatabaseRemovesPreparedBeforeCommit":                                                                                          "22329",
	"org.postgresql.test.xa.XADataSourceTest.testDatabaseRemovesPreparedBeforeRollback":                                                                                        "22329",
	"org.postgresql.test.xa.XADataSourceTest.testEndThenJoin":                                                                                                                  "22329",
	"org.postgresql.test.xa.XADataSourceTest.testMappingOfConstraintViolations":                                                                                                "22329",
	"org.postgresql.test.xa.XADataSourceTest.testNetworkIssueOnCommit":                                                                                                         "22329",
	"org.postgresql.test.xa.XADataSourceTest.testNetworkIssueOnOnePhaseCommit":                                                                                                 "22329",
	"org.postgresql.test.xa.XADataSourceTest.testNetworkIssueOnRollback":                                                                                                       "22329",
	"org.postgresql.test.xa.XADataSourceTest.testOnePhase":                                                                                                                     "22329",
	"org.postgresql.test.xa.XADataSourceTest.testOnePhaseCommitOfPrepared":                                                                                                     "22329",
	"org.postgresql.test.xa.XADataSourceTest.testOnePhaseCommitUnknownXid":                                                                                                     "22329",
	"org.postgresql.test.xa.XADataSourceTest.testOnePhaseCommitingCommittedXid":                                                                                                "22329",
	"org.postgresql.test.xa.XADataSourceTest.testPrepareUnknownXid":                                                                                                            "22329",
	"org.postgresql.test.xa.XADataSourceTest.testPreparingPreparedXid":                                                                                                         "22329",
	"org.postgresql.test.xa.XADataSourceTest.testRecover":                                                                                                                      "22329",
	"org.postgresql.test.xa.XADataSourceTest.testRepeatedRolledBack":                                                                                                           "22329",
	"org.postgresql.test.xa.XADataSourceTest.testRestoreOfAutoCommit":                                                                                                          "22329",
	"org.postgresql.test.xa.XADataSourceTest.testRestoreOfAutoCommitEndThenJoin":                                                                                               "22329",
	"org.postgresql.test.xa.XADataSourceTest.testRollback":                                                                                                                     "22329",
	"org.postgresql.test.xa.XADataSourceTest.testRollbackByDifferentConnection":                                                                                                "22329",
	"org.postgresql.test.xa.XADataSourceTest.testRollbackUnknownXid":                                                                                                           "22329",
	"org.postgresql.test.xa.XADataSourceTest.testRollbackWithoutPrepare":                                                                                                       "22329",
	"org.postgresql.test.xa.XADataSourceTest.testTwoPhaseCommit":                                                                                                               "22329",
	"org.postgresql.test.xa.XADataSourceTest.testWrapperEquals":                                                                                                                "22329",
}

var pgjdbcBlockList20_1 = blocklist{
	"org.postgresql.jdbc.DeepBatchedInsertStatementTest.testDeepInternalsBatchedQueryDecorator": "26508",
	"org.postgresql.jdbc.DeepBatchedInsertStatementTest.testUnspecifiedParameterType":           "26508",
	"org.postgresql.jdbc.DeepBatchedInsertStatementTest.testVaryingTypeCounts":                  "26508",
	"org.postgresql.jdbc.PgSQLXMLTest.setCharacterStream":                                       "43355",
	"org.postgresql.test.core.OptionsPropertyTest.testOptionsInProperties":                      "26443",
	"org.postgresql.test.jdbc2.ArrayTest.testEscaping[binary = FORCE]":                          "32552",
	"org.postgresql.test.jdbc2.ArrayTest.testEscaping[binary = REGULAR]":                        "32552",
	"org.postgresql.test.jdbc2.ArrayTest.testMultiDimensionalArray[binary = FORCE]":             "32552",
	"org.postgresql.test.jdbc2.ArrayTest.testMultiDimensionalArray[binary = REGULAR]":           "32552",
	"org.postgresql.test.jdbc2.ArrayTest.testNonStandardBounds[binary = FORCE]":                 "41405",
	"org.postgresql.test.jdbc2.ArrayTest.testNonStandardBounds[binary = REGULAR]":               "41405",
	"org.postgresql.test.jdbc2.ArrayTest.testNonStandardDelimiter[binary = FORCE]":              "21286",
	"org.postgresql.test.jdbc2.ArrayTest.testNonStandardDelimiter[binary = REGULAR]":            "21286",
	"org.postgresql.test.jdbc2.ArrayTest.testNullValues[binary = FORCE]":                        "26925",
	"org.postgresql.test.jdbc2.ArrayTest.testNullValues[binary = REGULAR]":                      "26925",
	"org.postgresql.test.jdbc2.ArrayTest.testRecursiveResultSets[binary = FORCE]":               "32552",
	"org.postgresql.test.jdbc2.ArrayTest.testRecursiveResultSets[binary = REGULAR]":             "32552",
	"org.postgresql.test.jdbc2.ArrayTest.testRetrieveArrays[binary = FORCE]":                    "41405",
	"org.postgresql.test.jdbc2.ArrayTest.testRetrieveArrays[binary = REGULAR]":                  "41405",
	"org.postgresql.test.jdbc2.ArrayTest.testRetrieveResultSets[binary = FORCE]":                "41405",
	"org.postgresql.test.jdbc2.ArrayTest.testRetrieveResultSets[binary = REGULAR]":              "41405",
	"org.postgresql.test.jdbc2.ArrayTest.testSetArray[binary = FORCE]":                          "26925",
	"org.postgresql.test.jdbc2.ArrayTest.testSetArray[binary = REGULAR]":                        "26925",
	"org.postgresql.test.jdbc2.ArrayTest.testSetPrimitiveArraysObjects[binary = FORCE]":         "26925",
	"org.postgresql.test.jdbc2.ArrayTest.testSetPrimitiveArraysObjects[binary = REGULAR]":       "26925",
	"org.postgresql.test.jdbc2.ArrayTest.testSetPrimitiveObjects[binary = FORCE]":               "26925",
	"org.postgresql.test.jdbc2.ArrayTest.testSetPrimitiveObjects[binary = REGULAR]":             "26925",
	"org.postgresql.test.jdbc2.ArrayTest.testWriteMultiDimensional[binary = FORCE]":             "32552",
	"org.postgresql.test.jdbc2.ArrayTest.testWriteMultiDimensional[binary = REGULAR]":           "32552",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[100: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                               "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[101: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                                "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[102: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":                   "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[103: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":                    "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[13: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=YES, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                                "41445",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[144: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                        "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[145: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                         "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[146: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":            "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[147: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":             "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[148: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                       "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[149: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                        "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[150: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[151: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":            "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[152: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                      "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[153: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                       "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[154: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":          "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[155: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[156: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                         "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[157: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                          "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[158: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":             "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[159: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":              "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[15: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=YES, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":                    "41445",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[160: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                        "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[161: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                         "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[162: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":            "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[163: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":             "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[177: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=YES, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                              "41445",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[179: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=YES, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":                  "41445",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[228: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                      "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[229: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                       "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[230: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":          "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[231: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[232: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                    "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[233: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                     "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[234: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":        "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[235: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":         "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[236: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                      "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[237: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                       "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[238: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":          "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[239: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[260: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                               "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[261: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                                "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[262: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":                   "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[263: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":                    "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[264: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                              "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[265: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                               "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[266: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":                  "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[267: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":                   "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[308: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                       "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[309: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                        "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[310: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[311: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":            "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[312: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                      "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[313: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                       "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[314: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":          "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[315: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[316: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                     "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[317: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                      "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[318: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":         "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[319: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":          "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[320: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                        "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[321: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                         "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[322: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":            "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[323: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":             "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[324: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                       "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[325: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                        "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[326: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[327: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":            "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[341: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                              "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[343: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":                  "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[348: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=DEALLOCATE, continueMode=COMMIT, flushOnDeallocate=false, hastransaction=false, sql=SELECT, columns=EXACT)]":                       "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[349: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=DEALLOCATE, continueMode=COMMIT, flushOnDeallocate=false, hastransaction=false, sql=SELECT, columns=STAR)]":                        "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[350: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=DEALLOCATE, continueMode=COMMIT, flushOnDeallocate=false, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[351: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=DEALLOCATE, continueMode=COMMIT, flushOnDeallocate=false, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":            "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[368: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=DISCARD, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[369: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=DISCARD, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                            "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[370: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=DISCARD, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":               "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[371: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=DISCARD, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":                "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[372: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=DISCARD, continueMode=COMMIT, flushOnDeallocate=false, hastransaction=false, sql=SELECT, columns=EXACT)]":                          "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[373: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=DISCARD, continueMode=COMMIT, flushOnDeallocate=false, hastransaction=false, sql=SELECT, columns=STAR)]":                           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[374: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=DISCARD, continueMode=COMMIT, flushOnDeallocate=false, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":              "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[375: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=DISCARD, continueMode=COMMIT, flushOnDeallocate=false, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":               "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[392: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                      "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[393: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                       "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[394: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":          "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[395: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[396: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                    "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[397: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                     "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[398: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":        "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[399: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":         "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[400: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                      "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[401: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                       "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[402: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":          "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[403: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[424: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                               "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[425: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                                "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[426: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":                   "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[427: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":                    "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[428: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                              "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[429: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                               "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[430: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":                  "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[431: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":                   "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[472: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                       "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[473: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                        "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[474: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[475: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":            "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[476: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                      "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[477: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                       "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[478: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":          "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[479: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[480: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                     "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[481: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                      "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[482: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":         "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[483: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":          "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[484: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                        "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[485: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                         "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[486: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":            "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[487: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":             "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[488: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                       "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[489: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                        "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[490: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[491: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":            "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[505: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                             "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[507: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":                 "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[512: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=DEALLOCATE, continueMode=COMMIT, flushOnDeallocate=false, hastransaction=false, sql=SELECT, columns=EXACT)]":                      "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[513: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=DEALLOCATE, continueMode=COMMIT, flushOnDeallocate=false, hastransaction=false, sql=SELECT, columns=STAR)]":                       "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[514: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=DEALLOCATE, continueMode=COMMIT, flushOnDeallocate=false, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":          "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[515: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=DEALLOCATE, continueMode=COMMIT, flushOnDeallocate=false, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[532: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=DISCARD, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                          "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[533: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=DISCARD, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[534: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=DISCARD, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":              "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[535: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=DISCARD, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":               "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[536: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=DISCARD, continueMode=COMMIT, flushOnDeallocate=false, hastransaction=false, sql=SELECT, columns=EXACT)]":                         "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[537: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=DISCARD, continueMode=COMMIT, flushOnDeallocate=false, hastransaction=false, sql=SELECT, columns=STAR)]":                          "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[538: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=DISCARD, continueMode=COMMIT, flushOnDeallocate=false, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":             "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[539: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=DISCARD, continueMode=COMMIT, flushOnDeallocate=false, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":              "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[556: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                     "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[557: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                      "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[558: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":         "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[559: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":          "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[560: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                   "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[561: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                    "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[562: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":       "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[563: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":        "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[564: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                     "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[565: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                      "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[566: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":         "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[567: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":          "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[588: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                              "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[589: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                               "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[590: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":                  "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[591: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":                   "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[592: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                             "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[593: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                              "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[594: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":                 "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[595: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":                  "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[636: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                      "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[637: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                       "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[638: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":          "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[639: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[640: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                     "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[641: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                      "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[642: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":         "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[643: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":          "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[644: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                    "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[645: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                     "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[646: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":        "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[647: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":         "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[648: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                       "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[649: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                        "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[64: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                        "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[650: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[651: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":            "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[652: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                      "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[653: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                       "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[654: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":          "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[655: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[65: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                         "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[669: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=YES, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                        "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[66: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":            "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[671: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=YES, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":            "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[67: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":             "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[68: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                      "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[69: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                       "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[70: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":          "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[71: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[720: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[721: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                 "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[722: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":    "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[723: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":     "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[724: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":              "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[725: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":               "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[726: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":  "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[727: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":   "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[728: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[729: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                 "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[72: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                        "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[730: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":    "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[731: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":     "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[73: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                         "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[74: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":            "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[752: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                         "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[753: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                          "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[754: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":             "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[755: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":              "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[756: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                        "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[757: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                         "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[758: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":            "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[759: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":             "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[75: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":             "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[800: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                 "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[801: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                  "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[802: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":     "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[803: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":      "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[804: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[805: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                 "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[806: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":    "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[807: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":     "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[808: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":               "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[809: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[810: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":   "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[811: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":    "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[812: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                  "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[813: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                   "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[814: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":      "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[815: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":       "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[816: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                 "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[817: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                  "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[818: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":     "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[819: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":      "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[833: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=YES, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                       "41445",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[835: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=YES, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":           "41445",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[884: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":               "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[885: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[886: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":   "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[887: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":    "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[888: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":             "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[889: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":              "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[890: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]": "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[891: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":  "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[892: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":               "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[893: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[894: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":   "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[895: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":    "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[916: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                        "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[917: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                         "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[918: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":            "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[919: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":             "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[920: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                       "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[921: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                        "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[922: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":           "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[923: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":            "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[964: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[965: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                 "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[966: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":    "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[967: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":     "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[968: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":               "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[969: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[96: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                                 "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[970: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":   "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[971: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":    "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[972: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":              "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[973: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":               "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[974: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":  "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[975: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":   "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[976: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                 "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[977: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                  "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[978: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":     "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[979: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":      "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[97: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                                  "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[980: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[981: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                 "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[982: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":    "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[983: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":     "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[98: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":                     "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[99: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":                      "26508",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithAlternatingTypes[binary = FORCE, insertRewrite = false]":                                                                                                                                                        "41513",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithAlternatingTypes[binary = FORCE, insertRewrite = true]":                                                                                                                                                         "41513",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithAlternatingTypes[binary = REGULAR, insertRewrite = false]":                                                                                                                                                      "41513",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithAlternatingTypes[binary = REGULAR, insertRewrite = true]":                                                                                                                                                       "41513",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithEmbeddedNulls[binary = FORCE, insertRewrite = false]":                                                                                                                                                           "26366",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithEmbeddedNulls[binary = FORCE, insertRewrite = true]":                                                                                                                                                            "26366",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithEmbeddedNulls[binary = REGULAR, insertRewrite = false]":                                                                                                                                                         "26366",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithEmbeddedNulls[binary = REGULAR, insertRewrite = true]":                                                                                                                                                          "26366",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testMixedBatch[binary = FORCE, insertRewrite = false]":                                                                                                                                                                       "31463",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testMixedBatch[binary = FORCE, insertRewrite = true]":                                                                                                                                                                        "31463",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testMixedBatch[binary = REGULAR, insertRewrite = false]":                                                                                                                                                                     "31463",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testMixedBatch[binary = REGULAR, insertRewrite = true]":                                                                                                                                                                      "31463",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testSelectInBatchThrowsAutoCommit[binary = FORCE, insertRewrite = false]":                                                                                                                                                    "44803",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testSelectInBatchThrowsAutoCommit[binary = FORCE, insertRewrite = true]":                                                                                                                                                     "44803",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testSelectInBatchThrowsAutoCommit[binary = REGULAR, insertRewrite = false]":                                                                                                                                                  "44803",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testSelectInBatchThrowsAutoCommit[binary = REGULAR, insertRewrite = true]":                                                                                                                                                   "44803",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testSelectInBatch[binary = FORCE, insertRewrite = false]":                                                                                                                                                                    "40195",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testSelectInBatch[binary = FORCE, insertRewrite = true]":                                                                                                                                                                     "40195",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testSelectInBatch[binary = REGULAR, insertRewrite = false]":                                                                                                                                                                  "40195",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testSelectInBatch[binary = REGULAR, insertRewrite = true]":                                                                                                                                                                   "40195",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testSmallBatchUpdateFailureSimple[binary = FORCE, insertRewrite = false]":                                                                                                                                                    "44803",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testSmallBatchUpdateFailureSimple[binary = REGULAR, insertRewrite = false]":                                                                                                                                                  "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[105: batchTest(mode=FAIL_VIA_DUP_KEY, position=SECOND_ROW, autoCommit=YES, batchType=PREPARED, generateKeys=YES, binary=REGULAR, insertRewrite=false)]":                                                                  "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[107: batchTest(mode=FAIL_VIA_DUP_KEY, position=SECOND_ROW, autoCommit=YES, batchType=PREPARED, generateKeys=YES, binary=FORCE, insertRewrite=false)]":                                                                    "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[112: batchTest(mode=FAIL_VIA_DUP_KEY, position=MIDDLE, autoCommit=YES, batchType=PREPARED, generateKeys=YES, binary=REGULAR, insertRewrite=true)]":                                                                       "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[113: batchTest(mode=FAIL_VIA_DUP_KEY, position=MIDDLE, autoCommit=YES, batchType=PREPARED, generateKeys=YES, binary=REGULAR, insertRewrite=false)]":                                                                      "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[114: batchTest(mode=FAIL_VIA_DUP_KEY, position=MIDDLE, autoCommit=YES, batchType=PREPARED, generateKeys=YES, binary=FORCE, insertRewrite=true)]":                                                                         "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[115: batchTest(mode=FAIL_VIA_DUP_KEY, position=MIDDLE, autoCommit=YES, batchType=PREPARED, generateKeys=YES, binary=FORCE, insertRewrite=false)]":                                                                        "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[120: batchTest(mode=FAIL_VIA_DUP_KEY, position=ALMOST_LAST_ROW, autoCommit=YES, batchType=PREPARED, generateKeys=YES, binary=REGULAR, insertRewrite=true)]":                                                              "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[121: batchTest(mode=FAIL_VIA_DUP_KEY, position=ALMOST_LAST_ROW, autoCommit=YES, batchType=PREPARED, generateKeys=YES, binary=REGULAR, insertRewrite=false)]":                                                             "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[122: batchTest(mode=FAIL_VIA_DUP_KEY, position=ALMOST_LAST_ROW, autoCommit=YES, batchType=PREPARED, generateKeys=YES, binary=FORCE, insertRewrite=true)]":                                                                "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[123: batchTest(mode=FAIL_VIA_DUP_KEY, position=ALMOST_LAST_ROW, autoCommit=YES, batchType=PREPARED, generateKeys=YES, binary=FORCE, insertRewrite=false)]":                                                               "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[128: batchTest(mode=FAIL_VIA_DUP_KEY, position=LAST_ROW, autoCommit=YES, batchType=PREPARED, generateKeys=YES, binary=REGULAR, insertRewrite=true)]":                                                                     "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[129: batchTest(mode=FAIL_VIA_DUP_KEY, position=LAST_ROW, autoCommit=YES, batchType=PREPARED, generateKeys=YES, binary=REGULAR, insertRewrite=false)]":                                                                    "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[130: batchTest(mode=FAIL_VIA_DUP_KEY, position=LAST_ROW, autoCommit=YES, batchType=PREPARED, generateKeys=YES, binary=FORCE, insertRewrite=true)]":                                                                       "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[131: batchTest(mode=FAIL_VIA_DUP_KEY, position=LAST_ROW, autoCommit=YES, batchType=PREPARED, generateKeys=YES, binary=FORCE, insertRewrite=false)]":                                                                      "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[16: batchTest(mode=FAIL_VIA_SELECT_PARSE, position=SECOND_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=REGULAR, insertRewrite=true)]":                                                                 "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[17: batchTest(mode=FAIL_VIA_SELECT_PARSE, position=SECOND_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=REGULAR, insertRewrite=false)]":                                                                "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[18: batchTest(mode=FAIL_VIA_SELECT_PARSE, position=SECOND_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=FORCE, insertRewrite=true)]":                                                                   "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[19: batchTest(mode=FAIL_VIA_SELECT_PARSE, position=SECOND_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=FORCE, insertRewrite=false)]":                                                                  "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[24: batchTest(mode=FAIL_VIA_SELECT_PARSE, position=MIDDLE, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=REGULAR, insertRewrite=true)]":                                                                     "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[25: batchTest(mode=FAIL_VIA_SELECT_PARSE, position=MIDDLE, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=REGULAR, insertRewrite=false)]":                                                                    "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[26: batchTest(mode=FAIL_VIA_SELECT_PARSE, position=MIDDLE, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=FORCE, insertRewrite=true)]":                                                                       "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[27: batchTest(mode=FAIL_VIA_SELECT_PARSE, position=MIDDLE, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=FORCE, insertRewrite=false)]":                                                                      "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[32: batchTest(mode=FAIL_VIA_SELECT_PARSE, position=ALMOST_LAST_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=REGULAR, insertRewrite=true)]":                                                            "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[33: batchTest(mode=FAIL_VIA_SELECT_PARSE, position=ALMOST_LAST_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=REGULAR, insertRewrite=false)]":                                                           "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[34: batchTest(mode=FAIL_VIA_SELECT_PARSE, position=ALMOST_LAST_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=FORCE, insertRewrite=true)]":                                                              "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[35: batchTest(mode=FAIL_VIA_SELECT_PARSE, position=ALMOST_LAST_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=FORCE, insertRewrite=false)]":                                                             "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[40: batchTest(mode=FAIL_VIA_SELECT_PARSE, position=LAST_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=REGULAR, insertRewrite=true)]":                                                                   "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[41: batchTest(mode=FAIL_VIA_SELECT_PARSE, position=LAST_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=REGULAR, insertRewrite=false)]":                                                                  "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[42: batchTest(mode=FAIL_VIA_SELECT_PARSE, position=LAST_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=FORCE, insertRewrite=true)]":                                                                     "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[43: batchTest(mode=FAIL_VIA_SELECT_PARSE, position=LAST_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=FORCE, insertRewrite=false)]":                                                                    "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[56: batchTest(mode=FAIL_VIA_SELECT_RUNTIME, position=SECOND_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=REGULAR, insertRewrite=true)]":                                                               "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[57: batchTest(mode=FAIL_VIA_SELECT_RUNTIME, position=SECOND_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=REGULAR, insertRewrite=false)]":                                                              "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[58: batchTest(mode=FAIL_VIA_SELECT_RUNTIME, position=SECOND_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=FORCE, insertRewrite=true)]":                                                                 "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[59: batchTest(mode=FAIL_VIA_SELECT_RUNTIME, position=SECOND_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=FORCE, insertRewrite=false)]":                                                                "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[64: batchTest(mode=FAIL_VIA_SELECT_RUNTIME, position=MIDDLE, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=REGULAR, insertRewrite=true)]":                                                                   "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[65: batchTest(mode=FAIL_VIA_SELECT_RUNTIME, position=MIDDLE, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=REGULAR, insertRewrite=false)]":                                                                  "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[66: batchTest(mode=FAIL_VIA_SELECT_RUNTIME, position=MIDDLE, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=FORCE, insertRewrite=true)]":                                                                     "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[67: batchTest(mode=FAIL_VIA_SELECT_RUNTIME, position=MIDDLE, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=FORCE, insertRewrite=false)]":                                                                    "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[72: batchTest(mode=FAIL_VIA_SELECT_RUNTIME, position=ALMOST_LAST_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=REGULAR, insertRewrite=true)]":                                                          "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[73: batchTest(mode=FAIL_VIA_SELECT_RUNTIME, position=ALMOST_LAST_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=REGULAR, insertRewrite=false)]":                                                         "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[74: batchTest(mode=FAIL_VIA_SELECT_RUNTIME, position=ALMOST_LAST_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=FORCE, insertRewrite=true)]":                                                            "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[75: batchTest(mode=FAIL_VIA_SELECT_RUNTIME, position=ALMOST_LAST_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=FORCE, insertRewrite=false)]":                                                           "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[80: batchTest(mode=FAIL_VIA_SELECT_RUNTIME, position=LAST_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=REGULAR, insertRewrite=true)]":                                                                 "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[81: batchTest(mode=FAIL_VIA_SELECT_RUNTIME, position=LAST_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=REGULAR, insertRewrite=false)]":                                                                "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[82: batchTest(mode=FAIL_VIA_SELECT_RUNTIME, position=LAST_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=FORCE, insertRewrite=true)]":                                                                   "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[83: batchTest(mode=FAIL_VIA_SELECT_RUNTIME, position=LAST_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=FORCE, insertRewrite=false)]":                                                                  "44803",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.test17000Binds[2: autoCommit=NO, binary=REGULAR]":                                                                                                                                                             "26508",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.test17000Binds[3: autoCommit=NO, binary=FORCE]":                                                                                                                                                               "26508",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.test32000Binds[2: autoCommit=NO, binary=REGULAR]":                                                                                                                                                             "26508",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.test32000Binds[3: autoCommit=NO, binary=FORCE]":                                                                                                                                                               "26508",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.testBatchWithReWrittenBatchStatementWithFixedParameter[2: autoCommit=NO, binary=REGULAR]":                                                                                                                     "26508",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.testBatchWithReWrittenBatchStatementWithFixedParameter[3: autoCommit=NO, binary=FORCE]":                                                                                                                       "26508",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.testBatchWithReWrittenBatchStatementWithFixedParametersOnly[2: autoCommit=NO, binary=REGULAR]":                                                                                                                "26508",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.testBatchWithReWrittenBatchStatementWithFixedParametersOnly[3: autoCommit=NO, binary=FORCE]":                                                                                                                  "26508",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.testBatchWithReWrittenRepeatedInsertStatementOptimizationEnabled[2: autoCommit=NO, binary=REGULAR]":                                                                                                           "26508",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.testBatchWithReWrittenRepeatedInsertStatementOptimizationEnabled[3: autoCommit=NO, binary=FORCE]":                                                                                                             "26508",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.testBindsInNestedParens[2: autoCommit=NO, binary=REGULAR]":                                                                                                                                                    "26508",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.testBindsInNestedParens[3: autoCommit=NO, binary=FORCE]":                                                                                                                                                      "26508",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.testConsistentOutcome[2: autoCommit=NO, binary=REGULAR]":                                                                                                                                                      "26508",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.testConsistentOutcome[3: autoCommit=NO, binary=FORCE]":                                                                                                                                                        "26508",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.testINSERTwithNamedColumnsNotBroken[2: autoCommit=NO, binary=REGULAR]":                                                                                                                                        "26508",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.testINSERTwithNamedColumnsNotBroken[3: autoCommit=NO, binary=FORCE]":                                                                                                                                          "26508",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.testMixedCaseInSeRtStatement[2: autoCommit=NO, binary=REGULAR]":                                                                                                                                               "26508",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.testMixedCaseInSeRtStatement[3: autoCommit=NO, binary=FORCE]":                                                                                                                                                 "26508",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.testMultiValues1bind[2: autoCommit=NO, binary=REGULAR]":                                                                                                                                                       "26508",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.testMultiValues1bind[3: autoCommit=NO, binary=FORCE]":                                                                                                                                                         "26508",
	"org.postgresql.test.jdbc2.BlobTest.testGetBytesOffset":                                                                                                                    "26725",
	"org.postgresql.test.jdbc2.BlobTest.testLargeLargeObject":                                                                                                                  "26725",
	"org.postgresql.test.jdbc2.BlobTest.testMarkResetStream":                                                                                                                   "26725",
	"org.postgresql.test.jdbc2.BlobTest.testMultipleStreams":                                                                                                                   "26725",
	"org.postgresql.test.jdbc2.BlobTest.testParallelStreams":                                                                                                                   "26725",
	"org.postgresql.test.jdbc2.BlobTest.testSet":                                                                                                                               "26725",
	"org.postgresql.test.jdbc2.BlobTest.testSetNull":                                                                                                                           "26725",
	"org.postgresql.test.jdbc2.BlobTest.testUploadBlob_LOOP":                                                                                                                   "26725",
	"org.postgresql.test.jdbc2.BlobTest.testUploadBlob_NATIVE":                                                                                                                 "26725",
	"org.postgresql.test.jdbc2.BlobTransactionTest.testConcurrentReplace":                                                                                                      "17511",
	"org.postgresql.test.jdbc2.CallableStmtTest.testBadStmt":                                                                                                                   "17511",
	"org.postgresql.test.jdbc2.CallableStmtTest.testBatchCall":                                                                                                                 "17511",
	"org.postgresql.test.jdbc2.CallableStmtTest.testFetchBeforeExecute":                                                                                                        "17511",
	"org.postgresql.test.jdbc2.CallableStmtTest.testFetchWithNoResults":                                                                                                        "17511",
	"org.postgresql.test.jdbc2.CallableStmtTest.testGetArray":                                                                                                                  "17511",
	"org.postgresql.test.jdbc2.CallableStmtTest.testGetDouble":                                                                                                                 "17511",
	"org.postgresql.test.jdbc2.CallableStmtTest.testGetInt":                                                                                                                    "17511",
	"org.postgresql.test.jdbc2.CallableStmtTest.testGetNumeric":                                                                                                                "17511",
	"org.postgresql.test.jdbc2.CallableStmtTest.testGetNumericWithoutArg":                                                                                                      "17511",
	"org.postgresql.test.jdbc2.CallableStmtTest.testGetShort":                                                                                                                  "17511",
	"org.postgresql.test.jdbc2.CallableStmtTest.testGetString":                                                                                                                 "17511",
	"org.postgresql.test.jdbc2.CallableStmtTest.testGetUpdateCount":                                                                                                            "17511",
	"org.postgresql.test.jdbc2.CallableStmtTest.testRaiseNotice":                                                                                                               "17511",
	"org.postgresql.test.jdbc2.CallableStmtTest.testWasNullBeforeFetch":                                                                                                        "17511",
	"org.postgresql.test.jdbc2.ClientEncodingTest.setEncodingAscii[allowEncodingChanges=false]":                                                                                "37129",
	"org.postgresql.test.jdbc2.ClientEncodingTest.setEncodingAscii[allowEncodingChanges=true]":                                                                                 "37129",
	"org.postgresql.test.jdbc2.ConcurrentStatementFetch.testFetchTwoStatements[6: fetch(autoCommit=NO, fetchSize=1, binaryMode=REGULAR)]":                                      "4035",
	"org.postgresql.test.jdbc2.ConcurrentStatementFetch.testFetchTwoStatements[7: fetch(autoCommit=NO, fetchSize=1, binaryMode=FORCE)]":                                        "4035",
	"org.postgresql.test.jdbc2.ConcurrentStatementFetch.testFetchTwoStatements[8: fetch(autoCommit=NO, fetchSize=2, binaryMode=REGULAR)]":                                      "4035",
	"org.postgresql.test.jdbc2.ConcurrentStatementFetch.testFetchTwoStatements[9: fetch(autoCommit=NO, fetchSize=2, binaryMode=FORCE)]":                                        "4035",
	"org.postgresql.test.jdbc2.ConnectionTest.testCreateStatement":                                                                                                             "41578",
	"org.postgresql.test.jdbc2.ConnectionTest.testDoubleClose":                                                                                                                 "41578",
	"org.postgresql.test.jdbc2.ConnectionTest.testIsClosed":                                                                                                                    "41578",
	"org.postgresql.test.jdbc2.ConnectionTest.testNativeSQL":                                                                                                                   "41578",
	"org.postgresql.test.jdbc2.ConnectionTest.testPrepareCall":                                                                                                                 "41578",
	"org.postgresql.test.jdbc2.ConnectionTest.testPrepareStatement":                                                                                                            "41578",
	"org.postgresql.test.jdbc2.ConnectionTest.testReadOnly_always":                                                                                                             "41578",
	"org.postgresql.test.jdbc2.ConnectionTest.testReadOnly_ignore":                                                                                                             "41578",
	"org.postgresql.test.jdbc2.ConnectionTest.testReadOnly_transaction":                                                                                                        "41578",
	"org.postgresql.test.jdbc2.ConnectionTest.testTransactionIsolation":                                                                                                        "41578",
	"org.postgresql.test.jdbc2.ConnectionTest.testTransactions":                                                                                                                "41578",
	"org.postgresql.test.jdbc2.ConnectionTest.testTypeMaps":                                                                                                                    "41578",
	"org.postgresql.test.jdbc2.ConnectionTest.testWarnings":                                                                                                                    "41578",
	"org.postgresql.test.jdbc2.CopyTest.testChangeDateStyle":                                                                                                                   "41608",
	"org.postgresql.test.jdbc2.CopyTest.testCopyOut":                                                                                                                           "41608",
	"org.postgresql.test.jdbc2.CopyTest.testCopyOutByRow":                                                                                                                      "41608",
	"org.postgresql.test.jdbc2.CopyTest.testCopyQuery":                                                                                                                         "41608",
	"org.postgresql.test.jdbc2.CopyTest.testLockReleaseOnCancelFailure":                                                                                                        "41608",
	"org.postgresql.test.jdbc2.CursorFetchTest.testMultistatement[binary = FORCE]":                                                                                             "40195",
	"org.postgresql.test.jdbc2.CursorFetchTest.testMultistatement[binary = REGULAR]":                                                                                           "40195",
	"org.postgresql.test.jdbc2.DatabaseEncodingTest.testEncoding":                                                                                                              "41771",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testArrayInt4DoubleDim":                                                                                                    "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testArrayTypeInfo":                                                                                                         "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testAscDescIndexInfo":                                                                                                      "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testBestRowIdentifier":                                                                                                     "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testCatalogs":                                                                                                              "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testColumnPrivileges":                                                                                                      "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testColumns":                                                                                                               "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testCrossReference":                                                                                                        "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testCustomArrayTypeInfo":                                                                                                   "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testDomainColumnSize":                                                                                                      "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testDroppedColumns":                                                                                                        "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testEscaping":                                                                                                              "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testForeignKeyActions":                                                                                                     "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testForeignKeys":                                                                                                           "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testForeignKeysToUniqueIndexes":                                                                                            "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testFuncReturningComposite":                                                                                                "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testFuncReturningTable":                                                                                                    "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testFuncWithDirection":                                                                                                     "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testFuncWithNames":                                                                                                         "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testFuncWithoutNames":                                                                                                      "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testFunctionColumns":                                                                                                       "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testGetSQLKeywords":                                                                                                        "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testGetUDT1":                                                                                                               "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testGetUDT2":                                                                                                               "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testGetUDT3":                                                                                                               "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testGetUDT4":                                                                                                               "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testGetUDTQualified":                                                                                                       "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testIdentityColumns":                                                                                                       "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testIndexInfo":                                                                                                             "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testInformationAboutArrayTypes":                                                                                            "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testMultiColumnForeignKeys":                                                                                                "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testNoTablePrivileges":                                                                                                     "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testNotNullDomainColumn":                                                                                                   "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testPartialIndexInfo":                                                                                                      "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testPartitionedTables":                                                                                                     "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testPrimaryKeys":                                                                                                           "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testProcedures":                                                                                                            "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testSameTableForeignKeys":                                                                                                  "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testSchemas":                                                                                                               "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testSearchStringEscape":                                                                                                    "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testSerialColumns":                                                                                                         "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testTablePrivileges":                                                                                                       "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testTableTypes":                                                                                                            "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testTables":                                                                                                                "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testTypeInfoQuoting":                                                                                                       "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testTypeInfoSigned":                                                                                                        "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testTypes":                                                                                                                 "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testVersionColumns":                                                                                                        "17511",
	"org.postgresql.test.jdbc2.DateStyleTest.conenct[dateStyle=ISO,ymd, shouldPass=true]":                                                                                      "41773",
	"org.postgresql.test.jdbc2.DateStyleTest.conenct[dateStyle=PostgreSQL, shouldPass=false]":                                                                                  "41773",
	"org.postgresql.test.jdbc2.GeometricTest.testPGbox[binary = FORCE]":                                                                                                        "21286",
	"org.postgresql.test.jdbc2.GeometricTest.testPGbox[binary = REGULAR]":                                                                                                      "21286",
	"org.postgresql.test.jdbc2.GeometricTest.testPGcircle[binary = FORCE]":                                                                                                     "21286",
	"org.postgresql.test.jdbc2.GeometricTest.testPGcircle[binary = REGULAR]":                                                                                                   "21286",
	"org.postgresql.test.jdbc2.GeometricTest.testPGline[binary = FORCE]":                                                                                                       "21286",
	"org.postgresql.test.jdbc2.GeometricTest.testPGline[binary = REGULAR]":                                                                                                     "21286",
	"org.postgresql.test.jdbc2.GeometricTest.testPGlseg[binary = FORCE]":                                                                                                       "21286",
	"org.postgresql.test.jdbc2.GeometricTest.testPGlseg[binary = REGULAR]":                                                                                                     "21286",
	"org.postgresql.test.jdbc2.GeometricTest.testPGpath[binary = FORCE]":                                                                                                       "21286",
	"org.postgresql.test.jdbc2.GeometricTest.testPGpath[binary = REGULAR]":                                                                                                     "21286",
	"org.postgresql.test.jdbc2.GeometricTest.testPGpoint[binary = FORCE]":                                                                                                      "21286",
	"org.postgresql.test.jdbc2.GeometricTest.testPGpoint[binary = REGULAR]":                                                                                                    "21286",
	"org.postgresql.test.jdbc2.GeometricTest.testPGpolygon[binary = FORCE]":                                                                                                    "21286",
	"org.postgresql.test.jdbc2.GeometricTest.testPGpolygon[binary = REGULAR]":                                                                                                  "21286",
	"org.postgresql.test.jdbc2.JBuilderTest.testMoney":                                                                                                                         "41578",
	"org.postgresql.test.jdbc2.NotifyTest.testAsyncNotify":                                                                                                                     "41522",
	"org.postgresql.test.jdbc2.NotifyTest.testAsyncNotifyWithEndlessTimeoutAndMessagesAvailableWhenStartingListening":                                                          "41522",
	"org.postgresql.test.jdbc2.NotifyTest.testAsyncNotifyWithEndlessTimeoutAndMessagesSendAfter":                                                                               "41522",
	"org.postgresql.test.jdbc2.NotifyTest.testAsyncNotifyWithTimeout":                                                                                                          "41522",
	"org.postgresql.test.jdbc2.NotifyTest.testAsyncNotifyWithTimeoutAndMessagesAvailableWhenStartingListening":                                                                 "41522",
	"org.postgresql.test.jdbc2.NotifyTest.testAsyncNotifyWithTimeoutAndMessagesSendAfter":                                                                                      "41522",
	"org.postgresql.test.jdbc2.NotifyTest.testAsyncNotifyWithTimeoutAndSocketThatBecomesClosed":                                                                                "41522",
	"org.postgresql.test.jdbc2.NotifyTest.testNotify":                                                                                                                          "41522",
	"org.postgresql.test.jdbc2.NotifyTest.testNotifyArgument":                                                                                                                  "41522",
	"org.postgresql.test.jdbc2.PGTimeTest.testTimeInsertAndSelect":                                                                                                             "41775",
	"org.postgresql.test.jdbc2.PGTimestampTest.testTimeInsertAndSelect":                                                                                                        "41775",
	"org.postgresql.test.jdbc2.ParameterStatusTest.transactionalParametersAutocommit":                                                                                          "32562",
	"org.postgresql.test.jdbc2.ParameterStatusTest.transactionalParametersCommit":                                                                                              "32562",
	"org.postgresql.test.jdbc2.ParameterStatusTest.transactionalParametersRollback":                                                                                            "32562",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testBatchWithPrepareThreshold5[binary = REGULAR]":                                                                         "5807",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testDollarQuotes[binary = FORCE]":                                                                                         "41777",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testDollarQuotes[binary = REGULAR]":                                                                                       "41777",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testDoubleQuestionMark[binary = FORCE]":                                                                                   "21286",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testDoubleQuestionMark[binary = REGULAR]":                                                                                 "21286",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testSingleQuotes[binary = FORCE]":                                                                                         "36215",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testSingleQuotes[binary = REGULAR]":                                                                                       "36215",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testUnknownSetObject[binary = FORCE]":                                                                                     "41779",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testUnknownSetObject[binary = REGULAR]":                                                                                   "41779",
	"org.postgresql.test.jdbc2.RefCursorTest.testEmptyResult[typeName = OTHER, cursorType = 1,111]":                                                                            "17511",
	"org.postgresql.test.jdbc2.RefCursorTest.testEmptyResult[typeName = REF_CURSOR, cursorType = 2,012]":                                                                       "17511",
	"org.postgresql.test.jdbc2.RefCursorTest.testMetaData[typeName = OTHER, cursorType = 1,111]":                                                                               "17511",
	"org.postgresql.test.jdbc2.RefCursorTest.testMetaData[typeName = REF_CURSOR, cursorType = 2,012]":                                                                          "17511",
	"org.postgresql.test.jdbc2.RefCursorTest.testResultType[typeName = OTHER, cursorType = 1,111]":                                                                             "17511",
	"org.postgresql.test.jdbc2.RefCursorTest.testResultType[typeName = REF_CURSOR, cursorType = 2,012]":                                                                        "17511",
	"org.postgresql.test.jdbc2.RefCursorTest.testResult[typeName = OTHER, cursorType = 1,111]":                                                                                 "17511",
	"org.postgresql.test.jdbc2.RefCursorTest.testResult[typeName = REF_CURSOR, cursorType = 2,012]":                                                                            "17511",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testCache[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = 0]":                                           "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testCache[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = null]":                                        "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testCache[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = 0]":                                        "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testCache[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = null]":                                     "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testClassesMatch[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = 0]":                                    "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testClassesMatch[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = null]":                                 "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testClassesMatch[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = 0]":                                 "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testClassesMatch[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = null]":                              "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testClosedResultSet[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = 0]":                                 "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testClosedResultSet[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = null]":                              "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testClosedResultSet[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = 0]":                              "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testClosedResultSet[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = null]":                           "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testColumnDisplaySize[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = 0]":                               "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testColumnDisplaySize[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = null]":                            "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testColumnDisplaySize[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = 0]":                            "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testColumnDisplaySize[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = null]":                         "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testComposite[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = 0]":                                       "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testComposite[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = null]":                                    "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testComposite[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = 0]":                                    "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testComposite[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = null]":                                 "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testDatabaseMetaDataNames[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = 0]":                           "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testDatabaseMetaDataNames[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = null]":                        "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testDatabaseMetaDataNames[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = 0]":                        "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testDatabaseMetaDataNames[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = null]":                     "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testIdentityColumn[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = 0]":                                  "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testIdentityColumn[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = null]":                               "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testIdentityColumn[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = 0]":                               "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testIdentityColumn[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = null]":                            "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testIsAutoIncrement[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = 0]":                                 "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testIsAutoIncrement[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = null]":                              "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testIsAutoIncrement[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = 0]":                              "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testIsAutoIncrement[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = null]":                           "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testPreparedResultSet[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = 0]":                               "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testPreparedResultSet[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = null]":                            "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testPreparedResultSet[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = 0]":                            "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testPreparedResultSet[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = null]":                         "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testPreparedUpdate[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = 0]":                                  "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testPreparedUpdate[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = null]":                               "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testPreparedUpdate[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = 0]":                               "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testPreparedUpdate[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = null]":                            "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testStandardResultSet[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = 0]":                               "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testStandardResultSet[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = null]":                            "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testStandardResultSet[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = 0]":                            "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testStandardResultSet[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = null]":                         "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testTimestampInfo[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = 0]":                                   "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testTimestampInfo[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = null]":                                "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testTimestampInfo[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = 0]":                                "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testTimestampInfo[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = null]":                             "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testUnexecutedStatement[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = 0]":                             "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testUnexecutedStatement[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = null]":                          "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testUnexecutedStatement[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = 0]":                          "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testUnexecutedStatement[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = null]":                       "32565",
	"org.postgresql.test.jdbc2.ResultSetTest.testUpdateWithPGobject":                                                                                                           "41781",
	"org.postgresql.test.jdbc2.ResultSetTest.testgetBadBoolean":                                                                                                                "32552",
	"org.postgresql.test.jdbc2.SearchPathLookupTest.testSearchPathBackwardsCompatibleLookup":                                                                                   "26443",
	"org.postgresql.test.jdbc2.SearchPathLookupTest.testSearchPathHiddenLookup":                                                                                                "26443",
	"org.postgresql.test.jdbc2.SearchPathLookupTest.testSearchPathNormalLookup":                                                                                                "26443",
	"org.postgresql.test.jdbc2.ServerCursorTest.testBasicFetch":                                                                                                                "41412",
	"org.postgresql.test.jdbc2.ServerCursorTest.testBinaryFetch":                                                                                                               "41412",
	"org.postgresql.test.jdbc2.ServerErrorTest.testColumn":                                                                                                                     "27796",
	"org.postgresql.test.jdbc2.ServerErrorTest.testDatatype":                                                                                                                   "27796",
	"org.postgresql.test.jdbc2.ServerErrorTest.testPrimaryKey":                                                                                                                 "27796",
	"org.postgresql.test.jdbc2.StatementTest.testClose":                                                                                                                        "17511",
	"org.postgresql.test.jdbc2.StatementTest.testCloseInProgressStatement":                                                                                                     "17511",
	"org.postgresql.test.jdbc2.StatementTest.testConcurrentWarningReadAndClear":                                                                                                "17511",
	"org.postgresql.test.jdbc2.StatementTest.testDateFuncWithParam":                                                                                                            "17511",
	"org.postgresql.test.jdbc2.StatementTest.testDateFunctions":                                                                                                                "17511",
	"org.postgresql.test.jdbc2.StatementTest.testDollarInComment":                                                                                                              "17511",
	"org.postgresql.test.jdbc2.StatementTest.testDollarInCommentTwoComments":                                                                                                   "17511",
	"org.postgresql.test.jdbc2.StatementTest.testDoubleClose":                                                                                                                  "17511",
	"org.postgresql.test.jdbc2.StatementTest.testEmptyQuery":                                                                                                                   "17511",
	"org.postgresql.test.jdbc2.StatementTest.testEscapeProcessing":                                                                                                             "17511",
	"org.postgresql.test.jdbc2.StatementTest.testExecuteUpdateFailsOnMultiStatementSelect":                                                                                     "17511",
	"org.postgresql.test.jdbc2.StatementTest.testExecuteUpdateFailsOnSelect":                                                                                                   "17511",
	"org.postgresql.test.jdbc2.StatementTest.testFastCloses":                                                                                                                   "17511",
	"org.postgresql.test.jdbc2.StatementTest.testJavascriptFunction":                                                                                                           "17511",
	"org.postgresql.test.jdbc2.StatementTest.testLongQueryTimeout":                                                                                                             "17511",
	"org.postgresql.test.jdbc2.StatementTest.testMultiExecute":                                                                                                                 "17511",
	"org.postgresql.test.jdbc2.StatementTest.testMultipleCancels":                                                                                                              "17511",
	"org.postgresql.test.jdbc2.StatementTest.testNumericFunctions":                                                                                                             "17511",
	"org.postgresql.test.jdbc2.StatementTest.testParsingDollarQuotes":                                                                                                          "17511",
	"org.postgresql.test.jdbc2.StatementTest.testParsingSemiColons":                                                                                                            "17511",
	"org.postgresql.test.jdbc2.StatementTest.testPreparedFunction":                                                                                                             "17511",
	"org.postgresql.test.jdbc2.StatementTest.testResultSetTwice":                                                                                                               "17511",
	"org.postgresql.test.jdbc2.StatementTest.testSetQueryTimeout":                                                                                                              "17511",
	"org.postgresql.test.jdbc2.StatementTest.testSetQueryTimeoutOnPrepared":                                                                                                    "17511",
	"org.postgresql.test.jdbc2.StatementTest.testSetQueryTimeoutWithSleep":                                                                                                     "17511",
	"org.postgresql.test.jdbc2.StatementTest.testSetQueryTimeoutWithoutExecute":                                                                                                "17511",
	"org.postgresql.test.jdbc2.StatementTest.testShortQueryTimeout":                                                                                                            "17511",
	"org.postgresql.test.jdbc2.StatementTest.testSideStatementFinalizers":                                                                                                      "17511",
	"org.postgresql.test.jdbc2.StatementTest.testStringFunctions":                                                                                                              "17511",
	"org.postgresql.test.jdbc2.StatementTest.testSystemFunctions":                                                                                                              "17511",
	"org.postgresql.test.jdbc2.StatementTest.testUnbalancedParensParseError":                                                                                                   "17511",
	"org.postgresql.test.jdbc2.StatementTest.testUnterminatedComment":                                                                                                          "17511",
	"org.postgresql.test.jdbc2.StatementTest.testUnterminatedDollarQuotes":                                                                                                     "17511",
	"org.postgresql.test.jdbc2.StatementTest.testUnterminatedIdentifier":                                                                                                       "17511",
	"org.postgresql.test.jdbc2.StatementTest.testUnterminatedLiteral":                                                                                                          "17511",
	"org.postgresql.test.jdbc2.StatementTest.testUnterminatedNamedDollarQuotes":                                                                                                "17511",
	"org.postgresql.test.jdbc2.StatementTest.testUpdateCount":                                                                                                                  "17511",
	"org.postgresql.test.jdbc2.StatementTest.testWarningsAreAvailableAsap":                                                                                                     "17511",
	"org.postgresql.test.jdbc2.StatementTest.testWarningsAreCleared":                                                                                                           "17511",
	"org.postgresql.test.jdbc2.StringTypeUnspecifiedArrayTest.testCreateArrayWithNonCachedType[binary = FORCE]":                                                                "21286",
	"org.postgresql.test.jdbc2.StringTypeUnspecifiedArrayTest.testCreateArrayWithNonCachedType[binary = REGULAR]":                                                              "21286",
	"org.postgresql.test.jdbc2.TimeTest.testGetTimeZone":                                                                                                                       "41775",
	"org.postgresql.test.jdbc2.TimestampTest.testGetTimestampWOTZ[binary = FORCE]":                                                                                             "41786",
	"org.postgresql.test.jdbc2.TimestampTest.testGetTimestampWOTZ[binary = REGULAR]":                                                                                           "41786",
	"org.postgresql.test.jdbc2.TimestampTest.testInfinity[binary = FORCE]":                                                                                                     "41786",
	"org.postgresql.test.jdbc2.TimestampTest.testInfinity[binary = REGULAR]":                                                                                                   "41786",
	"org.postgresql.test.jdbc2.TimestampTest.testSetTimestampWOTZ[binary = FORCE]":                                                                                             "41786",
	"org.postgresql.test.jdbc2.TimestampTest.testSetTimestampWOTZ[binary = REGULAR]":                                                                                           "41786",
	"org.postgresql.test.jdbc2.TimezoneTest.testGetDate":                                                                                                                       "41776",
	"org.postgresql.test.jdbc2.TimezoneTest.testGetTime":                                                                                                                       "41776",
	"org.postgresql.test.jdbc2.TimezoneTest.testGetTimestamp":                                                                                                                  "41776",
	"org.postgresql.test.jdbc2.TimezoneTest.testSetDate":                                                                                                                       "41776",
	"org.postgresql.test.jdbc2.TimezoneTest.testSetTime":                                                                                                                       "41776",
	"org.postgresql.test.jdbc2.TimezoneTest.testSetTimestamp":                                                                                                                  "41776",
	"org.postgresql.test.jdbc2.UpdateableResultTest.simpleAndUpdateableSameQuery":                                                                                              "19141",
	"org.postgresql.test.jdbc2.UpdateableResultTest.testArray":                                                                                                                 "19141",
	"org.postgresql.test.jdbc2.UpdateableResultTest.testCancelRowUpdates":                                                                                                      "19141",
	"org.postgresql.test.jdbc2.UpdateableResultTest.testMultiColumnUpdate":                                                                                                     "19141",
	"org.postgresql.test.jdbc2.UpdateableResultTest.testUpdateSelectOnly":                                                                                                      "19141",
	"org.postgresql.test.jdbc2.UpdateableResultTest.testUpdateStreams":                                                                                                         "19141",
	"org.postgresql.test.jdbc2.UpdateableResultTest.testUpdateTimestamp":                                                                                                       "19141",
	"org.postgresql.test.jdbc2.UpdateableResultTest.testUpdateable":                                                                                                            "19141",
	"org.postgresql.test.jdbc3.CompositeTest.testComplexArgumentSelect":                                                                                                        "27793",
	"org.postgresql.test.jdbc3.CompositeTest.testComplexSelect":                                                                                                                "27793",
	"org.postgresql.test.jdbc3.CompositeTest.testComplexTableNameMetadata":                                                                                                     "27793",
	"org.postgresql.test.jdbc3.CompositeTest.testCompositeFromTable":                                                                                                           "27793",
	"org.postgresql.test.jdbc3.CompositeTest.testNullArrayElement":                                                                                                             "27793",
	"org.postgresql.test.jdbc3.CompositeTest.testSimpleArgumentSelect":                                                                                                         "27793",
	"org.postgresql.test.jdbc3.CompositeTest.testSimpleSelect":                                                                                                                 "27793",
	"org.postgresql.test.jdbc3.CompositeTest.testTableMetadata":                                                                                                                "27793",
	"org.postgresql.test.jdbc3.DatabaseMetaDataTest.testGetColumnsForDomain":                                                                                                   "27796",
	"org.postgresql.test.jdbc3.EscapeSyntaxCallModeCallIfNoReturnTest.testInvokeFunction":                                                                                      "17511",
	"org.postgresql.test.jdbc3.EscapeSyntaxCallModeCallIfNoReturnTest.testInvokeFunctionHavingReturnParameter":                                                                 "17511",
	"org.postgresql.test.jdbc3.EscapeSyntaxCallModeCallIfNoReturnTest.testInvokeProcedure":                                                                                     "17511",
	"org.postgresql.test.jdbc3.EscapeSyntaxCallModeCallTest.testInvokeFunction":                                                                                                "17511",
	"org.postgresql.test.jdbc3.EscapeSyntaxCallModeCallTest.testInvokeFunctionHavingReturnParameter":                                                                           "17511",
	"org.postgresql.test.jdbc3.EscapeSyntaxCallModeCallTest.testInvokeProcedure":                                                                                               "17511",
	"org.postgresql.test.jdbc3.EscapeSyntaxCallModeSelectTest.testInvokeFunction":                                                                                              "17511",
	"org.postgresql.test.jdbc3.EscapeSyntaxCallModeSelectTest.testInvokeFunctionHavingReturnParameter":                                                                         "17511",
	"org.postgresql.test.jdbc3.EscapeSyntaxCallModeSelectTest.testInvokeProcedure":                                                                                             "17511",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testBatchGeneratedKeys[returningInQuery = A, binary = FORCE]":                                                                 "26925",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testBatchGeneratedKeys[returningInQuery = A, binary = REGULAR]":                                                               "26925",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testBatchGeneratedKeys[returningInQuery = AB, binary = FORCE]":                                                                "26925",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testBatchGeneratedKeys[returningInQuery = AB, binary = REGULAR]":                                                              "26925",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testBatchGeneratedKeys[returningInQuery = NO, binary = FORCE]":                                                                "26925",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testBatchGeneratedKeys[returningInQuery = NO, binary = REGULAR]":                                                              "26925",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testBatchGeneratedKeys[returningInQuery = STAR, binary = FORCE]":                                                              "26925",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testBatchGeneratedKeys[returningInQuery = STAR, binary = REGULAR]":                                                            "26925",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testSerialWorks[returningInQuery = A, binary = FORCE]":                                                                        "26925",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testSerialWorks[returningInQuery = A, binary = REGULAR]":                                                                      "26925",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testSerialWorks[returningInQuery = AB, binary = FORCE]":                                                                       "26925",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testSerialWorks[returningInQuery = AB, binary = REGULAR]":                                                                     "26925",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testSerialWorks[returningInQuery = NO, binary = FORCE]":                                                                       "26925",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testSerialWorks[returningInQuery = NO, binary = REGULAR]":                                                                     "26925",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testSerialWorks[returningInQuery = STAR, binary = FORCE]":                                                                     "26925",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testSerialWorks[returningInQuery = STAR, binary = REGULAR]":                                                                   "26925",
	"org.postgresql.test.jdbc3.Jdbc3BlobTest.test1Byte":                                                                                                                        "26725",
	"org.postgresql.test.jdbc3.Jdbc3BlobTest.test1ByteOffset":                                                                                                                  "26725",
	"org.postgresql.test.jdbc3.Jdbc3BlobTest.test1ByteOffsetStream":                                                                                                            "26725",
	"org.postgresql.test.jdbc3.Jdbc3BlobTest.test1ByteStream":                                                                                                                  "26725",
	"org.postgresql.test.jdbc3.Jdbc3BlobTest.testAllBytes":                                                                                                                     "26725",
	"org.postgresql.test.jdbc3.Jdbc3BlobTest.testAllBytesStream":                                                                                                               "26725",
	"org.postgresql.test.jdbc3.Jdbc3BlobTest.testManyBytes":                                                                                                                    "26725",
	"org.postgresql.test.jdbc3.Jdbc3BlobTest.testManyBytesOffset":                                                                                                              "26725",
	"org.postgresql.test.jdbc3.Jdbc3BlobTest.testManyBytesOffsetStream":                                                                                                        "26725",
	"org.postgresql.test.jdbc3.Jdbc3BlobTest.testManyBytesStream":                                                                                                              "26725",
	"org.postgresql.test.jdbc3.Jdbc3BlobTest.testPattern":                                                                                                                      "26725",
	"org.postgresql.test.jdbc3.Jdbc3BlobTest.testTruncate":                                                                                                                     "26725",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testAllInOut":                                                                                                        "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testFunctionNoParametersWithParentheses":                                                                             "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testFunctionNoParametersWithoutParentheses":                                                                          "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testGetBoolean01":                                                                                                    "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testGetByte01":                                                                                                       "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testGetBytes01":                                                                                                      "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testGetBytes02":                                                                                                      "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testGetDouble01":                                                                                                     "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testGetDoubleAsReal":                                                                                                 "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testGetInt01":                                                                                                        "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testGetLong01":                                                                                                       "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testGetObjectDecimal":                                                                                                "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testGetObjectFloat":                                                                                                  "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testGetObjectLongVarchar":                                                                                            "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testGetShort01":                                                                                                      "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testInOut":                                                                                                           "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testMultipleOutExecutions":                                                                                           "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testNotEnoughParameters":                                                                                             "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testNumeric":                                                                                                         "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testProcedureInOnlyNativeCall":                                                                                       "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testProcedureInOutNativeCall":                                                                                        "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testProcedureNoParametersWithParentheses":                                                                            "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testProcedureNoParametersWithoutParentheses":                                                                         "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testSetObjectBit":                                                                                                    "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testSomeInOut":                                                                                                       "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testSum":                                                                                                             "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testTooManyParameters":                                                                                               "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testUpdateDecimal":                                                                                                   "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testUpdateReal":                                                                                                      "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testVarcharBool":                                                                                                     "17511",
	"org.postgresql.test.jdbc3.ParameterMetaDataTest.testFailsOnBadIndex":                                                                                                      "21286",
	"org.postgresql.test.jdbc3.ParameterMetaDataTest.testMultiStatement":                                                                                                       "21286",
	"org.postgresql.test.jdbc3.ParameterMetaDataTest.testParameterMD":                                                                                                          "21286",
	"org.postgresql.test.jdbc3.ParameterMetaDataTest.testTypeChangeWithUnknown":                                                                                                "21286",
	"org.postgresql.test.jdbc3.StringTypeParameterTest.testMultipleEnumBinds[stringType = null]":                                                                               "27793",
	"org.postgresql.test.jdbc3.StringTypeParameterTest.testMultipleEnumBinds[stringType = unspecified]":                                                                        "27793",
	"org.postgresql.test.jdbc3.StringTypeParameterTest.testMultipleEnumBinds[stringType = varchar]":                                                                            "27793",
	"org.postgresql.test.jdbc3.StringTypeParameterTest.testOtherAsEnum[stringType = null]":                                                                                     "27793",
	"org.postgresql.test.jdbc3.StringTypeParameterTest.testOtherAsEnum[stringType = unspecified]":                                                                              "27793",
	"org.postgresql.test.jdbc3.StringTypeParameterTest.testOtherAsEnum[stringType = varchar]":                                                                                  "27793",
	"org.postgresql.test.jdbc3.StringTypeParameterTest.testParameterUnspecified[stringType = null]":                                                                            "27793",
	"org.postgresql.test.jdbc3.StringTypeParameterTest.testParameterUnspecified[stringType = unspecified]":                                                                     "27793",
	"org.postgresql.test.jdbc3.StringTypeParameterTest.testParameterUnspecified[stringType = varchar]":                                                                         "27793",
	"org.postgresql.test.jdbc3.StringTypeParameterTest.testVarcharAsEnum[stringType = null]":                                                                                   "27793",
	"org.postgresql.test.jdbc3.StringTypeParameterTest.testVarcharAsEnum[stringType = unspecified]":                                                                            "27793",
	"org.postgresql.test.jdbc3.StringTypeParameterTest.testVarcharAsEnum[stringType = varchar]":                                                                                "27793",
	"org.postgresql.test.jdbc3.TypesTest.testCallableBoolean":                                                                                                                  "17511",
	"org.postgresql.test.jdbc3.TypesTest.testPreparedBoolean":                                                                                                                  "17511",
	"org.postgresql.test.jdbc3.TypesTest.testPreparedByte":                                                                                                                     "17511",
	"org.postgresql.test.jdbc3.TypesTest.testUnknownType":                                                                                                                      "17511",
	"org.postgresql.test.jdbc4.ArrayTest.createNullArray[binary = FORCE]":                                                                                                      "32552",
	"org.postgresql.test.jdbc4.ArrayTest.createNullArray[binary = REGULAR]":                                                                                                    "32552",
	"org.postgresql.test.jdbc4.ArrayTest.multiDimIntArray[binary = FORCE]":                                                                                                     "32552",
	"org.postgresql.test.jdbc4.ArrayTest.multiDimIntArray[binary = REGULAR]":                                                                                                   "32552",
	"org.postgresql.test.jdbc4.ArrayTest.nullArray[binary = FORCE]":                                                                                                            "32552",
	"org.postgresql.test.jdbc4.ArrayTest.nullArray[binary = REGULAR]":                                                                                                          "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCasingBuiltinAlias[binary = FORCE]":                                                                                               "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCasingBuiltinAlias[binary = REGULAR]":                                                                                             "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCasingBuiltinNonAlias[binary = FORCE]":                                                                                            "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCasingBuiltinNonAlias[binary = REGULAR]":                                                                                          "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCasingComposite[binary = FORCE]":                                                                                                  "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCasingComposite[binary = REGULAR]":                                                                                                "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCreateArrayOfBool[binary = FORCE]":                                                                                                "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCreateArrayOfBool[binary = REGULAR]":                                                                                              "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCreateArrayOfInt[binary = FORCE]":                                                                                                 "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCreateArrayOfInt[binary = REGULAR]":                                                                                               "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCreateArrayOfMultiJson[binary = FORCE]":                                                                                           "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCreateArrayOfMultiJson[binary = REGULAR]":                                                                                         "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCreateArrayOfMultiString[binary = FORCE]":                                                                                         "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCreateArrayOfMultiString[binary = REGULAR]":                                                                                       "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCreateArrayOfNull[binary = FORCE]":                                                                                                "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCreateArrayOfNull[binary = REGULAR]":                                                                                              "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCreateArrayOfSmallInt[binary = FORCE]":                                                                                            "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCreateArrayOfSmallInt[binary = REGULAR]":                                                                                          "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCreateArrayWithNonStandardDelimiter[binary = FORCE]":                                                                              "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCreateArrayWithNonStandardDelimiter[binary = REGULAR]":                                                                            "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCreateArrayWithoutServer[binary = FORCE]":                                                                                         "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCreateArrayWithoutServer[binary = REGULAR]":                                                                                       "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCreateEmptyArrayOfIntViaAlias[binary = FORCE]":                                                                                    "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCreateEmptyArrayOfIntViaAlias[binary = REGULAR]":                                                                                  "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCreatePrimitiveArray[binary = FORCE]":                                                                                             "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCreatePrimitiveArray[binary = REGULAR]":                                                                                           "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testEvilCasing[binary = FORCE]":                                                                                                       "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testEvilCasing[binary = REGULAR]":                                                                                                     "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testGetArrayOfComposites[binary = FORCE]":                                                                                             "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testGetArrayOfComposites[binary = REGULAR]":                                                                                           "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testSetObjectFromJavaArray[binary = FORCE]":                                                                                           "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testSetObjectFromJavaArray[binary = REGULAR]":                                                                                         "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testToString[binary = FORCE]":                                                                                                         "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testToString[binary = REGULAR]":                                                                                                       "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testUUIDArray[binary = FORCE]":                                                                                                        "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testUUIDArray[binary = REGULAR]":                                                                                                      "32552",
	"org.postgresql.test.jdbc4.BlobTest.testFree":                                                                                                                              "26725",
	"org.postgresql.test.jdbc4.BlobTest.testGetBinaryStreamWithBoundaries":                                                                                                     "26725",
	"org.postgresql.test.jdbc4.BlobTest.testSetBlobWithStream":                                                                                                                 "26725",
	"org.postgresql.test.jdbc4.BlobTest.testSetBlobWithStreamAndLength":                                                                                                        "26725",
	"org.postgresql.test.jdbc4.DatabaseMetaDataHideUnprivilegedObjectsTest.org.postgresql.test.jdbc4.DatabaseMetaDataHideUnprivilegedObjectsTest":                              "26443",
	"org.postgresql.test.jdbc4.DatabaseMetaDataTest.testGetClientInfoProperties":                                                                                               "26443",
	"org.postgresql.test.jdbc4.DatabaseMetaDataTest.testGetColumnsForAutoIncrement":                                                                                            "41870",
	"org.postgresql.test.jdbc4.DatabaseMetaDataTest.testGetFunctionsInSchema":                                                                                                  "26443",
	"org.postgresql.test.jdbc4.DatabaseMetaDataTest.testGetFunctionsWithBlankPatterns":                                                                                         "41872",
	"org.postgresql.test.jdbc4.DatabaseMetaDataTest.testGetFunctionsWithSpecificTypes":                                                                                         "17511",
	"org.postgresql.test.jdbc4.DatabaseMetaDataTest.testGetProceduresInSchema":                                                                                                 "26443",
	"org.postgresql.test.jdbc4.DatabaseMetaDataTest.testGetSchemas":                                                                                                            "26443",
	"org.postgresql.test.jdbc4.DatabaseMetaDataTest.testSortedDataTypes":                                                                                                       "26443",
	"org.postgresql.test.jdbc4.IsValidTest.testIsValidRemoteClose":                                                                                                             "35897",
	"org.postgresql.test.jdbc4.PGCopyInputStreamTest.testReadBytesCorrectlyHandlesEof":                                                                                         "41608",
	"org.postgresql.test.jdbc4.PGCopyInputStreamTest.testReadBytesCorrectlyReadsDataInChunks":                                                                                  "41608",
	"org.postgresql.test.jdbc4.PGCopyInputStreamTest.testStreamCanBeClosedAfterReadUp":                                                                                         "41608",
	"org.postgresql.test.jdbc4.UUIDTest.testUUIDString[binary=FORCE, stringType=VARCHAR]":                                                                                      "5807",
	"org.postgresql.test.jdbc4.UUIDTest.testUUIDString[binary=REGULAR, stringType=VARCHAR]":                                                                                    "5807",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetArray":                                                                                                              "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetBigDecimal":                                                                                                         "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetBigInteger":                                                                                                         "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetBlob":                                                                                                               "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetBoolean":                                                                                                            "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetBooleanNull":                                                                                                        "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetBox":                                                                                                                "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetCalendar":                                                                                                           "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetCircle":                                                                                                             "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetClob":                                                                                                               "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetDate":                                                                                                               "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetDouble":                                                                                                             "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetDoubleNull":                                                                                                         "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetFloat":                                                                                                              "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetFloatNull":                                                                                                          "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetInet4Address":                                                                                                       "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetInet6Address":                                                                                                       "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetInetAddressNull":                                                                                                    "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetInteger":                                                                                                            "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetIntegerNull":                                                                                                        "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetInterval":                                                                                                           "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetJavaUtilDate":                                                                                                       "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetLine":                                                                                                               "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetLineseg":                                                                                                            "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetLong":                                                                                                               "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetLongNull":                                                                                                           "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetNullDate":                                                                                                           "21286",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetNullTimestamp":                                                                                                      "21286",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetPath":                                                                                                               "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetPoint":                                                                                                              "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetPolygon":                                                                                                            "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetSerial":                                                                                                             "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetShort":                                                                                                              "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetShortNull":                                                                                                          "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetString":                                                                                                             "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetTime":                                                                                                               "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetTimestamp":                                                                                                          "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetTimestampWithTimeZone":                                                                                              "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetUuid":                                                                                                               "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetXml":                                                                                                                "26097",
	"org.postgresql.test.jdbc4.jdbc41.SchemaTest.testCurrentSchemaPropertyNotVisibilityTableDuringFunctionCreation":                                                            "26443",
	"org.postgresql.test.jdbc4.jdbc41.SchemaTest.testCurrentSchemaPropertyNotVisibilityTableInsideFunction":                                                                    "26443",
	"org.postgresql.test.jdbc4.jdbc41.SchemaTest.testCurrentSchemaPropertyVisibilityFunction":                                                                                  "26443",
	"org.postgresql.test.jdbc4.jdbc41.SchemaTest.testCurrentSchemaPropertyVisibilityTableDuringFunctionCreation":                                                               "26443",
	"org.postgresql.test.jdbc4.jdbc41.SchemaTest.testGetSetSchema":                                                                                                             "26443",
	"org.postgresql.test.jdbc4.jdbc41.SchemaTest.testMultipleSearchPath":                                                                                                       "26443",
	"org.postgresql.test.jdbc4.jdbc41.SchemaTest.testSchemaInProperties":                                                                                                       "26443",
	"org.postgresql.test.jdbc4.jdbc41.SchemaTest.testSchemaPath$User":                                                                                                          "26443",
	"org.postgresql.test.jdbc4.jdbc41.SchemaTest.testSearchPathPreparedStatement":                                                                                              "26443",
	"org.postgresql.test.jdbc4.jdbc41.SchemaTest.testSearchPathPreparedStatementAutoCommitFalse":                                                                               "26443",
	"org.postgresql.test.jdbc4.jdbc41.SchemaTest.testSearchPathPreparedStatementAutoCommitTrue":                                                                                "26443",
	"org.postgresql.test.jdbc4.jdbc41.SchemaTest.testUsingSchema":                                                                                                              "26443",
	"org.postgresql.test.jdbc42.GetObject310InfinityTests.test[binary = FORCE, expr = -infinity, pgType = timestamp with time zone, klass = class java.time.OffsetDateTime]":   "41786",
	"org.postgresql.test.jdbc42.GetObject310InfinityTests.test[binary = FORCE, expr = -infinity, pgType = timestamp, klass = class java.time.LocalDateTime]":                   "41786",
	"org.postgresql.test.jdbc42.GetObject310InfinityTests.test[binary = FORCE, expr = -infinity, pgType = timestamp, klass = class java.time.OffsetDateTime]":                  "41786",
	"org.postgresql.test.jdbc42.GetObject310InfinityTests.test[binary = FORCE, expr = infinity, pgType = timestamp with time zone, klass = class java.time.OffsetDateTime]":    "41786",
	"org.postgresql.test.jdbc42.GetObject310InfinityTests.test[binary = FORCE, expr = infinity, pgType = timestamp, klass = class java.time.LocalDateTime]":                    "41786",
	"org.postgresql.test.jdbc42.GetObject310InfinityTests.test[binary = FORCE, expr = infinity, pgType = timestamp, klass = class java.time.OffsetDateTime]":                   "41786",
	"org.postgresql.test.jdbc42.GetObject310InfinityTests.test[binary = REGULAR, expr = -infinity, pgType = timestamp with time zone, klass = class java.time.OffsetDateTime]": "41786",
	"org.postgresql.test.jdbc42.GetObject310InfinityTests.test[binary = REGULAR, expr = -infinity, pgType = timestamp, klass = class java.time.LocalDateTime]":                 "41786",
	"org.postgresql.test.jdbc42.GetObject310InfinityTests.test[binary = REGULAR, expr = -infinity, pgType = timestamp, klass = class java.time.OffsetDateTime]":                "41786",
	"org.postgresql.test.jdbc42.GetObject310InfinityTests.test[binary = REGULAR, expr = infinity, pgType = timestamp with time zone, klass = class java.time.OffsetDateTime]":  "41786",
	"org.postgresql.test.jdbc42.GetObject310InfinityTests.test[binary = REGULAR, expr = infinity, pgType = timestamp, klass = class java.time.LocalDateTime]":                  "41786",
	"org.postgresql.test.jdbc42.GetObject310InfinityTests.test[binary = REGULAR, expr = infinity, pgType = timestamp, klass = class java.time.OffsetDateTime]":                 "41786",
	"org.postgresql.test.jdbc42.GetObject310Test.testGetLocalTimeInvalidType[binary = FORCE]":                                                                                  "26097",
	"org.postgresql.test.jdbc42.GetObject310Test.testGetLocalTimeInvalidType[binary = REGULAR]":                                                                                "26097",
	"org.postgresql.test.jdbc42.GetObject310Test.testProlepticCalendarTimestamptz[binary = FORCE]":                                                                             "26097",
	"org.postgresql.test.jdbc42.GetObject310Test.testProlepticCalendarTimestamptz[binary = REGULAR]":                                                                           "26097",
	"org.postgresql.test.jdbc42.Jdbc42CallableStatementTest.testGetResultSetWithoutArg":                                                                                        "17511",
	"org.postgresql.test.jdbc42.Jdbc42CallableStatementTest.testGetResultSetWithoutArgUnsupportedConversion":                                                                   "17511",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testEmptyExecuteLargeBatchPreparedStatement[binary = FORCE, insertRewrite = false]":                                       "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testEmptyExecuteLargeBatchPreparedStatement[binary = FORCE, insertRewrite = true]":                                        "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testEmptyExecuteLargeBatchPreparedStatement[binary = REGULAR, insertRewrite = false]":                                     "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testEmptyExecuteLargeBatchPreparedStatement[binary = REGULAR, insertRewrite = true]":                                      "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testEmptyExecuteLargeBatchStatement[binary = FORCE, insertRewrite = false]":                                               "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testEmptyExecuteLargeBatchStatement[binary = FORCE, insertRewrite = true]":                                                "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testEmptyExecuteLargeBatchStatement[binary = REGULAR, insertRewrite = false]":                                             "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testEmptyExecuteLargeBatchStatement[binary = REGULAR, insertRewrite = true]":                                              "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargeBatchStatementSMALL[binary = FORCE, insertRewrite = false]":                                               "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargeBatchStatementSMALL[binary = FORCE, insertRewrite = true]":                                                "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargeBatchStatementSMALL[binary = REGULAR, insertRewrite = false]":                                             "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargeBatchStatementSMALL[binary = REGULAR, insertRewrite = true]":                                              "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargeBatchValuesInsertSMALL[binary = FORCE, insertRewrite = false]":                                            "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargeBatchValuesInsertSMALL[binary = FORCE, insertRewrite = true]":                                             "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargeBatchValuesInsertSMALL[binary = REGULAR, insertRewrite = false]":                                          "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargeBatchValuesInsertSMALL[binary = REGULAR, insertRewrite = true]":                                           "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargePreparedStatementStatementLoopSMALL[binary = FORCE, insertRewrite = false]":                               "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargePreparedStatementStatementLoopSMALL[binary = FORCE, insertRewrite = true]":                                "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargePreparedStatementStatementLoopSMALL[binary = REGULAR, insertRewrite = false]":                             "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargePreparedStatementStatementLoopSMALL[binary = REGULAR, insertRewrite = true]":                              "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargePreparedStatementStatementSMALL[binary = FORCE, insertRewrite = false]":                                   "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargePreparedStatementStatementSMALL[binary = FORCE, insertRewrite = true]":                                    "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargePreparedStatementStatementSMALL[binary = REGULAR, insertRewrite = false]":                                 "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargePreparedStatementStatementSMALL[binary = REGULAR, insertRewrite = true]":                                  "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargeUpdatePreparedStatementSELECT[binary = FORCE, insertRewrite = false]":                                     "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargeUpdatePreparedStatementSELECT[binary = FORCE, insertRewrite = true]":                                      "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargeUpdatePreparedStatementSELECT[binary = REGULAR, insertRewrite = false]":                                   "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargeUpdatePreparedStatementSELECT[binary = REGULAR, insertRewrite = true]":                                    "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargeUpdatePreparedStatementSMALL[binary = FORCE, insertRewrite = false]":                                      "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargeUpdatePreparedStatementSMALL[binary = FORCE, insertRewrite = true]":                                       "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargeUpdatePreparedStatementSMALL[binary = REGULAR, insertRewrite = false]":                                    "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargeUpdatePreparedStatementSMALL[binary = REGULAR, insertRewrite = true]":                                     "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargeUpdateStatementSELECT[binary = FORCE, insertRewrite = false]":                                             "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargeUpdateStatementSELECT[binary = FORCE, insertRewrite = true]":                                              "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargeUpdateStatementSELECT[binary = REGULAR, insertRewrite = false]":                                           "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargeUpdateStatementSELECT[binary = REGULAR, insertRewrite = true]":                                            "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargeUpdateStatementSMALL[binary = FORCE, insertRewrite = false]":                                              "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargeUpdateStatementSMALL[binary = FORCE, insertRewrite = true]":                                               "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargeUpdateStatementSMALL[binary = REGULAR, insertRewrite = false]":                                            "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargeUpdateStatementSMALL[binary = REGULAR, insertRewrite = true]":                                             "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testGetLargeUpdateCountPreparedStatementSELECT[binary = FORCE, insertRewrite = false]":                                    "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testGetLargeUpdateCountPreparedStatementSELECT[binary = FORCE, insertRewrite = true]":                                     "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testGetLargeUpdateCountPreparedStatementSELECT[binary = REGULAR, insertRewrite = false]":                                  "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testGetLargeUpdateCountPreparedStatementSELECT[binary = REGULAR, insertRewrite = true]":                                   "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testGetLargeUpdateCountPreparedStatementSMALL[binary = FORCE, insertRewrite = false]":                                     "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testGetLargeUpdateCountPreparedStatementSMALL[binary = FORCE, insertRewrite = true]":                                      "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testGetLargeUpdateCountPreparedStatementSMALL[binary = REGULAR, insertRewrite = false]":                                   "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testGetLargeUpdateCountPreparedStatementSMALL[binary = REGULAR, insertRewrite = true]":                                    "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testGetLargeUpdateCountStatementSELECT[binary = FORCE, insertRewrite = false]":                                            "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testGetLargeUpdateCountStatementSELECT[binary = FORCE, insertRewrite = true]":                                             "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testGetLargeUpdateCountStatementSELECT[binary = REGULAR, insertRewrite = false]":                                          "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testGetLargeUpdateCountStatementSELECT[binary = REGULAR, insertRewrite = true]":                                           "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testGetLargeUpdateCountStatementSMALL[binary = FORCE, insertRewrite = false]":                                             "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testGetLargeUpdateCountStatementSMALL[binary = FORCE, insertRewrite = true]":                                              "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testGetLargeUpdateCountStatementSMALL[binary = REGULAR, insertRewrite = false]":                                           "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testGetLargeUpdateCountStatementSMALL[binary = REGULAR, insertRewrite = true]":                                            "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testNullExecuteLargeBatchPreparedStatement[binary = FORCE, insertRewrite = false]":                                        "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testNullExecuteLargeBatchPreparedStatement[binary = FORCE, insertRewrite = true]":                                         "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testNullExecuteLargeBatchPreparedStatement[binary = REGULAR, insertRewrite = false]":                                      "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testNullExecuteLargeBatchPreparedStatement[binary = REGULAR, insertRewrite = true]":                                       "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testNullExecuteLargeBatchStatement[binary = FORCE, insertRewrite = false]":                                                "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testNullExecuteLargeBatchStatement[binary = FORCE, insertRewrite = true]":                                                 "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testNullExecuteLargeBatchStatement[binary = REGULAR, insertRewrite = false]":                                              "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testNullExecuteLargeBatchStatement[binary = REGULAR, insertRewrite = true]":                                               "43352",
	"org.postgresql.test.jdbc42.PreparedStatementTest.testLocalTimeMax":                                                                                                        "26097",
	"org.postgresql.test.jdbc42.SetObject310Test.testTimeStampRoundingWithType[binary = REGULAR]":                                                                              "26097",
	"org.postgresql.test.jdbc42.SetObject310Test.testTimeStampRounding[binary = REGULAR]":                                                                                      "26097",
	"org.postgresql.test.xa.XADataSourceTest.testAutoCommit":                                                                                                                   "22329",
	"org.postgresql.test.xa.XADataSourceTest.testCloseBeforeCommit":                                                                                                            "22329",
	"org.postgresql.test.xa.XADataSourceTest.testCommitByDifferentConnection":                                                                                                  "22329",
	"org.postgresql.test.xa.XADataSourceTest.testCommitUnknownXid":                                                                                                             "22329",
	"org.postgresql.test.xa.XADataSourceTest.testCommitingCommittedXid":                                                                                                        "22329",
	"org.postgresql.test.xa.XADataSourceTest.testDatabaseRemovesPreparedBeforeCommit":                                                                                          "22329",
	"org.postgresql.test.xa.XADataSourceTest.testDatabaseRemovesPreparedBeforeRollback":                                                                                        "22329",
	"org.postgresql.test.xa.XADataSourceTest.testEndThenJoin":                                                                                                                  "22329",
	"org.postgresql.test.xa.XADataSourceTest.testMappingOfConstraintViolations":                                                                                                "22329",
	"org.postgresql.test.xa.XADataSourceTest.testNetworkIssueOnCommit":                                                                                                         "22329",
	"org.postgresql.test.xa.XADataSourceTest.testNetworkIssueOnOnePhaseCommit":                                                                                                 "22329",
	"org.postgresql.test.xa.XADataSourceTest.testNetworkIssueOnRollback":                                                                                                       "22329",
	"org.postgresql.test.xa.XADataSourceTest.testOnePhase":                                                                                                                     "22329",
	"org.postgresql.test.xa.XADataSourceTest.testOnePhaseCommitOfPrepared":                                                                                                     "22329",
	"org.postgresql.test.xa.XADataSourceTest.testOnePhaseCommitUnknownXid":                                                                                                     "22329",
	"org.postgresql.test.xa.XADataSourceTest.testOnePhaseCommitingCommittedXid":                                                                                                "22329",
	"org.postgresql.test.xa.XADataSourceTest.testPrepareUnknownXid":                                                                                                            "22329",
	"org.postgresql.test.xa.XADataSourceTest.testPreparingPreparedXid":                                                                                                         "22329",
	"org.postgresql.test.xa.XADataSourceTest.testRecover":                                                                                                                      "22329",
	"org.postgresql.test.xa.XADataSourceTest.testRepeatedRolledBack":                                                                                                           "22329",
	"org.postgresql.test.xa.XADataSourceTest.testRestoreOfAutoCommit":                                                                                                          "22329",
	"org.postgresql.test.xa.XADataSourceTest.testRestoreOfAutoCommitEndThenJoin":                                                                                               "22329",
	"org.postgresql.test.xa.XADataSourceTest.testRollback":                                                                                                                     "22329",
	"org.postgresql.test.xa.XADataSourceTest.testRollbackByDifferentConnection":                                                                                                "22329",
	"org.postgresql.test.xa.XADataSourceTest.testRollbackUnknownXid":                                                                                                           "22329",
	"org.postgresql.test.xa.XADataSourceTest.testRollbackWithoutPrepare":                                                                                                       "22329",
	"org.postgresql.test.xa.XADataSourceTest.testTwoPhaseCommit":                                                                                                               "22329",
	"org.postgresql.test.xa.XADataSourceTest.testWrapperEquals":                                                                                                                "22329",
}

var pgjdbcBlockList19_2 = blocklist{
	"org.postgresql.jdbc.DeepBatchedInsertStatementTest.testDeepInternalsBatchedQueryDecorator": "26508",
	"org.postgresql.jdbc.DeepBatchedInsertStatementTest.testUnspecifiedParameterType":           "26508",
	"org.postgresql.jdbc.DeepBatchedInsertStatementTest.testVaryingTypeCounts":                  "26508",
	"org.postgresql.jdbc.PgSQLXMLTest.setCharacterStream":                                       "5807",
	"org.postgresql.test.core.OptionsPropertyTest.testOptionsInProperties":                      "26443",
	"org.postgresql.test.jdbc2.ArrayTest.testEscaping[binary = FORCE]":                          "32552",
	"org.postgresql.test.jdbc2.ArrayTest.testEscaping[binary = REGULAR]":                        "32552",
	"org.postgresql.test.jdbc2.ArrayTest.testMultiDimensionalArray[binary = FORCE]":             "32552",
	"org.postgresql.test.jdbc2.ArrayTest.testMultiDimensionalArray[binary = REGULAR]":           "32552",
	"org.postgresql.test.jdbc2.ArrayTest.testNonStandardBounds[binary = FORCE]":                 "41405",
	"org.postgresql.test.jdbc2.ArrayTest.testNonStandardBounds[binary = REGULAR]":               "41405",
	"org.postgresql.test.jdbc2.ArrayTest.testNonStandardDelimiter[binary = FORCE]":              "21286",
	"org.postgresql.test.jdbc2.ArrayTest.testNonStandardDelimiter[binary = REGULAR]":            "21286",
	"org.postgresql.test.jdbc2.ArrayTest.testNullValues[binary = FORCE]":                        "26925",
	"org.postgresql.test.jdbc2.ArrayTest.testNullValues[binary = REGULAR]":                      "26925",
	"org.postgresql.test.jdbc2.ArrayTest.testRecursiveResultSets[binary = FORCE]":               "32552",
	"org.postgresql.test.jdbc2.ArrayTest.testRecursiveResultSets[binary = REGULAR]":             "32552",
	"org.postgresql.test.jdbc2.ArrayTest.testRetrieveArrays[binary = FORCE]":                    "41405",
	"org.postgresql.test.jdbc2.ArrayTest.testRetrieveArrays[binary = REGULAR]":                  "41405",
	"org.postgresql.test.jdbc2.ArrayTest.testRetrieveResultSets[binary = FORCE]":                "41405",
	"org.postgresql.test.jdbc2.ArrayTest.testRetrieveResultSets[binary = REGULAR]":              "41405",
	"org.postgresql.test.jdbc2.ArrayTest.testSetArray[binary = FORCE]":                          "26925",
	"org.postgresql.test.jdbc2.ArrayTest.testSetArray[binary = REGULAR]":                        "26925",
	"org.postgresql.test.jdbc2.ArrayTest.testSetPrimitiveArraysObjects[binary = FORCE]":         "26925",
	"org.postgresql.test.jdbc2.ArrayTest.testSetPrimitiveArraysObjects[binary = REGULAR]":       "26925",
	"org.postgresql.test.jdbc2.ArrayTest.testSetPrimitiveObjects[binary = FORCE]":               "26925",
	"org.postgresql.test.jdbc2.ArrayTest.testSetPrimitiveObjects[binary = REGULAR]":             "26925",
	"org.postgresql.test.jdbc2.ArrayTest.testWriteMultiDimensional[binary = FORCE]":             "32552",
	"org.postgresql.test.jdbc2.ArrayTest.testWriteMultiDimensional[binary = REGULAR]":           "32552",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[100: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                               "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[101: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                                "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[102: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":                   "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[103: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":                    "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[13: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=YES, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                                "41445",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[144: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                        "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[145: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                         "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[146: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":            "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[147: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":             "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[148: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                       "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[149: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                        "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[150: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[151: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":            "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[152: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                      "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[153: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                       "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[154: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":          "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[155: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[156: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                         "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[157: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                          "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[158: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":             "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[159: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":              "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[15: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=YES, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":                    "41445",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[160: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                        "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[161: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                         "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[162: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":            "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[163: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":             "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[177: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=YES, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                              "41445",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[179: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=YES, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":                  "41445",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[228: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                      "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[229: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                       "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[230: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":          "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[231: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[232: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                    "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[233: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                     "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[234: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":        "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[235: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":         "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[236: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                      "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[237: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                       "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[238: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":          "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[239: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[260: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                               "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[261: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                                "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[262: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":                   "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[263: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":                    "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[264: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                              "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[265: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                               "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[266: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":                  "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[267: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":                   "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[308: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                       "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[309: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                        "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[310: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[311: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":            "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[312: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                      "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[313: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                       "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[314: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":          "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[315: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[316: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                     "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[317: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                      "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[318: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":         "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[319: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":          "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[320: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                        "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[321: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                         "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[322: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":            "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[323: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":             "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[324: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                       "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[325: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                        "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[326: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[327: autorollback(autoSave=NEVER, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":            "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[328: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=SELECT, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                            "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[329: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=SELECT, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                             "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[330: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=SELECT, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":                "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[331: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=SELECT, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":                 "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[341: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                              "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[343: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":                  "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[344: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=DEALLOCATE, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                        "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[345: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=DEALLOCATE, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                         "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[346: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=DEALLOCATE, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":            "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[347: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=DEALLOCATE, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":             "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[348: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=DEALLOCATE, continueMode=COMMIT, flushOnDeallocate=false, hastransaction=false, sql=SELECT, columns=EXACT)]":                       "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[349: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=DEALLOCATE, continueMode=COMMIT, flushOnDeallocate=false, hastransaction=false, sql=SELECT, columns=STAR)]":                        "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[350: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=DEALLOCATE, continueMode=COMMIT, flushOnDeallocate=false, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[351: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=DEALLOCATE, continueMode=COMMIT, flushOnDeallocate=false, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":            "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[368: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=DISCARD, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[369: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=DISCARD, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                            "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[370: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=DISCARD, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":               "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[371: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=DISCARD, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":                "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[372: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=DISCARD, continueMode=COMMIT, flushOnDeallocate=false, hastransaction=false, sql=SELECT, columns=EXACT)]":                          "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[373: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=DISCARD, continueMode=COMMIT, flushOnDeallocate=false, hastransaction=false, sql=SELECT, columns=STAR)]":                           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[374: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=DISCARD, continueMode=COMMIT, flushOnDeallocate=false, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":              "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[375: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=DISCARD, continueMode=COMMIT, flushOnDeallocate=false, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":               "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[392: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                      "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[393: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                       "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[394: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":          "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[395: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[396: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                    "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[397: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                     "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[398: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":        "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[399: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":         "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[400: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                      "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[401: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                       "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[402: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":          "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[403: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[404: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=SELECT, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                             "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[405: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=SELECT, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                              "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[406: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=SELECT, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":                 "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[407: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=SELECT, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":                  "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[408: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=SELECT, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                            "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[409: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=SELECT, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                             "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[410: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=SELECT, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":                "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[411: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=SELECT, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":                 "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[412: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=SELECT, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                           "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[413: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=SELECT, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                            "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[414: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=SELECT, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":               "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[415: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=SELECT, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":                "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[416: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=SELECT, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                              "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[417: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=SELECT, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                               "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[418: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=SELECT, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":                  "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[419: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=SELECT, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":                   "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[420: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=SELECT, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                             "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[421: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=SELECT, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                              "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[422: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=SELECT, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":                 "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[423: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=SELECT, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":                  "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[424: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                               "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[425: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                                "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[426: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":                   "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[427: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":                    "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[428: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                              "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[429: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                               "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[430: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":                  "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[431: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":                   "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[432: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=DEALLOCATE, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                         "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[433: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=DEALLOCATE, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                          "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[434: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=DEALLOCATE, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":             "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[435: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=DEALLOCATE, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":              "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[436: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=DEALLOCATE, continueMode=COMMIT, flushOnDeallocate=false, hastransaction=false, sql=SELECT, columns=EXACT)]":                        "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[437: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=DEALLOCATE, continueMode=COMMIT, flushOnDeallocate=false, hastransaction=false, sql=SELECT, columns=STAR)]":                         "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[438: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=DEALLOCATE, continueMode=COMMIT, flushOnDeallocate=false, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":            "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[439: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=DEALLOCATE, continueMode=COMMIT, flushOnDeallocate=false, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":             "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[440: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=DEALLOCATE, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                        "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[441: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=DEALLOCATE, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                         "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[442: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=DEALLOCATE, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":            "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[443: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=DEALLOCATE, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":             "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[444: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=DEALLOCATE, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                       "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[445: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=DEALLOCATE, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                        "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[446: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=DEALLOCATE, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":           "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[447: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=DEALLOCATE, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":            "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[448: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=DEALLOCATE, continueMode=IS_VALID, flushOnDeallocate=false, hastransaction=true, sql=SELECT, columns=EXACT)]":                       "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[449: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=DEALLOCATE, continueMode=IS_VALID, flushOnDeallocate=false, hastransaction=true, sql=SELECT, columns=STAR)]":                        "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[450: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=DEALLOCATE, continueMode=IS_VALID, flushOnDeallocate=false, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":           "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[451: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=DEALLOCATE, continueMode=IS_VALID, flushOnDeallocate=false, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":            "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[452: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=DEALLOCATE, continueMode=IS_VALID, flushOnDeallocate=false, hastransaction=false, sql=SELECT, columns=EXACT)]":                      "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[453: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=DEALLOCATE, continueMode=IS_VALID, flushOnDeallocate=false, hastransaction=false, sql=SELECT, columns=STAR)]":                       "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[454: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=DEALLOCATE, continueMode=IS_VALID, flushOnDeallocate=false, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":          "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[455: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=DEALLOCATE, continueMode=IS_VALID, flushOnDeallocate=false, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":           "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[456: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                          "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[457: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                           "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[458: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":              "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[459: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":               "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[460: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                         "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[461: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                          "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[462: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":             "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[463: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":              "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[464: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=false, hastransaction=true, sql=SELECT, columns=EXACT)]":                         "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[465: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=false, hastransaction=true, sql=SELECT, columns=STAR)]":                          "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[466: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=false, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":             "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[467: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=false, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":              "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[468: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=false, hastransaction=false, sql=SELECT, columns=EXACT)]":                        "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[469: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=false, hastransaction=false, sql=SELECT, columns=STAR)]":                         "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[470: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=false, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":            "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[471: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=false, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":             "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[472: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                       "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[473: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                        "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[474: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[475: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":            "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[476: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                      "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[477: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                       "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[478: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":          "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[479: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[480: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                     "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[481: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                      "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[482: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":         "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[483: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":          "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[484: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                        "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[485: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                         "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[486: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":            "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[487: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":             "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[488: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                       "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[489: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                        "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[490: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[491: autorollback(autoSave=ALWAYS, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":            "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[492: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=SELECT, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[493: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=SELECT, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                            "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[494: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=SELECT, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":               "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[495: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=SELECT, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":                "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[505: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                             "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[507: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":                 "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[508: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=DEALLOCATE, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                       "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[509: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=DEALLOCATE, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                        "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[510: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=DEALLOCATE, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[511: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=DEALLOCATE, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":            "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[512: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=DEALLOCATE, continueMode=COMMIT, flushOnDeallocate=false, hastransaction=false, sql=SELECT, columns=EXACT)]":                      "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[513: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=DEALLOCATE, continueMode=COMMIT, flushOnDeallocate=false, hastransaction=false, sql=SELECT, columns=STAR)]":                       "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[514: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=DEALLOCATE, continueMode=COMMIT, flushOnDeallocate=false, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":          "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[515: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=DEALLOCATE, continueMode=COMMIT, flushOnDeallocate=false, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[532: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=DISCARD, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                          "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[533: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=DISCARD, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[534: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=DISCARD, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":              "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[535: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=DISCARD, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":               "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[536: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=DISCARD, continueMode=COMMIT, flushOnDeallocate=false, hastransaction=false, sql=SELECT, columns=EXACT)]":                         "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[537: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=DISCARD, continueMode=COMMIT, flushOnDeallocate=false, hastransaction=false, sql=SELECT, columns=STAR)]":                          "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[538: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=DISCARD, continueMode=COMMIT, flushOnDeallocate=false, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":             "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[539: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=DISCARD, continueMode=COMMIT, flushOnDeallocate=false, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":              "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[556: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                     "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[557: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                      "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[558: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":         "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[559: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":          "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[560: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                   "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[561: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                    "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[562: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":       "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[563: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":        "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[564: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                     "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[565: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                      "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[566: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":         "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[567: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":          "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[568: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=SELECT, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                            "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[569: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=SELECT, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                             "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[570: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=SELECT, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":                "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[571: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=SELECT, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":                 "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[572: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=SELECT, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                           "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[573: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=SELECT, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                            "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[574: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=SELECT, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":               "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[575: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=SELECT, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":                "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[576: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=SELECT, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                          "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[577: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=SELECT, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                           "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[578: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=SELECT, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":              "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[579: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=SELECT, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":               "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[580: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=SELECT, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                             "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[581: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=SELECT, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                              "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[582: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=SELECT, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":                 "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[583: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=SELECT, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":                  "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[584: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=SELECT, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                            "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[585: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=SELECT, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                             "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[586: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=SELECT, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":                "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[587: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=SELECT, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":                 "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[588: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                              "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[589: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                               "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[590: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":                  "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[591: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":                   "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[592: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                             "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[593: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                              "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[594: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":                 "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[595: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":                  "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[596: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=DEALLOCATE, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                        "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[597: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=DEALLOCATE, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                         "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[598: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=DEALLOCATE, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":            "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[599: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=DEALLOCATE, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":             "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[600: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=DEALLOCATE, continueMode=COMMIT, flushOnDeallocate=false, hastransaction=false, sql=SELECT, columns=EXACT)]":                       "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[601: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=DEALLOCATE, continueMode=COMMIT, flushOnDeallocate=false, hastransaction=false, sql=SELECT, columns=STAR)]":                        "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[602: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=DEALLOCATE, continueMode=COMMIT, flushOnDeallocate=false, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":           "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[603: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=DEALLOCATE, continueMode=COMMIT, flushOnDeallocate=false, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":            "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[604: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=DEALLOCATE, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                       "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[605: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=DEALLOCATE, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                        "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[606: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=DEALLOCATE, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":           "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[607: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=DEALLOCATE, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":            "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[608: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=DEALLOCATE, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                      "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[609: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=DEALLOCATE, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                       "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[610: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=DEALLOCATE, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":          "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[611: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=DEALLOCATE, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":           "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[612: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=DEALLOCATE, continueMode=IS_VALID, flushOnDeallocate=false, hastransaction=true, sql=SELECT, columns=EXACT)]":                      "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[613: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=DEALLOCATE, continueMode=IS_VALID, flushOnDeallocate=false, hastransaction=true, sql=SELECT, columns=STAR)]":                       "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[614: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=DEALLOCATE, continueMode=IS_VALID, flushOnDeallocate=false, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":          "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[615: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=DEALLOCATE, continueMode=IS_VALID, flushOnDeallocate=false, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":           "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[616: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=DEALLOCATE, continueMode=IS_VALID, flushOnDeallocate=false, hastransaction=false, sql=SELECT, columns=EXACT)]":                     "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[617: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=DEALLOCATE, continueMode=IS_VALID, flushOnDeallocate=false, hastransaction=false, sql=SELECT, columns=STAR)]":                      "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[618: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=DEALLOCATE, continueMode=IS_VALID, flushOnDeallocate=false, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":         "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[619: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=DEALLOCATE, continueMode=IS_VALID, flushOnDeallocate=false, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":          "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[620: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                         "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[621: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                          "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[622: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":             "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[623: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":              "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[624: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                        "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[625: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                         "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[626: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":            "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[627: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":             "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[628: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=false, hastransaction=true, sql=SELECT, columns=EXACT)]":                        "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[629: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=false, hastransaction=true, sql=SELECT, columns=STAR)]":                         "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[630: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=false, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":            "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[631: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=false, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":             "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[632: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=false, hastransaction=false, sql=SELECT, columns=EXACT)]":                       "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[633: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=false, hastransaction=false, sql=SELECT, columns=STAR)]":                        "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[634: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=false, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":           "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[635: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=false, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":            "41511",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[636: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                      "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[637: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                       "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[638: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":          "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[639: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[640: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                     "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[641: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                      "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[642: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":         "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[643: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":          "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[644: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                    "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[645: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                     "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[646: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":        "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[647: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":         "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[648: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                       "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[649: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                        "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[64: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                        "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[650: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[651: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":            "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[652: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                      "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[653: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                       "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[654: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":          "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[655: autorollback(autoSave=ALWAYS, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[65: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                         "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[669: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=YES, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                        "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[66: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":            "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[671: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=YES, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":            "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[67: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":             "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[68: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                      "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[69: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                       "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[70: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":          "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[71: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":           "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[720: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[721: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                 "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[722: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":    "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[723: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":     "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[724: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":              "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[725: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":               "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[726: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":  "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[727: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":   "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[728: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[729: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                 "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[72: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                        "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[730: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":    "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[731: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":     "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[73: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                         "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[744: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=SELECT, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                        "10735",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[745: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=SELECT, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                         "10735",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[746: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=SELECT, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":            "10735",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[747: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=SELECT, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":             "10735",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[748: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=SELECT, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                       "10735",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[749: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=SELECT, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                        "10735",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[74: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":            "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[750: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=SELECT, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":           "10735",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[751: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=SELECT, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":            "10735",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[752: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                         "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[753: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                          "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[754: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":             "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[755: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":              "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[756: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                        "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[757: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                         "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[758: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":            "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[759: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":             "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[75: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":             "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[784: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                    "10735",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[785: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                     "10735",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[786: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":        "10735",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[787: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":         "10735",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[788: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                   "10735",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[789: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                    "10735",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[790: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":       "10735",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[791: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":        "10735",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[792: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=false, hastransaction=true, sql=SELECT, columns=EXACT)]":                   "10735",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[793: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=false, hastransaction=true, sql=SELECT, columns=STAR)]":                    "10735",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[794: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=false, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":       "10735",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[795: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=false, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":        "10735",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[796: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=false, hastransaction=false, sql=SELECT, columns=EXACT)]":                  "10735",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[797: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=false, hastransaction=false, sql=SELECT, columns=STAR)]":                   "10735",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[798: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=false, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":      "10735",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[799: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=false, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":       "10735",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[800: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                 "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[801: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                  "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[802: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":     "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[803: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":      "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[804: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[805: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                 "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[806: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":    "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[807: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":     "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[808: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":               "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[809: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[810: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":   "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[811: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":    "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[812: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                  "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[813: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                   "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[814: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":      "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[815: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":       "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[816: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                 "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[817: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                  "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[818: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":     "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[819: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=TRUE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":      "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[833: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=YES, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                       "41445",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[835: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=YES, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":           "41445",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[884: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":               "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[885: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[886: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":   "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[887: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":    "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[888: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":             "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[889: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":              "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[890: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]": "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[891: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":  "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[892: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":               "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[893: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[894: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":   "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[895: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=YES, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":    "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[908: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=SELECT, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                       "10735",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[909: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=SELECT, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                        "10735",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[910: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=SELECT, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":           "10735",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[911: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=SELECT, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":            "10735",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[912: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=SELECT, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                      "10735",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[913: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=SELECT, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                       "10735",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[914: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=SELECT, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":          "10735",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[915: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=SELECT, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":           "10735",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[916: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                        "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[917: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                         "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[918: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":            "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[919: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":             "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[920: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                       "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[921: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                        "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[922: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":           "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[923: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":            "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[948: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                   "10735",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[949: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                    "10735",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[950: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":       "10735",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[951: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":        "10735",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[952: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                  "10735",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[953: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                   "10735",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[954: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":      "10735",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[955: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":       "10735",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[956: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=false, hastransaction=true, sql=SELECT, columns=EXACT)]":                  "10735",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[957: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=false, hastransaction=true, sql=SELECT, columns=STAR)]":                   "10735",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[958: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=false, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":      "10735",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[959: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=false, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":       "10735",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[960: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=false, hastransaction=false, sql=SELECT, columns=EXACT)]":                 "10735",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[961: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=false, hastransaction=false, sql=SELECT, columns=STAR)]":                  "10735",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[962: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=false, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":     "10735",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[963: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=DEALLOCATE, continueMode=SELECT, flushOnDeallocate=false, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":      "10735",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[964: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[965: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                 "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[966: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":    "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[967: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=COMMIT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":     "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[968: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":               "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[969: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[96: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                                 "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[970: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":   "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[971: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":    "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[972: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":              "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[973: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":               "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[974: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":  "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[975: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=IS_VALID, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":   "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[976: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=EXACT)]":                 "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[977: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                  "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[978: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":     "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[979: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":      "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[97: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=SELECT, columns=STAR)]":                                  "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[980: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=EXACT)]":                "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[981: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=SELECT, columns=STAR)]":                 "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[982: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=EXACT)]":    "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[983: autorollback(autoSave=CONSERVATIVE, cleanSavePoint=FALSE, autoCommit=NO, failMode=INSERT_BATCH, continueMode=SELECT, flushOnDeallocate=true, hastransaction=false, sql=WITH_INSERT_SELECT, columns=STAR)]":     "41448",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[98: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=EXACT)]":                     "26508",
	"org.postgresql.test.jdbc2.AutoRollbackTestSuite.run[99: autorollback(autoSave=NEVER, cleanSavePoint=TRUE, autoCommit=NO, failMode=ALTER, continueMode=SELECT, flushOnDeallocate=true, hastransaction=true, sql=WITH_INSERT_SELECT, columns=STAR)]":                      "26508",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchEscapeProcessing[binary = FORCE, insertRewrite = false]":                                                                                                                                                            "5807",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchEscapeProcessing[binary = FORCE, insertRewrite = true]":                                                                                                                                                             "5807",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchEscapeProcessing[binary = REGULAR, insertRewrite = false]":                                                                                                                                                          "5807",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchEscapeProcessing[binary = REGULAR, insertRewrite = true]":                                                                                                                                                           "5807",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithAlternatingTypes[binary = FORCE, insertRewrite = false]":                                                                                                                                                        "41513",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithAlternatingTypes[binary = FORCE, insertRewrite = true]":                                                                                                                                                         "41513",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithAlternatingTypes[binary = REGULAR, insertRewrite = false]":                                                                                                                                                      "41513",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithAlternatingTypes[binary = REGULAR, insertRewrite = true]":                                                                                                                                                       "41513",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithEmbeddedNulls[binary = FORCE, insertRewrite = false]":                                                                                                                                                           "5807",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithEmbeddedNulls[binary = FORCE, insertRewrite = true]":                                                                                                                                                            "5807",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithEmbeddedNulls[binary = REGULAR, insertRewrite = false]":                                                                                                                                                         "5807",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithEmbeddedNulls[binary = REGULAR, insertRewrite = true]":                                                                                                                                                          "5807",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testMixedBatch[binary = FORCE, insertRewrite = false]":                                                                                                                                                                       "5807",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testMixedBatch[binary = FORCE, insertRewrite = true]":                                                                                                                                                                        "5807",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testMixedBatch[binary = REGULAR, insertRewrite = false]":                                                                                                                                                                     "5807",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testMixedBatch[binary = REGULAR, insertRewrite = true]":                                                                                                                                                                      "5807",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testSelectInBatchThrowsAutoCommit[binary = FORCE, insertRewrite = false]":                                                                                                                                                    "44803",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testSelectInBatchThrowsAutoCommit[binary = FORCE, insertRewrite = true]":                                                                                                                                                     "44803",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testSelectInBatchThrowsAutoCommit[binary = REGULAR, insertRewrite = false]":                                                                                                                                                  "44803",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testSelectInBatchThrowsAutoCommit[binary = REGULAR, insertRewrite = true]":                                                                                                                                                   "44803",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testSelectInBatch[binary = FORCE, insertRewrite = false]":                                                                                                                                                                    "40195",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testSelectInBatch[binary = FORCE, insertRewrite = true]":                                                                                                                                                                     "40195",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testSelectInBatch[binary = REGULAR, insertRewrite = false]":                                                                                                                                                                  "40195",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testSelectInBatch[binary = REGULAR, insertRewrite = true]":                                                                                                                                                                   "40195",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testSmallBatchUpdateFailureSimple[binary = FORCE, insertRewrite = false]":                                                                                                                                                    "44803",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testSmallBatchUpdateFailureSimple[binary = REGULAR, insertRewrite = false]":                                                                                                                                                  "44803",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testWarningsAreCleared[binary = FORCE, insertRewrite = false]":                                                                                                                                                               "5807",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testWarningsAreCleared[binary = FORCE, insertRewrite = true]":                                                                                                                                                                "5807",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testWarningsAreCleared[binary = REGULAR, insertRewrite = false]":                                                                                                                                                             "5807",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testWarningsAreCleared[binary = REGULAR, insertRewrite = true]":                                                                                                                                                              "5807",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[105: batchTest(mode=FAIL_VIA_DUP_KEY, position=SECOND_ROW, autoCommit=YES, batchType=PREPARED, generateKeys=YES, binary=REGULAR, insertRewrite=false)]":                                                                  "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[107: batchTest(mode=FAIL_VIA_DUP_KEY, position=SECOND_ROW, autoCommit=YES, batchType=PREPARED, generateKeys=YES, binary=FORCE, insertRewrite=false)]":                                                                    "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[112: batchTest(mode=FAIL_VIA_DUP_KEY, position=MIDDLE, autoCommit=YES, batchType=PREPARED, generateKeys=YES, binary=REGULAR, insertRewrite=true)]":                                                                       "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[113: batchTest(mode=FAIL_VIA_DUP_KEY, position=MIDDLE, autoCommit=YES, batchType=PREPARED, generateKeys=YES, binary=REGULAR, insertRewrite=false)]":                                                                      "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[114: batchTest(mode=FAIL_VIA_DUP_KEY, position=MIDDLE, autoCommit=YES, batchType=PREPARED, generateKeys=YES, binary=FORCE, insertRewrite=true)]":                                                                         "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[115: batchTest(mode=FAIL_VIA_DUP_KEY, position=MIDDLE, autoCommit=YES, batchType=PREPARED, generateKeys=YES, binary=FORCE, insertRewrite=false)]":                                                                        "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[120: batchTest(mode=FAIL_VIA_DUP_KEY, position=ALMOST_LAST_ROW, autoCommit=YES, batchType=PREPARED, generateKeys=YES, binary=REGULAR, insertRewrite=true)]":                                                              "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[121: batchTest(mode=FAIL_VIA_DUP_KEY, position=ALMOST_LAST_ROW, autoCommit=YES, batchType=PREPARED, generateKeys=YES, binary=REGULAR, insertRewrite=false)]":                                                             "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[122: batchTest(mode=FAIL_VIA_DUP_KEY, position=ALMOST_LAST_ROW, autoCommit=YES, batchType=PREPARED, generateKeys=YES, binary=FORCE, insertRewrite=true)]":                                                                "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[123: batchTest(mode=FAIL_VIA_DUP_KEY, position=ALMOST_LAST_ROW, autoCommit=YES, batchType=PREPARED, generateKeys=YES, binary=FORCE, insertRewrite=false)]":                                                               "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[128: batchTest(mode=FAIL_VIA_DUP_KEY, position=LAST_ROW, autoCommit=YES, batchType=PREPARED, generateKeys=YES, binary=REGULAR, insertRewrite=true)]":                                                                     "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[129: batchTest(mode=FAIL_VIA_DUP_KEY, position=LAST_ROW, autoCommit=YES, batchType=PREPARED, generateKeys=YES, binary=REGULAR, insertRewrite=false)]":                                                                    "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[130: batchTest(mode=FAIL_VIA_DUP_KEY, position=LAST_ROW, autoCommit=YES, batchType=PREPARED, generateKeys=YES, binary=FORCE, insertRewrite=true)]":                                                                       "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[131: batchTest(mode=FAIL_VIA_DUP_KEY, position=LAST_ROW, autoCommit=YES, batchType=PREPARED, generateKeys=YES, binary=FORCE, insertRewrite=false)]":                                                                      "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[16: batchTest(mode=FAIL_VIA_SELECT_PARSE, position=SECOND_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=REGULAR, insertRewrite=true)]":                                                                 "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[17: batchTest(mode=FAIL_VIA_SELECT_PARSE, position=SECOND_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=REGULAR, insertRewrite=false)]":                                                                "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[18: batchTest(mode=FAIL_VIA_SELECT_PARSE, position=SECOND_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=FORCE, insertRewrite=true)]":                                                                   "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[19: batchTest(mode=FAIL_VIA_SELECT_PARSE, position=SECOND_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=FORCE, insertRewrite=false)]":                                                                  "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[24: batchTest(mode=FAIL_VIA_SELECT_PARSE, position=MIDDLE, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=REGULAR, insertRewrite=true)]":                                                                     "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[25: batchTest(mode=FAIL_VIA_SELECT_PARSE, position=MIDDLE, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=REGULAR, insertRewrite=false)]":                                                                    "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[26: batchTest(mode=FAIL_VIA_SELECT_PARSE, position=MIDDLE, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=FORCE, insertRewrite=true)]":                                                                       "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[27: batchTest(mode=FAIL_VIA_SELECT_PARSE, position=MIDDLE, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=FORCE, insertRewrite=false)]":                                                                      "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[32: batchTest(mode=FAIL_VIA_SELECT_PARSE, position=ALMOST_LAST_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=REGULAR, insertRewrite=true)]":                                                            "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[33: batchTest(mode=FAIL_VIA_SELECT_PARSE, position=ALMOST_LAST_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=REGULAR, insertRewrite=false)]":                                                           "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[34: batchTest(mode=FAIL_VIA_SELECT_PARSE, position=ALMOST_LAST_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=FORCE, insertRewrite=true)]":                                                              "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[35: batchTest(mode=FAIL_VIA_SELECT_PARSE, position=ALMOST_LAST_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=FORCE, insertRewrite=false)]":                                                             "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[40: batchTest(mode=FAIL_VIA_SELECT_PARSE, position=LAST_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=REGULAR, insertRewrite=true)]":                                                                   "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[41: batchTest(mode=FAIL_VIA_SELECT_PARSE, position=LAST_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=REGULAR, insertRewrite=false)]":                                                                  "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[42: batchTest(mode=FAIL_VIA_SELECT_PARSE, position=LAST_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=FORCE, insertRewrite=true)]":                                                                     "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[43: batchTest(mode=FAIL_VIA_SELECT_PARSE, position=LAST_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=FORCE, insertRewrite=false)]":                                                                    "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[56: batchTest(mode=FAIL_VIA_SELECT_RUNTIME, position=SECOND_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=REGULAR, insertRewrite=true)]":                                                               "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[57: batchTest(mode=FAIL_VIA_SELECT_RUNTIME, position=SECOND_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=REGULAR, insertRewrite=false)]":                                                              "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[58: batchTest(mode=FAIL_VIA_SELECT_RUNTIME, position=SECOND_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=FORCE, insertRewrite=true)]":                                                                 "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[59: batchTest(mode=FAIL_VIA_SELECT_RUNTIME, position=SECOND_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=FORCE, insertRewrite=false)]":                                                                "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[64: batchTest(mode=FAIL_VIA_SELECT_RUNTIME, position=MIDDLE, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=REGULAR, insertRewrite=true)]":                                                                   "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[65: batchTest(mode=FAIL_VIA_SELECT_RUNTIME, position=MIDDLE, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=REGULAR, insertRewrite=false)]":                                                                  "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[66: batchTest(mode=FAIL_VIA_SELECT_RUNTIME, position=MIDDLE, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=FORCE, insertRewrite=true)]":                                                                     "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[67: batchTest(mode=FAIL_VIA_SELECT_RUNTIME, position=MIDDLE, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=FORCE, insertRewrite=false)]":                                                                    "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[72: batchTest(mode=FAIL_VIA_SELECT_RUNTIME, position=ALMOST_LAST_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=REGULAR, insertRewrite=true)]":                                                          "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[73: batchTest(mode=FAIL_VIA_SELECT_RUNTIME, position=ALMOST_LAST_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=REGULAR, insertRewrite=false)]":                                                         "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[74: batchTest(mode=FAIL_VIA_SELECT_RUNTIME, position=ALMOST_LAST_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=FORCE, insertRewrite=true)]":                                                            "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[75: batchTest(mode=FAIL_VIA_SELECT_RUNTIME, position=ALMOST_LAST_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=FORCE, insertRewrite=false)]":                                                           "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[80: batchTest(mode=FAIL_VIA_SELECT_RUNTIME, position=LAST_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=REGULAR, insertRewrite=true)]":                                                                 "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[81: batchTest(mode=FAIL_VIA_SELECT_RUNTIME, position=LAST_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=REGULAR, insertRewrite=false)]":                                                                "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[82: batchTest(mode=FAIL_VIA_SELECT_RUNTIME, position=LAST_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=FORCE, insertRewrite=true)]":                                                                   "44803",
	"org.postgresql.test.jdbc2.BatchFailureTest.run[83: batchTest(mode=FAIL_VIA_SELECT_RUNTIME, position=LAST_ROW, autoCommit=YES, batchType=SIMPLE, generateKeys=YES, binary=FORCE, insertRewrite=false)]":                                                                  "44803",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.test17000Binds[2: autoCommit=NO, binary=REGULAR]":                                                                                                                                                             "26508",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.test17000Binds[3: autoCommit=NO, binary=FORCE]":                                                                                                                                                               "26508",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.test32000Binds[2: autoCommit=NO, binary=REGULAR]":                                                                                                                                                             "26508",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.test32000Binds[3: autoCommit=NO, binary=FORCE]":                                                                                                                                                               "26508",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.testBatchWithReWrittenBatchStatementWithFixedParameter[2: autoCommit=NO, binary=REGULAR]":                                                                                                                     "26508",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.testBatchWithReWrittenBatchStatementWithFixedParameter[3: autoCommit=NO, binary=FORCE]":                                                                                                                       "26508",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.testBatchWithReWrittenBatchStatementWithFixedParametersOnly[2: autoCommit=NO, binary=REGULAR]":                                                                                                                "26508",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.testBatchWithReWrittenBatchStatementWithFixedParametersOnly[3: autoCommit=NO, binary=FORCE]":                                                                                                                  "26508",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.testBatchWithReWrittenRepeatedInsertStatementOptimizationEnabled[2: autoCommit=NO, binary=REGULAR]":                                                                                                           "26508",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.testBatchWithReWrittenRepeatedInsertStatementOptimizationEnabled[3: autoCommit=NO, binary=FORCE]":                                                                                                             "26508",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.testBindsInNestedParens[2: autoCommit=NO, binary=REGULAR]":                                                                                                                                                    "26508",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.testBindsInNestedParens[3: autoCommit=NO, binary=FORCE]":                                                                                                                                                      "26508",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.testConsistentOutcome[2: autoCommit=NO, binary=REGULAR]":                                                                                                                                                      "26508",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.testConsistentOutcome[3: autoCommit=NO, binary=FORCE]":                                                                                                                                                        "26508",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.testINSERTwithNamedColumnsNotBroken[2: autoCommit=NO, binary=REGULAR]":                                                                                                                                        "26508",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.testINSERTwithNamedColumnsNotBroken[3: autoCommit=NO, binary=FORCE]":                                                                                                                                          "26508",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.testMixedCaseInSeRtStatement[2: autoCommit=NO, binary=REGULAR]":                                                                                                                                               "26508",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.testMixedCaseInSeRtStatement[3: autoCommit=NO, binary=FORCE]":                                                                                                                                                 "26508",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.testMultiValues1bind[2: autoCommit=NO, binary=REGULAR]":                                                                                                                                                       "26508",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.testMultiValues1bind[3: autoCommit=NO, binary=FORCE]":                                                                                                                                                         "26508",
	"org.postgresql.test.jdbc2.BlobTest.testGetBytesOffset":                                                                                                                    "26725",
	"org.postgresql.test.jdbc2.BlobTest.testLargeLargeObject":                                                                                                                  "26725",
	"org.postgresql.test.jdbc2.BlobTest.testMarkResetStream":                                                                                                                   "26725",
	"org.postgresql.test.jdbc2.BlobTest.testMultipleStreams":                                                                                                                   "26725",
	"org.postgresql.test.jdbc2.BlobTest.testParallelStreams":                                                                                                                   "26725",
	"org.postgresql.test.jdbc2.BlobTest.testSet":                                                                                                                               "26725",
	"org.postgresql.test.jdbc2.BlobTest.testSetNull":                                                                                                                           "26725",
	"org.postgresql.test.jdbc2.BlobTest.testUploadBlob_LOOP":                                                                                                                   "26725",
	"org.postgresql.test.jdbc2.BlobTest.testUploadBlob_NATIVE":                                                                                                                 "26725",
	"org.postgresql.test.jdbc2.BlobTransactionTest.testConcurrentReplace":                                                                                                      "17511",
	"org.postgresql.test.jdbc2.CallableStmtTest.testBadStmt":                                                                                                                   "17511",
	"org.postgresql.test.jdbc2.CallableStmtTest.testBatchCall":                                                                                                                 "17511",
	"org.postgresql.test.jdbc2.CallableStmtTest.testFetchBeforeExecute":                                                                                                        "17511",
	"org.postgresql.test.jdbc2.CallableStmtTest.testFetchWithNoResults":                                                                                                        "17511",
	"org.postgresql.test.jdbc2.CallableStmtTest.testGetArray":                                                                                                                  "17511",
	"org.postgresql.test.jdbc2.CallableStmtTest.testGetDouble":                                                                                                                 "17511",
	"org.postgresql.test.jdbc2.CallableStmtTest.testGetInt":                                                                                                                    "17511",
	"org.postgresql.test.jdbc2.CallableStmtTest.testGetNumeric":                                                                                                                "17511",
	"org.postgresql.test.jdbc2.CallableStmtTest.testGetNumericWithoutArg":                                                                                                      "17511",
	"org.postgresql.test.jdbc2.CallableStmtTest.testGetShort":                                                                                                                  "17511",
	"org.postgresql.test.jdbc2.CallableStmtTest.testGetString":                                                                                                                 "17511",
	"org.postgresql.test.jdbc2.CallableStmtTest.testGetUpdateCount":                                                                                                            "17511",
	"org.postgresql.test.jdbc2.CallableStmtTest.testRaiseNotice":                                                                                                               "17511",
	"org.postgresql.test.jdbc2.CallableStmtTest.testWasNullBeforeFetch":                                                                                                        "17511",
	"org.postgresql.test.jdbc2.ClientEncodingTest.setEncodingAscii[allowEncodingChanges=false]":                                                                                "37129",
	"org.postgresql.test.jdbc2.ClientEncodingTest.setEncodingAscii[allowEncodingChanges=true]":                                                                                 "37129",
	"org.postgresql.test.jdbc2.ConcurrentStatementFetch.testFetchTwoStatements[6: fetch(autoCommit=NO, fetchSize=1, binaryMode=REGULAR)]":                                      "4035",
	"org.postgresql.test.jdbc2.ConcurrentStatementFetch.testFetchTwoStatements[7: fetch(autoCommit=NO, fetchSize=1, binaryMode=FORCE)]":                                        "4035",
	"org.postgresql.test.jdbc2.ConcurrentStatementFetch.testFetchTwoStatements[8: fetch(autoCommit=NO, fetchSize=2, binaryMode=REGULAR)]":                                      "4035",
	"org.postgresql.test.jdbc2.ConcurrentStatementFetch.testFetchTwoStatements[9: fetch(autoCommit=NO, fetchSize=2, binaryMode=FORCE)]":                                        "4035",
	"org.postgresql.test.jdbc2.ConnectionTest.testCreateStatement":                                                                                                             "41578",
	"org.postgresql.test.jdbc2.ConnectionTest.testDoubleClose":                                                                                                                 "41578",
	"org.postgresql.test.jdbc2.ConnectionTest.testIsClosed":                                                                                                                    "41578",
	"org.postgresql.test.jdbc2.ConnectionTest.testNativeSQL":                                                                                                                   "41578",
	"org.postgresql.test.jdbc2.ConnectionTest.testPrepareCall":                                                                                                                 "41578",
	"org.postgresql.test.jdbc2.ConnectionTest.testPrepareStatement":                                                                                                            "41578",
	"org.postgresql.test.jdbc2.ConnectionTest.testReadOnly_always":                                                                                                             "41578",
	"org.postgresql.test.jdbc2.ConnectionTest.testReadOnly_ignore":                                                                                                             "41578",
	"org.postgresql.test.jdbc2.ConnectionTest.testReadOnly_transaction":                                                                                                        "41578",
	"org.postgresql.test.jdbc2.ConnectionTest.testTransactionIsolation":                                                                                                        "41578",
	"org.postgresql.test.jdbc2.ConnectionTest.testTransactions":                                                                                                                "41578",
	"org.postgresql.test.jdbc2.ConnectionTest.testTypeMaps":                                                                                                                    "41578",
	"org.postgresql.test.jdbc2.ConnectionTest.testWarnings":                                                                                                                    "41578",
	"org.postgresql.test.jdbc2.CopyTest.testChangeDateStyle":                                                                                                                   "41608",
	"org.postgresql.test.jdbc2.CopyTest.testCopyOut":                                                                                                                           "41608",
	"org.postgresql.test.jdbc2.CopyTest.testCopyOutByRow":                                                                                                                      "41608",
	"org.postgresql.test.jdbc2.CopyTest.testCopyQuery":                                                                                                                         "41608",
	"org.postgresql.test.jdbc2.CopyTest.testLockReleaseOnCancelFailure":                                                                                                        "41608",
	"org.postgresql.test.jdbc2.CursorFetchTest.testMultistatement[binary = FORCE]":                                                                                             "40195",
	"org.postgresql.test.jdbc2.CursorFetchTest.testMultistatement[binary = REGULAR]":                                                                                           "40195",
	"org.postgresql.test.jdbc2.DatabaseEncodingTest.testEncoding":                                                                                                              "41771",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testArrayInt4DoubleDim":                                                                                                    "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testArrayTypeInfo":                                                                                                         "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testAscDescIndexInfo":                                                                                                      "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testBestRowIdentifier":                                                                                                     "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testCatalogs":                                                                                                              "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testColumnPrivileges":                                                                                                      "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testColumns":                                                                                                               "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testCrossReference":                                                                                                        "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testCustomArrayTypeInfo":                                                                                                   "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testDomainColumnSize":                                                                                                      "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testDroppedColumns":                                                                                                        "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testEscaping":                                                                                                              "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testForeignKeyActions":                                                                                                     "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testForeignKeys":                                                                                                           "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testForeignKeysToUniqueIndexes":                                                                                            "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testFuncReturningComposite":                                                                                                "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testFuncReturningTable":                                                                                                    "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testFuncWithDirection":                                                                                                     "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testFuncWithNames":                                                                                                         "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testFuncWithoutNames":                                                                                                      "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testFunctionColumns":                                                                                                       "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testGetSQLKeywords":                                                                                                        "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testGetUDT1":                                                                                                               "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testGetUDT2":                                                                                                               "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testGetUDT3":                                                                                                               "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testGetUDT4":                                                                                                               "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testGetUDTQualified":                                                                                                       "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testIdentityColumns":                                                                                                       "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testIndexInfo":                                                                                                             "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testInformationAboutArrayTypes":                                                                                            "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testMultiColumnForeignKeys":                                                                                                "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testNoTablePrivileges":                                                                                                     "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testNotNullDomainColumn":                                                                                                   "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testPartialIndexInfo":                                                                                                      "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testPartitionedTables":                                                                                                     "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testPrimaryKeys":                                                                                                           "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testProcedures":                                                                                                            "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testSameTableForeignKeys":                                                                                                  "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testSchemas":                                                                                                               "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testSearchStringEscape":                                                                                                    "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testSerialColumns":                                                                                                         "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testTablePrivileges":                                                                                                       "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testTableTypes":                                                                                                            "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testTables":                                                                                                                "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testTypeInfoQuoting":                                                                                                       "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testTypeInfoSigned":                                                                                                        "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testTypes":                                                                                                                 "17511",
	"org.postgresql.test.jdbc2.DatabaseMetaDataTest.testVersionColumns":                                                                                                        "17511",
	"org.postgresql.test.jdbc2.DateStyleTest.conenct[dateStyle=ISO,ymd, shouldPass=true]":                                                                                      "41773",
	"org.postgresql.test.jdbc2.DateStyleTest.conenct[dateStyle=PostgreSQL, shouldPass=false]":                                                                                  "41773",
	"org.postgresql.test.jdbc2.GeometricTest.testPGbox[binary = FORCE]":                                                                                                        "21286",
	"org.postgresql.test.jdbc2.GeometricTest.testPGbox[binary = REGULAR]":                                                                                                      "21286",
	"org.postgresql.test.jdbc2.GeometricTest.testPGcircle[binary = FORCE]":                                                                                                     "21286",
	"org.postgresql.test.jdbc2.GeometricTest.testPGcircle[binary = REGULAR]":                                                                                                   "21286",
	"org.postgresql.test.jdbc2.GeometricTest.testPGline[binary = FORCE]":                                                                                                       "21286",
	"org.postgresql.test.jdbc2.GeometricTest.testPGline[binary = REGULAR]":                                                                                                     "21286",
	"org.postgresql.test.jdbc2.GeometricTest.testPGlseg[binary = FORCE]":                                                                                                       "21286",
	"org.postgresql.test.jdbc2.GeometricTest.testPGlseg[binary = REGULAR]":                                                                                                     "21286",
	"org.postgresql.test.jdbc2.GeometricTest.testPGpath[binary = FORCE]":                                                                                                       "21286",
	"org.postgresql.test.jdbc2.GeometricTest.testPGpath[binary = REGULAR]":                                                                                                     "21286",
	"org.postgresql.test.jdbc2.GeometricTest.testPGpoint[binary = FORCE]":                                                                                                      "21286",
	"org.postgresql.test.jdbc2.GeometricTest.testPGpoint[binary = REGULAR]":                                                                                                    "21286",
	"org.postgresql.test.jdbc2.GeometricTest.testPGpolygon[binary = FORCE]":                                                                                                    "21286",
	"org.postgresql.test.jdbc2.GeometricTest.testPGpolygon[binary = REGULAR]":                                                                                                  "21286",
	"org.postgresql.test.jdbc2.GetXXXTest.testGetObject":                                                                                                                       "5807",
	"org.postgresql.test.jdbc2.GetXXXTest.testGetUDT":                                                                                                                          "5807",
	"org.postgresql.test.jdbc2.JBuilderTest.testMoney":                                                                                                                         "41578",
	"org.postgresql.test.jdbc2.MiscTest.testWarning":                                                                                                                           "5807",
	"org.postgresql.test.jdbc2.NotifyTest.testAsyncNotify":                                                                                                                     "41522",
	"org.postgresql.test.jdbc2.NotifyTest.testAsyncNotifyWithEndlessTimeoutAndMessagesAvailableWhenStartingListening":                                                          "41522",
	"org.postgresql.test.jdbc2.NotifyTest.testAsyncNotifyWithEndlessTimeoutAndMessagesSendAfter":                                                                               "41522",
	"org.postgresql.test.jdbc2.NotifyTest.testAsyncNotifyWithTimeout":                                                                                                          "41522",
	"org.postgresql.test.jdbc2.NotifyTest.testAsyncNotifyWithTimeoutAndMessagesAvailableWhenStartingListening":                                                                 "41522",
	"org.postgresql.test.jdbc2.NotifyTest.testAsyncNotifyWithTimeoutAndMessagesSendAfter":                                                                                      "41522",
	"org.postgresql.test.jdbc2.NotifyTest.testAsyncNotifyWithTimeoutAndSocketThatBecomesClosed":                                                                                "41522",
	"org.postgresql.test.jdbc2.NotifyTest.testNotify":                                                                                                                          "41522",
	"org.postgresql.test.jdbc2.NotifyTest.testNotifyArgument":                                                                                                                  "41522",
	"org.postgresql.test.jdbc2.PGTimeTest.testTimeInsertAndSelect":                                                                                                             "5807",
	"org.postgresql.test.jdbc2.PGTimeTest.testTimeWithInterval":                                                                                                                "5807",
	"org.postgresql.test.jdbc2.PGTimestampTest.testTimeInsertAndSelect":                                                                                                        "41775",
	"org.postgresql.test.jdbc2.ParameterStatusTest.expectedInitialParameters":                                                                                                  "41776",
	"org.postgresql.test.jdbc2.ParameterStatusTest.parameterMapIsView":                                                                                                         "40854",
	"org.postgresql.test.jdbc2.ParameterStatusTest.reportUpdatedParameters":                                                                                                    "40854",
	"org.postgresql.test.jdbc2.ParameterStatusTest.transactionalParametersAutocommit":                                                                                          "40854",
	"org.postgresql.test.jdbc2.ParameterStatusTest.transactionalParametersCommit":                                                                                              "40854",
	"org.postgresql.test.jdbc2.ParameterStatusTest.transactionalParametersRollback":                                                                                            "40854",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testBatchWithPrepareThreshold0[binary = REGULAR]":                                                                         "5807",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testBatchWithPrepareThreshold5[binary = REGULAR]":                                                                         "5807",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testDollarQuotesAndIdentifiers[binary = FORCE]":                                                                           "5807",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testDollarQuotesAndIdentifiers[binary = REGULAR]":                                                                         "5807",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testDollarQuotes[binary = FORCE]":                                                                                         "41777",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testDollarQuotes[binary = REGULAR]":                                                                                       "41777",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testDoubleQuestionMark[binary = FORCE]":                                                                                   "21286",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testDoubleQuestionMark[binary = REGULAR]":                                                                                 "21286",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testDouble[binary = FORCE]":                                                                                               "5807",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testDouble[binary = REGULAR]":                                                                                             "5807",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testFloat[binary = FORCE]":                                                                                                "5807",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testFloat[binary = REGULAR]":                                                                                              "5807",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testNumeric[binary = FORCE]":                                                                                              "5807",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testNumeric[binary = REGULAR]":                                                                                            "5807",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testSelectPrepareThreshold0AutoCommitFalseFetchSizeNonZero[binary = REGULAR]":                                             "41778",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testSetBooleanDecimal[binary = FORCE]":                                                                                    "5807",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testSetBooleanDecimal[binary = REGULAR]":                                                                                  "5807",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testSetBooleanDouble[binary = FORCE]":                                                                                     "5807",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testSetBooleanDouble[binary = REGULAR]":                                                                                   "5807",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testSetBooleanNumeric[binary = FORCE]":                                                                                    "5807",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testSetBooleanNumeric[binary = REGULAR]":                                                                                  "5807",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testSetFloatBigDecimal[binary = FORCE]":                                                                                   "5807",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testSetFloatBigDecimal[binary = REGULAR]":                                                                                 "5807",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testSetFloatInteger[binary = FORCE]":                                                                                      "5807",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testSetFloatInteger[binary = REGULAR]":                                                                                    "5807",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testSetFloatString[binary = FORCE]":                                                                                       "5807",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testSetFloatString[binary = REGULAR]":                                                                                     "5807",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testSetIntFloat[binary = FORCE]":                                                                                          "5807",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testSetIntFloat[binary = REGULAR]":                                                                                        "5807",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testSetObjectBigDecimalUnscaled[binary = FORCE]":                                                                          "5807",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testSetObjectBigDecimalUnscaled[binary = REGULAR]":                                                                        "5807",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testSetObjectBigDecimalWithScale[binary = FORCE]":                                                                         "5807",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testSetObjectBigDecimalWithScale[binary = REGULAR]":                                                                       "5807",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testSetObjectNumberFallbackWithAtomicLong[binary = FORCE]":                                                                "5807",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testSetObjectNumberFallbackWithAtomicLong[binary = REGULAR]":                                                              "5807",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testSetObjectNumberFallbackWithBigInteger[binary = FORCE]":                                                                "5807",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testSetObjectNumberFallbackWithBigInteger[binary = REGULAR]":                                                              "5807",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testSetObjectWithBigDecimal[binary = FORCE]":                                                                              "5807",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testSetObjectWithBigDecimal[binary = REGULAR]":                                                                            "5807",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testSetSmallIntFloat[binary = FORCE]":                                                                                     "5807",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testSetSmallIntFloat[binary = REGULAR]":                                                                                   "5807",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testSetTinyIntFloat[binary = FORCE]":                                                                                      "5807",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testSetTinyIntFloat[binary = REGULAR]":                                                                                    "5807",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testSingleQuotes[binary = FORCE]":                                                                                         "36215",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testSingleQuotes[binary = REGULAR]":                                                                                       "36215",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testUnknownSetObject[binary = FORCE]":                                                                                     "41779",
	"org.postgresql.test.jdbc2.PreparedStatementTest.testUnknownSetObject[binary = REGULAR]":                                                                                   "41779",
	"org.postgresql.test.jdbc2.RefCursorTest.testEmptyResult[typeName = OTHER, cursorType = 1,111]":                                                                            "17511",
	"org.postgresql.test.jdbc2.RefCursorTest.testEmptyResult[typeName = REF_CURSOR, cursorType = 2,012]":                                                                       "17511",
	"org.postgresql.test.jdbc2.RefCursorTest.testMetaData[typeName = OTHER, cursorType = 1,111]":                                                                               "17511",
	"org.postgresql.test.jdbc2.RefCursorTest.testMetaData[typeName = REF_CURSOR, cursorType = 2,012]":                                                                          "17511",
	"org.postgresql.test.jdbc2.RefCursorTest.testResultType[typeName = OTHER, cursorType = 1,111]":                                                                             "17511",
	"org.postgresql.test.jdbc2.RefCursorTest.testResultType[typeName = REF_CURSOR, cursorType = 2,012]":                                                                        "17511",
	"org.postgresql.test.jdbc2.RefCursorTest.testResult[typeName = OTHER, cursorType = 1,111]":                                                                                 "17511",
	"org.postgresql.test.jdbc2.RefCursorTest.testResult[typeName = REF_CURSOR, cursorType = 2,012]":                                                                            "17511",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testCache[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = 0]":                                           "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testCache[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = null]":                                        "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testCache[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = 0]":                                        "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testCache[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = null]":                                     "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testClassesMatch[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = 0]":                                    "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testClassesMatch[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = null]":                                 "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testClassesMatch[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = 0]":                                 "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testClassesMatch[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = null]":                              "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testClosedResultSet[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = 0]":                                 "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testClosedResultSet[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = null]":                              "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testClosedResultSet[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = 0]":                              "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testClosedResultSet[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = null]":                           "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testColumnDisplaySize[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = 0]":                               "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testColumnDisplaySize[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = null]":                            "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testColumnDisplaySize[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = 0]":                            "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testColumnDisplaySize[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = null]":                         "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testComposite[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = 0]":                                       "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testComposite[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = null]":                                    "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testComposite[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = 0]":                                    "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testComposite[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = null]":                                 "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testDatabaseMetaDataNames[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = 0]":                           "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testDatabaseMetaDataNames[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = null]":                        "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testDatabaseMetaDataNames[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = 0]":                        "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testDatabaseMetaDataNames[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = null]":                     "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testIdentityColumn[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = 0]":                                  "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testIdentityColumn[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = null]":                               "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testIdentityColumn[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = 0]":                               "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testIdentityColumn[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = null]":                            "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testIsAutoIncrement[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = 0]":                                 "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testIsAutoIncrement[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = null]":                              "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testIsAutoIncrement[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = 0]":                              "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testIsAutoIncrement[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = null]":                           "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testPreparedResultSet[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = 0]":                               "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testPreparedResultSet[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = null]":                            "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testPreparedResultSet[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = 0]":                            "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testPreparedResultSet[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = null]":                         "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testPreparedUpdate[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = 0]":                                  "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testPreparedUpdate[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = null]":                               "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testPreparedUpdate[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = 0]":                               "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testPreparedUpdate[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = null]":                            "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testStandardResultSet[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = 0]":                               "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testStandardResultSet[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = null]":                            "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testStandardResultSet[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = 0]":                            "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testStandardResultSet[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = null]":                         "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testTimestampInfo[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = 0]":                                   "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testTimestampInfo[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = null]":                                "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testTimestampInfo[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = 0]":                                "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testTimestampInfo[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = null]":                             "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testUnexecutedStatement[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = 0]":                             "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testUnexecutedStatement[databaseMetadataCacheFields = 0, databaseMetadataCacheFieldsMib = null]":                          "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testUnexecutedStatement[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = 0]":                          "32565",
	"org.postgresql.test.jdbc2.ResultSetMetaDataTest.testUnexecutedStatement[databaseMetadataCacheFields = null, databaseMetadataCacheFieldsMib = null]":                       "32565",
	"org.postgresql.test.jdbc2.ResultSetTest.testUpdateWithPGobject":                                                                                                           "41781",
	"org.postgresql.test.jdbc2.ResultSetTest.testgetBadBoolean":                                                                                                                "32552",
	"org.postgresql.test.jdbc2.SearchPathLookupTest.testSearchPathBackwardsCompatibleLookup":                                                                                   "26443",
	"org.postgresql.test.jdbc2.SearchPathLookupTest.testSearchPathHiddenLookup":                                                                                                "26443",
	"org.postgresql.test.jdbc2.SearchPathLookupTest.testSearchPathNormalLookup":                                                                                                "26443",
	"org.postgresql.test.jdbc2.ServerCursorTest.testBasicFetch":                                                                                                                "41412",
	"org.postgresql.test.jdbc2.ServerCursorTest.testBinaryFetch":                                                                                                               "41412",
	"org.postgresql.test.jdbc2.ServerErrorTest.testColumn":                                                                                                                     "27796",
	"org.postgresql.test.jdbc2.ServerErrorTest.testDatatype":                                                                                                                   "27796",
	"org.postgresql.test.jdbc2.ServerErrorTest.testPrimaryKey":                                                                                                                 "27796",
	"org.postgresql.test.jdbc2.StatementTest.testClose":                                                                                                                        "17511",
	"org.postgresql.test.jdbc2.StatementTest.testCloseInProgressStatement":                                                                                                     "17511",
	"org.postgresql.test.jdbc2.StatementTest.testConcurrentWarningReadAndClear":                                                                                                "17511",
	"org.postgresql.test.jdbc2.StatementTest.testDateFuncWithParam":                                                                                                            "17511",
	"org.postgresql.test.jdbc2.StatementTest.testDateFunctions":                                                                                                                "17511",
	"org.postgresql.test.jdbc2.StatementTest.testDollarInComment":                                                                                                              "17511",
	"org.postgresql.test.jdbc2.StatementTest.testDollarInCommentTwoComments":                                                                                                   "17511",
	"org.postgresql.test.jdbc2.StatementTest.testDoubleClose":                                                                                                                  "17511",
	"org.postgresql.test.jdbc2.StatementTest.testEmptyQuery":                                                                                                                   "17511",
	"org.postgresql.test.jdbc2.StatementTest.testEscapeProcessing":                                                                                                             "17511",
	"org.postgresql.test.jdbc2.StatementTest.testExecuteUpdateFailsOnMultiStatementSelect":                                                                                     "17511",
	"org.postgresql.test.jdbc2.StatementTest.testExecuteUpdateFailsOnSelect":                                                                                                   "17511",
	"org.postgresql.test.jdbc2.StatementTest.testFastCloses":                                                                                                                   "17511",
	"org.postgresql.test.jdbc2.StatementTest.testJavascriptFunction":                                                                                                           "17511",
	"org.postgresql.test.jdbc2.StatementTest.testLongQueryTimeout":                                                                                                             "17511",
	"org.postgresql.test.jdbc2.StatementTest.testMultiExecute":                                                                                                                 "17511",
	"org.postgresql.test.jdbc2.StatementTest.testMultipleCancels":                                                                                                              "17511",
	"org.postgresql.test.jdbc2.StatementTest.testNumericFunctions":                                                                                                             "17511",
	"org.postgresql.test.jdbc2.StatementTest.testParsingDollarQuotes":                                                                                                          "17511",
	"org.postgresql.test.jdbc2.StatementTest.testParsingSemiColons":                                                                                                            "17511",
	"org.postgresql.test.jdbc2.StatementTest.testPreparedFunction":                                                                                                             "17511",
	"org.postgresql.test.jdbc2.StatementTest.testResultSetTwice":                                                                                                               "17511",
	"org.postgresql.test.jdbc2.StatementTest.testSetQueryTimeout":                                                                                                              "17511",
	"org.postgresql.test.jdbc2.StatementTest.testSetQueryTimeoutOnPrepared":                                                                                                    "17511",
	"org.postgresql.test.jdbc2.StatementTest.testSetQueryTimeoutWithSleep":                                                                                                     "17511",
	"org.postgresql.test.jdbc2.StatementTest.testSetQueryTimeoutWithoutExecute":                                                                                                "17511",
	"org.postgresql.test.jdbc2.StatementTest.testShortQueryTimeout":                                                                                                            "17511",
	"org.postgresql.test.jdbc2.StatementTest.testSideStatementFinalizers":                                                                                                      "17511",
	"org.postgresql.test.jdbc2.StatementTest.testStringFunctions":                                                                                                              "17511",
	"org.postgresql.test.jdbc2.StatementTest.testSystemFunctions":                                                                                                              "17511",
	"org.postgresql.test.jdbc2.StatementTest.testUnbalancedParensParseError":                                                                                                   "17511",
	"org.postgresql.test.jdbc2.StatementTest.testUnterminatedComment":                                                                                                          "17511",
	"org.postgresql.test.jdbc2.StatementTest.testUnterminatedDollarQuotes":                                                                                                     "17511",
	"org.postgresql.test.jdbc2.StatementTest.testUnterminatedIdentifier":                                                                                                       "17511",
	"org.postgresql.test.jdbc2.StatementTest.testUnterminatedLiteral":                                                                                                          "17511",
	"org.postgresql.test.jdbc2.StatementTest.testUnterminatedNamedDollarQuotes":                                                                                                "17511",
	"org.postgresql.test.jdbc2.StatementTest.testUpdateCount":                                                                                                                  "17511",
	"org.postgresql.test.jdbc2.StatementTest.testWarningsAreAvailableAsap":                                                                                                     "17511",
	"org.postgresql.test.jdbc2.StatementTest.testWarningsAreCleared":                                                                                                           "17511",
	"org.postgresql.test.jdbc2.StringTypeUnspecifiedArrayTest.testCreateArrayWithNonCachedType[binary = FORCE]":                                                                "21286",
	"org.postgresql.test.jdbc2.StringTypeUnspecifiedArrayTest.testCreateArrayWithNonCachedType[binary = REGULAR]":                                                              "21286",
	"org.postgresql.test.jdbc2.TimeTest.testGetTime":                                                                                                                           "5807",
	"org.postgresql.test.jdbc2.TimeTest.testGetTimeZone":                                                                                                                       "5807",
	"org.postgresql.test.jdbc2.TimeTest.testSetTime":                                                                                                                           "5807",
	"org.postgresql.test.jdbc2.TimestampTest.testGetTimestampWOTZ[binary = FORCE]":                                                                                             "41786",
	"org.postgresql.test.jdbc2.TimestampTest.testGetTimestampWOTZ[binary = REGULAR]":                                                                                           "41786",
	"org.postgresql.test.jdbc2.TimestampTest.testInfinity[binary = FORCE]":                                                                                                     "41786",
	"org.postgresql.test.jdbc2.TimestampTest.testInfinity[binary = REGULAR]":                                                                                                   "41786",
	"org.postgresql.test.jdbc2.TimestampTest.testSetTimestampWOTZ[binary = FORCE]":                                                                                             "41786",
	"org.postgresql.test.jdbc2.TimestampTest.testSetTimestampWOTZ[binary = REGULAR]":                                                                                           "41786",
	"org.postgresql.test.jdbc2.TimezoneTest.testGetDate":                                                                                                                       "41776",
	"org.postgresql.test.jdbc2.TimezoneTest.testGetTime":                                                                                                                       "41776",
	"org.postgresql.test.jdbc2.TimezoneTest.testGetTimestamp":                                                                                                                  "41776",
	"org.postgresql.test.jdbc2.TimezoneTest.testHalfHourTimezone":                                                                                                              "41776",
	"org.postgresql.test.jdbc2.TimezoneTest.testLocalTimestampsInAfricaCasablanca":                                                                                             "41776",
	"org.postgresql.test.jdbc2.TimezoneTest.testLocalTimestampsInAmericaAdak":                                                                                                  "41776",
	"org.postgresql.test.jdbc2.TimezoneTest.testLocalTimestampsInAtlanticAzores":                                                                                               "41776",
	"org.postgresql.test.jdbc2.TimezoneTest.testLocalTimestampsInEuropeMoscow":                                                                                                 "41776",
	"org.postgresql.test.jdbc2.TimezoneTest.testLocalTimestampsInNonDSTZones":                                                                                                  "41776",
	"org.postgresql.test.jdbc2.TimezoneTest.testLocalTimestampsInPacificApia":                                                                                                  "41776",
	"org.postgresql.test.jdbc2.TimezoneTest.testLocalTimestampsInPacificNiue":                                                                                                  "41776",
	"org.postgresql.test.jdbc2.TimezoneTest.testSetDate":                                                                                                                       "41776",
	"org.postgresql.test.jdbc2.TimezoneTest.testSetTime":                                                                                                                       "41776",
	"org.postgresql.test.jdbc2.TimezoneTest.testSetTimestamp":                                                                                                                  "41776",
	"org.postgresql.test.jdbc2.TimezoneTest.testSetTimestampOnTime":                                                                                                            "41776",
	"org.postgresql.test.jdbc2.TimezoneTest.testTimezoneWithSeconds":                                                                                                           "41776",
	"org.postgresql.test.jdbc2.UpdateableResultTest.simpleAndUpdateableSameQuery":                                                                                              "19141",
	"org.postgresql.test.jdbc2.UpdateableResultTest.testArray":                                                                                                                 "19141",
	"org.postgresql.test.jdbc2.UpdateableResultTest.testBadColumnIndexes":                                                                                                      "19141",
	"org.postgresql.test.jdbc2.UpdateableResultTest.testCancelRowUpdates":                                                                                                      "19141",
	"org.postgresql.test.jdbc2.UpdateableResultTest.testDeleteRows":                                                                                                            "19141",
	"org.postgresql.test.jdbc2.UpdateableResultTest.testInsertRowIllegalMethods":                                                                                               "19141",
	"org.postgresql.test.jdbc2.UpdateableResultTest.testMultiColumnUpdate":                                                                                                     "19141",
	"org.postgresql.test.jdbc2.UpdateableResultTest.testMultiColumnUpdateWithoutAllColumns":                                                                                    "19141",
	"org.postgresql.test.jdbc2.UpdateableResultTest.testPositioning":                                                                                                           "19141",
	"org.postgresql.test.jdbc2.UpdateableResultTest.testUpdateReadOnlyResultSet":                                                                                               "19141",
	"org.postgresql.test.jdbc2.UpdateableResultTest.testUpdateSelectOnly":                                                                                                      "19141",
	"org.postgresql.test.jdbc2.UpdateableResultTest.testUpdateStreams":                                                                                                         "19141",
	"org.postgresql.test.jdbc2.UpdateableResultTest.testUpdateTimestamp":                                                                                                       "19141",
	"org.postgresql.test.jdbc2.UpdateableResultTest.testUpdateable":                                                                                                            "19141",
	"org.postgresql.test.jdbc2.UpdateableResultTest.testUpdateablePreparedStatement":                                                                                           "19141",
	"org.postgresql.test.jdbc2.UpdateableResultTest.testZeroRowResult":                                                                                                         "19141",
	"org.postgresql.test.jdbc2.UpsertTest.testMultiValuedUpsertBatch[binary = FORCE, reWriteBatchedInserts = NO]":                                                              "5807",
	"org.postgresql.test.jdbc2.UpsertTest.testMultiValuedUpsertBatch[binary = FORCE, reWriteBatchedInserts = YES]":                                                             "5807",
	"org.postgresql.test.jdbc2.UpsertTest.testMultiValuedUpsertBatch[binary = REGULAR, reWriteBatchedInserts = NO]":                                                            "5807",
	"org.postgresql.test.jdbc2.UpsertTest.testMultiValuedUpsertBatch[binary = REGULAR, reWriteBatchedInserts = YES]":                                                           "5807",
	"org.postgresql.test.jdbc2.UpsertTest.testSingleValuedUpsertBatch[binary = FORCE, reWriteBatchedInserts = NO]":                                                             "5807",
	"org.postgresql.test.jdbc2.UpsertTest.testSingleValuedUpsertBatch[binary = FORCE, reWriteBatchedInserts = YES]":                                                            "5807",
	"org.postgresql.test.jdbc2.UpsertTest.testSingleValuedUpsertBatch[binary = REGULAR, reWriteBatchedInserts = NO]":                                                           "5807",
	"org.postgresql.test.jdbc2.UpsertTest.testSingleValuedUpsertBatch[binary = REGULAR, reWriteBatchedInserts = YES]":                                                          "5807",
	"org.postgresql.test.jdbc2.UpsertTest.testSingleValuedUpsertUpdateBatch[binary = FORCE, reWriteBatchedInserts = NO]":                                                       "5807",
	"org.postgresql.test.jdbc2.UpsertTest.testSingleValuedUpsertUpdateBatch[binary = FORCE, reWriteBatchedInserts = YES]":                                                      "5807",
	"org.postgresql.test.jdbc2.UpsertTest.testSingleValuedUpsertUpdateBatch[binary = REGULAR, reWriteBatchedInserts = NO]":                                                     "5807",
	"org.postgresql.test.jdbc2.UpsertTest.testSingleValuedUpsertUpdateBatch[binary = REGULAR, reWriteBatchedInserts = YES]":                                                    "5807",
	"org.postgresql.test.jdbc2.UpsertTest.testSingleValuedUpsertUpdateConstantBatch[binary = FORCE, reWriteBatchedInserts = NO]":                                               "5807",
	"org.postgresql.test.jdbc2.UpsertTest.testSingleValuedUpsertUpdateConstantBatch[binary = FORCE, reWriteBatchedInserts = YES]":                                              "5807",
	"org.postgresql.test.jdbc2.UpsertTest.testSingleValuedUpsertUpdateConstantBatch[binary = REGULAR, reWriteBatchedInserts = NO]":                                             "5807",
	"org.postgresql.test.jdbc2.UpsertTest.testSingleValuedUpsertUpdateConstantBatch[binary = REGULAR, reWriteBatchedInserts = YES]":                                            "5807",
	"org.postgresql.test.jdbc2.UpsertTest.testUpsertDoNothingConflict[binary = FORCE, reWriteBatchedInserts = NO]":                                                             "5807",
	"org.postgresql.test.jdbc2.UpsertTest.testUpsertDoNothingConflict[binary = FORCE, reWriteBatchedInserts = YES]":                                                            "5807",
	"org.postgresql.test.jdbc2.UpsertTest.testUpsertDoNothingConflict[binary = REGULAR, reWriteBatchedInserts = NO]":                                                           "5807",
	"org.postgresql.test.jdbc2.UpsertTest.testUpsertDoNothingConflict[binary = REGULAR, reWriteBatchedInserts = YES]":                                                          "5807",
	"org.postgresql.test.jdbc2.UpsertTest.testUpsertDoNothingNoConflict[binary = FORCE, reWriteBatchedInserts = NO]":                                                           "5807",
	"org.postgresql.test.jdbc2.UpsertTest.testUpsertDoNothingNoConflict[binary = FORCE, reWriteBatchedInserts = YES]":                                                          "5807",
	"org.postgresql.test.jdbc2.UpsertTest.testUpsertDoNothingNoConflict[binary = REGULAR, reWriteBatchedInserts = NO]":                                                         "5807",
	"org.postgresql.test.jdbc2.UpsertTest.testUpsertDoNothingNoConflict[binary = REGULAR, reWriteBatchedInserts = YES]":                                                        "5807",
	"org.postgresql.test.jdbc2.UpsertTest.testUpsertDoUpdateConflict[binary = FORCE, reWriteBatchedInserts = NO]":                                                              "5807",
	"org.postgresql.test.jdbc2.UpsertTest.testUpsertDoUpdateConflict[binary = FORCE, reWriteBatchedInserts = YES]":                                                             "5807",
	"org.postgresql.test.jdbc2.UpsertTest.testUpsertDoUpdateConflict[binary = REGULAR, reWriteBatchedInserts = NO]":                                                            "5807",
	"org.postgresql.test.jdbc2.UpsertTest.testUpsertDoUpdateConflict[binary = REGULAR, reWriteBatchedInserts = YES]":                                                           "5807",
	"org.postgresql.test.jdbc2.UpsertTest.testUpsertDoUpdateNoConflict[binary = FORCE, reWriteBatchedInserts = NO]":                                                            "5807",
	"org.postgresql.test.jdbc2.UpsertTest.testUpsertDoUpdateNoConflict[binary = FORCE, reWriteBatchedInserts = YES]":                                                           "5807",
	"org.postgresql.test.jdbc2.UpsertTest.testUpsertDoUpdateNoConflict[binary = REGULAR, reWriteBatchedInserts = NO]":                                                          "5807",
	"org.postgresql.test.jdbc2.UpsertTest.testUpsertDoUpdateNoConflict[binary = REGULAR, reWriteBatchedInserts = YES]":                                                         "5807",
	"org.postgresql.test.jdbc3.CompositeTest.testComplexArgumentSelect":                                                                                                        "27793",
	"org.postgresql.test.jdbc3.CompositeTest.testComplexSelect":                                                                                                                "27793",
	"org.postgresql.test.jdbc3.CompositeTest.testComplexTableNameMetadata":                                                                                                     "27793",
	"org.postgresql.test.jdbc3.CompositeTest.testCompositeFromTable":                                                                                                           "27793",
	"org.postgresql.test.jdbc3.CompositeTest.testNullArrayElement":                                                                                                             "27793",
	"org.postgresql.test.jdbc3.CompositeTest.testSimpleArgumentSelect":                                                                                                         "27793",
	"org.postgresql.test.jdbc3.CompositeTest.testSimpleSelect":                                                                                                                 "27793",
	"org.postgresql.test.jdbc3.CompositeTest.testTableMetadata":                                                                                                                "27793",
	"org.postgresql.test.jdbc3.DatabaseMetaDataTest.testGetColumnsForDomain":                                                                                                   "27796",
	"org.postgresql.test.jdbc3.EscapeSyntaxCallModeCallIfNoReturnTest.testInvokeFunction":                                                                                      "17511",
	"org.postgresql.test.jdbc3.EscapeSyntaxCallModeCallIfNoReturnTest.testInvokeFunctionHavingReturnParameter":                                                                 "17511",
	"org.postgresql.test.jdbc3.EscapeSyntaxCallModeCallIfNoReturnTest.testInvokeProcedure":                                                                                     "17511",
	"org.postgresql.test.jdbc3.EscapeSyntaxCallModeCallTest.testInvokeFunction":                                                                                                "17511",
	"org.postgresql.test.jdbc3.EscapeSyntaxCallModeCallTest.testInvokeFunctionHavingReturnParameter":                                                                           "17511",
	"org.postgresql.test.jdbc3.EscapeSyntaxCallModeCallTest.testInvokeProcedure":                                                                                               "17511",
	"org.postgresql.test.jdbc3.EscapeSyntaxCallModeSelectTest.testInvokeFunction":                                                                                              "17511",
	"org.postgresql.test.jdbc3.EscapeSyntaxCallModeSelectTest.testInvokeFunctionHavingReturnParameter":                                                                         "17511",
	"org.postgresql.test.jdbc3.EscapeSyntaxCallModeSelectTest.testInvokeProcedure":                                                                                             "17511",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.breakDescribeOnFirstServerPreparedExecution[returningInQuery = A, binary = FORCE]":                                            "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.breakDescribeOnFirstServerPreparedExecution[returningInQuery = A, binary = REGULAR]":                                          "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.breakDescribeOnFirstServerPreparedExecution[returningInQuery = AB, binary = FORCE]":                                           "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.breakDescribeOnFirstServerPreparedExecution[returningInQuery = AB, binary = REGULAR]":                                         "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.breakDescribeOnFirstServerPreparedExecution[returningInQuery = NO, binary = FORCE]":                                           "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.breakDescribeOnFirstServerPreparedExecution[returningInQuery = NO, binary = REGULAR]":                                         "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.breakDescribeOnFirstServerPreparedExecution[returningInQuery = STAR, binary = FORCE]":                                         "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.breakDescribeOnFirstServerPreparedExecution[returningInQuery = STAR, binary = REGULAR]":                                       "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.selectWithGeneratedKeysViaNonPrepared[returningInQuery = A, binary = FORCE]":                                                  "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.selectWithGeneratedKeysViaNonPrepared[returningInQuery = A, binary = REGULAR]":                                                "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.selectWithGeneratedKeysViaNonPrepared[returningInQuery = AB, binary = FORCE]":                                                 "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.selectWithGeneratedKeysViaNonPrepared[returningInQuery = AB, binary = REGULAR]":                                               "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.selectWithGeneratedKeysViaNonPrepared[returningInQuery = NO, binary = FORCE]":                                                 "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.selectWithGeneratedKeysViaNonPrepared[returningInQuery = NO, binary = REGULAR]":                                               "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.selectWithGeneratedKeysViaNonPrepared[returningInQuery = STAR, binary = FORCE]":                                               "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.selectWithGeneratedKeysViaNonPrepared[returningInQuery = STAR, binary = REGULAR]":                                             "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.selectWithGeneratedKeysViaPreparedExecuteQuery[returningInQuery = A, binary = FORCE]":                                         "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.selectWithGeneratedKeysViaPreparedExecuteQuery[returningInQuery = A, binary = REGULAR]":                                       "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.selectWithGeneratedKeysViaPreparedExecuteQuery[returningInQuery = AB, binary = FORCE]":                                        "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.selectWithGeneratedKeysViaPreparedExecuteQuery[returningInQuery = AB, binary = REGULAR]":                                      "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.selectWithGeneratedKeysViaPreparedExecuteQuery[returningInQuery = NO, binary = FORCE]":                                        "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.selectWithGeneratedKeysViaPreparedExecuteQuery[returningInQuery = NO, binary = REGULAR]":                                      "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.selectWithGeneratedKeysViaPreparedExecuteQuery[returningInQuery = STAR, binary = FORCE]":                                      "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.selectWithGeneratedKeysViaPreparedExecuteQuery[returningInQuery = STAR, binary = REGULAR]":                                    "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.selectWithGeneratedKeysViaPreparedExecute[returningInQuery = A, binary = FORCE]":                                              "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.selectWithGeneratedKeysViaPreparedExecute[returningInQuery = A, binary = REGULAR]":                                            "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.selectWithGeneratedKeysViaPreparedExecute[returningInQuery = AB, binary = FORCE]":                                             "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.selectWithGeneratedKeysViaPreparedExecute[returningInQuery = AB, binary = REGULAR]":                                           "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.selectWithGeneratedKeysViaPreparedExecute[returningInQuery = NO, binary = FORCE]":                                             "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.selectWithGeneratedKeysViaPreparedExecute[returningInQuery = NO, binary = REGULAR]":                                           "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.selectWithGeneratedKeysViaPreparedExecute[returningInQuery = STAR, binary = FORCE]":                                           "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.selectWithGeneratedKeysViaPreparedExecute[returningInQuery = STAR, binary = REGULAR]":                                         "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testBatchGeneratedKeys[returningInQuery = A, binary = FORCE]":                                                                 "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testBatchGeneratedKeys[returningInQuery = A, binary = REGULAR]":                                                               "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testBatchGeneratedKeys[returningInQuery = AB, binary = FORCE]":                                                                "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testBatchGeneratedKeys[returningInQuery = AB, binary = REGULAR]":                                                              "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testBatchGeneratedKeys[returningInQuery = NO, binary = FORCE]":                                                                "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testBatchGeneratedKeys[returningInQuery = NO, binary = REGULAR]":                                                              "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testBatchGeneratedKeys[returningInQuery = STAR, binary = FORCE]":                                                              "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testBatchGeneratedKeys[returningInQuery = STAR, binary = REGULAR]":                                                            "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testCloseStatementClosesRS[returningInQuery = A, binary = FORCE]":                                                             "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testCloseStatementClosesRS[returningInQuery = A, binary = REGULAR]":                                                           "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testCloseStatementClosesRS[returningInQuery = AB, binary = FORCE]":                                                            "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testCloseStatementClosesRS[returningInQuery = AB, binary = REGULAR]":                                                          "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testCloseStatementClosesRS[returningInQuery = NO, binary = FORCE]":                                                            "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testCloseStatementClosesRS[returningInQuery = NO, binary = REGULAR]":                                                          "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testCloseStatementClosesRS[returningInQuery = STAR, binary = FORCE]":                                                          "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testCloseStatementClosesRS[returningInQuery = STAR, binary = REGULAR]":                                                        "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testDelete[returningInQuery = A, binary = FORCE]":                                                                             "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testDelete[returningInQuery = A, binary = REGULAR]":                                                                           "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testDelete[returningInQuery = AB, binary = FORCE]":                                                                            "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testDelete[returningInQuery = AB, binary = REGULAR]":                                                                          "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testDelete[returningInQuery = NO, binary = FORCE]":                                                                            "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testDelete[returningInQuery = NO, binary = REGULAR]":                                                                          "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testDelete[returningInQuery = STAR, binary = FORCE]":                                                                          "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testDelete[returningInQuery = STAR, binary = REGULAR]":                                                                        "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testEmptyRSWithoutReturning[returningInQuery = A, binary = FORCE]":                                                            "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testEmptyRSWithoutReturning[returningInQuery = A, binary = REGULAR]":                                                          "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testEmptyRSWithoutReturning[returningInQuery = AB, binary = FORCE]":                                                           "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testEmptyRSWithoutReturning[returningInQuery = AB, binary = REGULAR]":                                                         "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testEmptyRSWithoutReturning[returningInQuery = NO, binary = FORCE]":                                                           "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testEmptyRSWithoutReturning[returningInQuery = NO, binary = REGULAR]":                                                         "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testEmptyRSWithoutReturning[returningInQuery = STAR, binary = FORCE]":                                                         "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testEmptyRSWithoutReturning[returningInQuery = STAR, binary = REGULAR]":                                                       "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testGeneratedKeysCleared[returningInQuery = A, binary = FORCE]":                                                               "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testGeneratedKeysCleared[returningInQuery = A, binary = REGULAR]":                                                             "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testGeneratedKeysCleared[returningInQuery = AB, binary = FORCE]":                                                              "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testGeneratedKeysCleared[returningInQuery = AB, binary = REGULAR]":                                                            "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testGeneratedKeysCleared[returningInQuery = NO, binary = FORCE]":                                                              "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testGeneratedKeysCleared[returningInQuery = NO, binary = REGULAR]":                                                            "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testGeneratedKeysCleared[returningInQuery = STAR, binary = FORCE]":                                                            "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testGeneratedKeysCleared[returningInQuery = STAR, binary = REGULAR]":                                                          "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testGeneratedKeys[returningInQuery = A, binary = FORCE]":                                                                      "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testGeneratedKeys[returningInQuery = A, binary = REGULAR]":                                                                    "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testGeneratedKeys[returningInQuery = AB, binary = FORCE]":                                                                     "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testGeneratedKeys[returningInQuery = AB, binary = REGULAR]":                                                                   "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testGeneratedKeys[returningInQuery = NO, binary = FORCE]":                                                                     "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testGeneratedKeys[returningInQuery = NO, binary = REGULAR]":                                                                   "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testGeneratedKeys[returningInQuery = STAR, binary = FORCE]":                                                                   "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testGeneratedKeys[returningInQuery = STAR, binary = REGULAR]":                                                                 "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testMultipleRows[returningInQuery = A, binary = FORCE]":                                                                       "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testMultipleRows[returningInQuery = A, binary = REGULAR]":                                                                     "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testMultipleRows[returningInQuery = AB, binary = FORCE]":                                                                      "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testMultipleRows[returningInQuery = AB, binary = REGULAR]":                                                                    "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testMultipleRows[returningInQuery = NO, binary = FORCE]":                                                                      "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testMultipleRows[returningInQuery = NO, binary = REGULAR]":                                                                    "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testMultipleRows[returningInQuery = STAR, binary = FORCE]":                                                                    "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testMultipleRows[returningInQuery = STAR, binary = REGULAR]":                                                                  "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testPSDelete[returningInQuery = A, binary = FORCE]":                                                                           "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testPSDelete[returningInQuery = A, binary = REGULAR]":                                                                         "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testPSDelete[returningInQuery = AB, binary = FORCE]":                                                                          "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testPSDelete[returningInQuery = AB, binary = REGULAR]":                                                                        "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testPSDelete[returningInQuery = NO, binary = FORCE]":                                                                          "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testPSDelete[returningInQuery = NO, binary = REGULAR]":                                                                        "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testPSDelete[returningInQuery = STAR, binary = FORCE]":                                                                        "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testPSDelete[returningInQuery = STAR, binary = REGULAR]":                                                                      "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testPSUpdate[returningInQuery = A, binary = FORCE]":                                                                           "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testPSUpdate[returningInQuery = A, binary = REGULAR]":                                                                         "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testPSUpdate[returningInQuery = AB, binary = FORCE]":                                                                          "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testPSUpdate[returningInQuery = AB, binary = REGULAR]":                                                                        "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testPSUpdate[returningInQuery = NO, binary = FORCE]":                                                                          "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testPSUpdate[returningInQuery = NO, binary = REGULAR]":                                                                        "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testPSUpdate[returningInQuery = STAR, binary = FORCE]":                                                                        "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testPSUpdate[returningInQuery = STAR, binary = REGULAR]":                                                                      "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testReturningWithTrailingSemicolon[returningInQuery = A, binary = FORCE]":                                                     "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testReturningWithTrailingSemicolon[returningInQuery = A, binary = REGULAR]":                                                   "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testReturningWithTrailingSemicolon[returningInQuery = AB, binary = FORCE]":                                                    "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testReturningWithTrailingSemicolon[returningInQuery = AB, binary = REGULAR]":                                                  "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testReturningWithTrailingSemicolon[returningInQuery = NO, binary = FORCE]":                                                    "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testReturningWithTrailingSemicolon[returningInQuery = NO, binary = REGULAR]":                                                  "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testReturningWithTrailingSemicolon[returningInQuery = STAR, binary = FORCE]":                                                  "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testReturningWithTrailingSemicolon[returningInQuery = STAR, binary = REGULAR]":                                                "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testSerialWorks[returningInQuery = A, binary = FORCE]":                                                                        "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testSerialWorks[returningInQuery = A, binary = REGULAR]":                                                                      "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testSerialWorks[returningInQuery = AB, binary = FORCE]":                                                                       "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testSerialWorks[returningInQuery = AB, binary = REGULAR]":                                                                     "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testSerialWorks[returningInQuery = NO, binary = FORCE]":                                                                       "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testSerialWorks[returningInQuery = NO, binary = REGULAR]":                                                                     "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testSerialWorks[returningInQuery = STAR, binary = FORCE]":                                                                     "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testSerialWorks[returningInQuery = STAR, binary = REGULAR]":                                                                   "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testStatementUpdateCount[returningInQuery = A, binary = FORCE]":                                                               "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testStatementUpdateCount[returningInQuery = A, binary = REGULAR]":                                                             "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testStatementUpdateCount[returningInQuery = AB, binary = FORCE]":                                                              "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testStatementUpdateCount[returningInQuery = AB, binary = REGULAR]":                                                            "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testStatementUpdateCount[returningInQuery = NO, binary = FORCE]":                                                              "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testStatementUpdateCount[returningInQuery = NO, binary = REGULAR]":                                                            "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testStatementUpdateCount[returningInQuery = STAR, binary = FORCE]":                                                            "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testStatementUpdateCount[returningInQuery = STAR, binary = REGULAR]":                                                          "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testUpdate[returningInQuery = A, binary = FORCE]":                                                                             "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testUpdate[returningInQuery = A, binary = REGULAR]":                                                                           "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testUpdate[returningInQuery = AB, binary = FORCE]":                                                                            "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testUpdate[returningInQuery = AB, binary = REGULAR]":                                                                          "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testUpdate[returningInQuery = NO, binary = FORCE]":                                                                            "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testUpdate[returningInQuery = NO, binary = REGULAR]":                                                                          "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testUpdate[returningInQuery = STAR, binary = FORCE]":                                                                          "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testUpdate[returningInQuery = STAR, binary = REGULAR]":                                                                        "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testWithInsertInsert[returningInQuery = A, binary = FORCE]":                                                                   "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testWithInsertInsert[returningInQuery = A, binary = REGULAR]":                                                                 "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testWithInsertInsert[returningInQuery = AB, binary = FORCE]":                                                                  "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testWithInsertInsert[returningInQuery = AB, binary = REGULAR]":                                                                "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testWithInsertInsert[returningInQuery = NO, binary = FORCE]":                                                                  "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testWithInsertInsert[returningInQuery = NO, binary = REGULAR]":                                                                "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testWithInsertInsert[returningInQuery = STAR, binary = FORCE]":                                                                "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testWithInsertInsert[returningInQuery = STAR, binary = REGULAR]":                                                              "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testWithInsertSelect[returningInQuery = A, binary = FORCE]":                                                                   "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testWithInsertSelect[returningInQuery = A, binary = REGULAR]":                                                                 "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testWithInsertSelect[returningInQuery = AB, binary = FORCE]":                                                                  "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testWithInsertSelect[returningInQuery = AB, binary = REGULAR]":                                                                "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testWithInsertSelect[returningInQuery = NO, binary = FORCE]":                                                                  "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testWithInsertSelect[returningInQuery = NO, binary = REGULAR]":                                                                "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testWithInsertSelect[returningInQuery = STAR, binary = FORCE]":                                                                "5807",
	"org.postgresql.test.jdbc3.GeneratedKeysTest.testWithInsertSelect[returningInQuery = STAR, binary = REGULAR]":                                                              "5807",
	"org.postgresql.test.jdbc3.Jdbc3BlobTest.test1Byte":                                                                                                                        "26725",
	"org.postgresql.test.jdbc3.Jdbc3BlobTest.test1ByteOffset":                                                                                                                  "26725",
	"org.postgresql.test.jdbc3.Jdbc3BlobTest.test1ByteOffsetStream":                                                                                                            "26725",
	"org.postgresql.test.jdbc3.Jdbc3BlobTest.test1ByteStream":                                                                                                                  "26725",
	"org.postgresql.test.jdbc3.Jdbc3BlobTest.testAllBytes":                                                                                                                     "26725",
	"org.postgresql.test.jdbc3.Jdbc3BlobTest.testAllBytesStream":                                                                                                               "26725",
	"org.postgresql.test.jdbc3.Jdbc3BlobTest.testManyBytes":                                                                                                                    "26725",
	"org.postgresql.test.jdbc3.Jdbc3BlobTest.testManyBytesOffset":                                                                                                              "26725",
	"org.postgresql.test.jdbc3.Jdbc3BlobTest.testManyBytesOffsetStream":                                                                                                        "26725",
	"org.postgresql.test.jdbc3.Jdbc3BlobTest.testManyBytesStream":                                                                                                              "26725",
	"org.postgresql.test.jdbc3.Jdbc3BlobTest.testPattern":                                                                                                                      "26725",
	"org.postgresql.test.jdbc3.Jdbc3BlobTest.testTruncate":                                                                                                                     "26725",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testAllInOut":                                                                                                        "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testFunctionNoParametersWithParentheses":                                                                             "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testFunctionNoParametersWithoutParentheses":                                                                          "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testGetBoolean01":                                                                                                    "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testGetByte01":                                                                                                       "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testGetBytes01":                                                                                                      "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testGetBytes02":                                                                                                      "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testGetDouble01":                                                                                                     "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testGetDoubleAsReal":                                                                                                 "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testGetInt01":                                                                                                        "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testGetLong01":                                                                                                       "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testGetObjectDecimal":                                                                                                "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testGetObjectFloat":                                                                                                  "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testGetObjectLongVarchar":                                                                                            "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testGetShort01":                                                                                                      "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testInOut":                                                                                                           "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testMultipleOutExecutions":                                                                                           "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testNotEnoughParameters":                                                                                             "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testNumeric":                                                                                                         "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testProcedureInOnlyNativeCall":                                                                                       "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testProcedureInOutNativeCall":                                                                                        "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testProcedureNoParametersWithParentheses":                                                                            "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testProcedureNoParametersWithoutParentheses":                                                                         "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testSetObjectBit":                                                                                                    "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testSomeInOut":                                                                                                       "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testSum":                                                                                                             "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testTooManyParameters":                                                                                               "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testUpdateDecimal":                                                                                                   "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testUpdateReal":                                                                                                      "17511",
	"org.postgresql.test.jdbc3.Jdbc3CallableStatementTest.testVarcharBool":                                                                                                     "17511",
	"org.postgresql.test.jdbc3.Jdbc3SavepointTest.testCantMixSavepointTypes":                                                                                                   "10735",
	"org.postgresql.test.jdbc3.Jdbc3SavepointTest.testComplicatedSavepointName":                                                                                                "10735",
	"org.postgresql.test.jdbc3.Jdbc3SavepointTest.testContinueAfterError":                                                                                                      "10735",
	"org.postgresql.test.jdbc3.Jdbc3SavepointTest.testGlobalRollbackWorks":                                                                                                     "10735",
	"org.postgresql.test.jdbc3.Jdbc3SavepointTest.testReleaseSavepoint":                                                                                                        "10735",
	"org.postgresql.test.jdbc3.Jdbc3SavepointTest.testRollbackMultipleTimes":                                                                                                   "10735",
	"org.postgresql.test.jdbc3.Jdbc3SavepointTest.testRollingBackToInvalidSavepointFails":                                                                                      "10735",
	"org.postgresql.test.jdbc3.Jdbc3SavepointTest.testRollingBackToSavepoints":                                                                                                 "10735",
	"org.postgresql.test.jdbc3.ParameterMetaDataTest.testFailsOnBadIndex":                                                                                                      "21286",
	"org.postgresql.test.jdbc3.ParameterMetaDataTest.testMultiStatement":                                                                                                       "21286",
	"org.postgresql.test.jdbc3.ParameterMetaDataTest.testParameterMD":                                                                                                          "21286",
	"org.postgresql.test.jdbc3.ParameterMetaDataTest.testTypeChangeWithUnknown":                                                                                                "21286",
	"org.postgresql.test.jdbc3.ResultSetTest.testHoldableResultSet":                                                                                                            "5807",
	"org.postgresql.test.jdbc3.SendRecvBufferSizeTest.testSelect":                                                                                                              "5807",
	"org.postgresql.test.jdbc3.StringTypeParameterTest.testMultipleEnumBinds[stringType = null]":                                                                               "27793",
	"org.postgresql.test.jdbc3.StringTypeParameterTest.testMultipleEnumBinds[stringType = unspecified]":                                                                        "27793",
	"org.postgresql.test.jdbc3.StringTypeParameterTest.testMultipleEnumBinds[stringType = varchar]":                                                                            "27793",
	"org.postgresql.test.jdbc3.StringTypeParameterTest.testOtherAsEnum[stringType = null]":                                                                                     "27793",
	"org.postgresql.test.jdbc3.StringTypeParameterTest.testOtherAsEnum[stringType = unspecified]":                                                                              "27793",
	"org.postgresql.test.jdbc3.StringTypeParameterTest.testOtherAsEnum[stringType = varchar]":                                                                                  "27793",
	"org.postgresql.test.jdbc3.StringTypeParameterTest.testParameterUnspecified[stringType = null]":                                                                            "27793",
	"org.postgresql.test.jdbc3.StringTypeParameterTest.testParameterUnspecified[stringType = unspecified]":                                                                     "27793",
	"org.postgresql.test.jdbc3.StringTypeParameterTest.testParameterUnspecified[stringType = varchar]":                                                                         "27793",
	"org.postgresql.test.jdbc3.StringTypeParameterTest.testVarcharAsEnum[stringType = null]":                                                                                   "27793",
	"org.postgresql.test.jdbc3.StringTypeParameterTest.testVarcharAsEnum[stringType = unspecified]":                                                                            "27793",
	"org.postgresql.test.jdbc3.StringTypeParameterTest.testVarcharAsEnum[stringType = varchar]":                                                                                "27793",
	"org.postgresql.test.jdbc3.TypesTest.testCallableBoolean":                                                                                                                  "17511",
	"org.postgresql.test.jdbc3.TypesTest.testPreparedBoolean":                                                                                                                  "17511",
	"org.postgresql.test.jdbc3.TypesTest.testPreparedByte":                                                                                                                     "17511",
	"org.postgresql.test.jdbc3.TypesTest.testUnknownType":                                                                                                                      "17511",
	"org.postgresql.test.jdbc4.ArrayTest.createNullArray[binary = FORCE]":                                                                                                      "32552",
	"org.postgresql.test.jdbc4.ArrayTest.createNullArray[binary = REGULAR]":                                                                                                    "32552",
	"org.postgresql.test.jdbc4.ArrayTest.multiDimIntArray[binary = FORCE]":                                                                                                     "32552",
	"org.postgresql.test.jdbc4.ArrayTest.multiDimIntArray[binary = REGULAR]":                                                                                                   "32552",
	"org.postgresql.test.jdbc4.ArrayTest.nullArray[binary = FORCE]":                                                                                                            "32552",
	"org.postgresql.test.jdbc4.ArrayTest.nullArray[binary = REGULAR]":                                                                                                          "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCasingBuiltinAlias[binary = FORCE]":                                                                                               "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCasingBuiltinAlias[binary = REGULAR]":                                                                                             "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCasingBuiltinNonAlias[binary = FORCE]":                                                                                            "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCasingBuiltinNonAlias[binary = REGULAR]":                                                                                          "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCasingComposite[binary = FORCE]":                                                                                                  "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCasingComposite[binary = REGULAR]":                                                                                                "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCreateArrayOfBool[binary = FORCE]":                                                                                                "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCreateArrayOfBool[binary = REGULAR]":                                                                                              "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCreateArrayOfInt[binary = FORCE]":                                                                                                 "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCreateArrayOfInt[binary = REGULAR]":                                                                                               "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCreateArrayOfMultiJson[binary = FORCE]":                                                                                           "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCreateArrayOfMultiJson[binary = REGULAR]":                                                                                         "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCreateArrayOfMultiString[binary = FORCE]":                                                                                         "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCreateArrayOfMultiString[binary = REGULAR]":                                                                                       "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCreateArrayOfNull[binary = FORCE]":                                                                                                "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCreateArrayOfNull[binary = REGULAR]":                                                                                              "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCreateArrayOfSmallInt[binary = FORCE]":                                                                                            "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCreateArrayOfSmallInt[binary = REGULAR]":                                                                                          "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCreateArrayWithNonStandardDelimiter[binary = FORCE]":                                                                              "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCreateArrayWithNonStandardDelimiter[binary = REGULAR]":                                                                            "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCreateArrayWithoutServer[binary = FORCE]":                                                                                         "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCreateArrayWithoutServer[binary = REGULAR]":                                                                                       "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCreateEmptyArrayOfIntViaAlias[binary = FORCE]":                                                                                    "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCreateEmptyArrayOfIntViaAlias[binary = REGULAR]":                                                                                  "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCreatePrimitiveArray[binary = FORCE]":                                                                                             "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testCreatePrimitiveArray[binary = REGULAR]":                                                                                           "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testEvilCasing[binary = FORCE]":                                                                                                       "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testEvilCasing[binary = REGULAR]":                                                                                                     "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testGetArrayOfComposites[binary = FORCE]":                                                                                             "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testGetArrayOfComposites[binary = REGULAR]":                                                                                           "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testSetObjectFromJavaArray[binary = FORCE]":                                                                                           "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testSetObjectFromJavaArray[binary = REGULAR]":                                                                                         "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testToString[binary = FORCE]":                                                                                                         "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testToString[binary = REGULAR]":                                                                                                       "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testUUIDArray[binary = FORCE]":                                                                                                        "32552",
	"org.postgresql.test.jdbc4.ArrayTest.testUUIDArray[binary = REGULAR]":                                                                                                      "32552",
	"org.postgresql.test.jdbc4.BlobTest.testFree":                                                                                                                              "26725",
	"org.postgresql.test.jdbc4.BlobTest.testGetBinaryStreamWithBoundaries":                                                                                                     "26725",
	"org.postgresql.test.jdbc4.BlobTest.testSetBlobWithStream":                                                                                                                 "26725",
	"org.postgresql.test.jdbc4.BlobTest.testSetBlobWithStreamAndLength":                                                                                                        "26725",
	"org.postgresql.test.jdbc4.ClientInfoTest.testExplicitSetAppNameNotificationIsParsed":                                                                                      "40854",
	"org.postgresql.test.jdbc4.ClientInfoTest.testSetAppName":                                                                                                                  "40854",
	"org.postgresql.test.jdbc4.ClientInfoTest.testSetAppNameProps":                                                                                                             "40854",
	"org.postgresql.test.jdbc4.DatabaseMetaDataHideUnprivilegedObjectsTest.org.postgresql.test.jdbc4.DatabaseMetaDataHideUnprivilegedObjectsTest":                              "26443",
	"org.postgresql.test.jdbc4.DatabaseMetaDataTest.testGetClientInfoProperties":                                                                                               "26443",
	"org.postgresql.test.jdbc4.DatabaseMetaDataTest.testGetColumnsForAutoIncrement":                                                                                            "41870",
	"org.postgresql.test.jdbc4.DatabaseMetaDataTest.testGetFunctionsInSchema":                                                                                                  "26443",
	"org.postgresql.test.jdbc4.DatabaseMetaDataTest.testGetFunctionsWithBlankPatterns":                                                                                         "41872",
	"org.postgresql.test.jdbc4.DatabaseMetaDataTest.testGetFunctionsWithSpecificTypes":                                                                                         "17511",
	"org.postgresql.test.jdbc4.DatabaseMetaDataTest.testGetProceduresInSchema":                                                                                                 "26443",
	"org.postgresql.test.jdbc4.DatabaseMetaDataTest.testGetSchemas":                                                                                                            "26443",
	"org.postgresql.test.jdbc4.DatabaseMetaDataTest.testSortedDataTypes":                                                                                                       "26443",
	"org.postgresql.test.jdbc4.IsValidTest.testIsValidRemoteClose":                                                                                                             "35897",
	"org.postgresql.test.jdbc4.PGCopyInputStreamTest.testReadBytesCorrectlyHandlesEof":                                                                                         "41608",
	"org.postgresql.test.jdbc4.PGCopyInputStreamTest.testReadBytesCorrectlyReadsDataInChunks":                                                                                  "41608",
	"org.postgresql.test.jdbc4.PGCopyInputStreamTest.testStreamCanBeClosedAfterReadUp":                                                                                         "41608",
	"org.postgresql.test.jdbc4.UUIDTest.testUUIDString[binary=FORCE, stringType=UNSPECIFIED]":                                                                                  "5807",
	"org.postgresql.test.jdbc4.UUIDTest.testUUIDString[binary=FORCE, stringType=VARCHAR]":                                                                                      "5807",
	"org.postgresql.test.jdbc4.UUIDTest.testUUIDString[binary=REGULAR, stringType=UNSPECIFIED]":                                                                                "5807",
	"org.postgresql.test.jdbc4.UUIDTest.testUUIDString[binary=REGULAR, stringType=VARCHAR]":                                                                                    "5807",
	"org.postgresql.test.jdbc4.UUIDTest.testUUID[binary=FORCE, stringType=UNSPECIFIED]":                                                                                        "5807",
	"org.postgresql.test.jdbc4.UUIDTest.testUUID[binary=FORCE, stringType=VARCHAR]":                                                                                            "5807",
	"org.postgresql.test.jdbc4.UUIDTest.testUUID[binary=REGULAR, stringType=UNSPECIFIED]":                                                                                      "5807",
	"org.postgresql.test.jdbc4.UUIDTest.testUUID[binary=REGULAR, stringType=VARCHAR]":                                                                                          "5807",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetArray":                                                                                                              "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetBigDecimal":                                                                                                         "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetBigInteger":                                                                                                         "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetBlob":                                                                                                               "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetBoolean":                                                                                                            "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetBooleanNull":                                                                                                        "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetBox":                                                                                                                "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetCalendar":                                                                                                           "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetCircle":                                                                                                             "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetClob":                                                                                                               "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetDate":                                                                                                               "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetDouble":                                                                                                             "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetDoubleNull":                                                                                                         "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetFloat":                                                                                                              "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetFloatNull":                                                                                                          "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetInet4Address":                                                                                                       "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetInet6Address":                                                                                                       "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetInetAddressNull":                                                                                                    "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetInteger":                                                                                                            "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetIntegerNull":                                                                                                        "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetInterval":                                                                                                           "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetJavaUtilDate":                                                                                                       "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetLine":                                                                                                               "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetLineseg":                                                                                                            "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetLong":                                                                                                               "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetLongNull":                                                                                                           "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetNullDate":                                                                                                           "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetNullTimestamp":                                                                                                      "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetPath":                                                                                                               "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetPoint":                                                                                                              "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetPolygon":                                                                                                            "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetSerial":                                                                                                             "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetShort":                                                                                                              "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetShortNull":                                                                                                          "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetString":                                                                                                             "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetTime":                                                                                                               "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetTimestamp":                                                                                                          "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetTimestampWithTimeZone":                                                                                              "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetUuid":                                                                                                               "26097",
	"org.postgresql.test.jdbc4.jdbc41.GetObjectTest.testGetXml":                                                                                                                "26097",
	"org.postgresql.test.jdbc4.jdbc41.SchemaTest.testCurrentSchemaPropertyNotVisibilityTableDuringFunctionCreation":                                                            "26443",
	"org.postgresql.test.jdbc4.jdbc41.SchemaTest.testCurrentSchemaPropertyNotVisibilityTableInsideFunction":                                                                    "26443",
	"org.postgresql.test.jdbc4.jdbc41.SchemaTest.testCurrentSchemaPropertyVisibilityFunction":                                                                                  "26443",
	"org.postgresql.test.jdbc4.jdbc41.SchemaTest.testCurrentSchemaPropertyVisibilityTableDuringFunctionCreation":                                                               "26443",
	"org.postgresql.test.jdbc4.jdbc41.SchemaTest.testGetSetSchema":                                                                                                             "26443",
	"org.postgresql.test.jdbc4.jdbc41.SchemaTest.testMultipleSearchPath":                                                                                                       "26443",
	"org.postgresql.test.jdbc4.jdbc41.SchemaTest.testSchemaInProperties":                                                                                                       "26443",
	"org.postgresql.test.jdbc4.jdbc41.SchemaTest.testSchemaPath$User":                                                                                                          "26443",
	"org.postgresql.test.jdbc4.jdbc41.SchemaTest.testSearchPathPreparedStatement":                                                                                              "26443",
	"org.postgresql.test.jdbc4.jdbc41.SchemaTest.testSearchPathPreparedStatementAutoCommitFalse":                                                                               "26443",
	"org.postgresql.test.jdbc4.jdbc41.SchemaTest.testSearchPathPreparedStatementAutoCommitTrue":                                                                                "26443",
	"org.postgresql.test.jdbc4.jdbc41.SchemaTest.testUsingSchema":                                                                                                              "26443",
	"org.postgresql.test.jdbc42.GetObject310InfinityTests.test[binary = FORCE, expr = -infinity, pgType = timestamp with time zone, klass = class java.time.OffsetDateTime]":   "41786",
	"org.postgresql.test.jdbc42.GetObject310InfinityTests.test[binary = FORCE, expr = -infinity, pgType = timestamp, klass = class java.time.LocalDateTime]":                   "41786",
	"org.postgresql.test.jdbc42.GetObject310InfinityTests.test[binary = FORCE, expr = -infinity, pgType = timestamp, klass = class java.time.OffsetDateTime]":                  "41786",
	"org.postgresql.test.jdbc42.GetObject310InfinityTests.test[binary = FORCE, expr = infinity, pgType = timestamp with time zone, klass = class java.time.OffsetDateTime]":    "41786",
	"org.postgresql.test.jdbc42.GetObject310InfinityTests.test[binary = FORCE, expr = infinity, pgType = timestamp, klass = class java.time.LocalDateTime]":                    "41786",
	"org.postgresql.test.jdbc42.GetObject310InfinityTests.test[binary = FORCE, expr = infinity, pgType = timestamp, klass = class java.time.OffsetDateTime]":                   "41786",
	"org.postgresql.test.jdbc42.GetObject310InfinityTests.test[binary = REGULAR, expr = -infinity, pgType = timestamp with time zone, klass = class java.time.OffsetDateTime]": "41786",
	"org.postgresql.test.jdbc42.GetObject310InfinityTests.test[binary = REGULAR, expr = -infinity, pgType = timestamp, klass = class java.time.LocalDateTime]":                 "41786",
	"org.postgresql.test.jdbc42.GetObject310InfinityTests.test[binary = REGULAR, expr = -infinity, pgType = timestamp, klass = class java.time.OffsetDateTime]":                "41786",
	"org.postgresql.test.jdbc42.GetObject310InfinityTests.test[binary = REGULAR, expr = infinity, pgType = timestamp with time zone, klass = class java.time.OffsetDateTime]":  "41786",
	"org.postgresql.test.jdbc42.GetObject310InfinityTests.test[binary = REGULAR, expr = infinity, pgType = timestamp, klass = class java.time.LocalDateTime]":                  "41786",
	"org.postgresql.test.jdbc42.GetObject310InfinityTests.test[binary = REGULAR, expr = infinity, pgType = timestamp, klass = class java.time.OffsetDateTime]":                 "41786",
	"org.postgresql.test.jdbc42.GetObject310Test.testBcTimestamp[binary = FORCE]":                                                                                              "26097",
	"org.postgresql.test.jdbc42.GetObject310Test.testBcTimestamp[binary = REGULAR]":                                                                                            "26097",
	"org.postgresql.test.jdbc42.GetObject310Test.testBcTimestamptz[binary = FORCE]":                                                                                            "26097",
	"org.postgresql.test.jdbc42.GetObject310Test.testBcTimestamptz[binary = REGULAR]":                                                                                          "26097",
	"org.postgresql.test.jdbc42.GetObject310Test.testGetLocalDateTime[binary = FORCE]":                                                                                         "26097",
	"org.postgresql.test.jdbc42.GetObject310Test.testGetLocalDateTime[binary = REGULAR]":                                                                                       "26097",
	"org.postgresql.test.jdbc42.GetObject310Test.testGetLocalDate[binary = FORCE]":                                                                                             "26097",
	"org.postgresql.test.jdbc42.GetObject310Test.testGetLocalDate[binary = REGULAR]":                                                                                           "26097",
	"org.postgresql.test.jdbc42.GetObject310Test.testGetLocalTimeInvalidType[binary = FORCE]":                                                                                  "26097",
	"org.postgresql.test.jdbc42.GetObject310Test.testGetLocalTimeInvalidType[binary = REGULAR]":                                                                                "26097",
	"org.postgresql.test.jdbc42.GetObject310Test.testGetLocalTimeNull[binary = FORCE]":                                                                                         "26097",
	"org.postgresql.test.jdbc42.GetObject310Test.testGetLocalTimeNull[binary = REGULAR]":                                                                                       "26097",
	"org.postgresql.test.jdbc42.GetObject310Test.testGetLocalTime[binary = FORCE]":                                                                                             "26097",
	"org.postgresql.test.jdbc42.GetObject310Test.testGetLocalTime[binary = REGULAR]":                                                                                           "26097",
	"org.postgresql.test.jdbc42.GetObject310Test.testGetTimestampWithTimeZone[binary = FORCE]":                                                                                 "26097",
	"org.postgresql.test.jdbc42.GetObject310Test.testGetTimestampWithTimeZone[binary = REGULAR]":                                                                               "26097",
	"org.postgresql.test.jdbc42.GetObject310Test.testProlepticCalendarTimestamp[binary = FORCE]":                                                                               "26097",
	"org.postgresql.test.jdbc42.GetObject310Test.testProlepticCalendarTimestamp[binary = REGULAR]":                                                                             "26097",
	"org.postgresql.test.jdbc42.GetObject310Test.testProlepticCalendarTimestamptz[binary = FORCE]":                                                                             "26097",
	"org.postgresql.test.jdbc42.GetObject310Test.testProlepticCalendarTimestamptz[binary = REGULAR]":                                                                           "26097",
	"org.postgresql.test.jdbc42.Jdbc42CallableStatementTest.testGetResultSetWithoutArg":                                                                                        "17511",
	"org.postgresql.test.jdbc42.Jdbc42CallableStatementTest.testGetResultSetWithoutArgUnsupportedConversion":                                                                   "17511",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testEmptyExecuteLargeBatchPreparedStatement[binary = FORCE, insertRewrite = false]":                                       "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testEmptyExecuteLargeBatchPreparedStatement[binary = FORCE, insertRewrite = true]":                                        "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testEmptyExecuteLargeBatchPreparedStatement[binary = REGULAR, insertRewrite = false]":                                     "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testEmptyExecuteLargeBatchPreparedStatement[binary = REGULAR, insertRewrite = true]":                                      "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testEmptyExecuteLargeBatchStatement[binary = FORCE, insertRewrite = false]":                                               "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testEmptyExecuteLargeBatchStatement[binary = FORCE, insertRewrite = true]":                                                "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testEmptyExecuteLargeBatchStatement[binary = REGULAR, insertRewrite = false]":                                             "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testEmptyExecuteLargeBatchStatement[binary = REGULAR, insertRewrite = true]":                                              "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargeBatchStatementSMALL[binary = FORCE, insertRewrite = false]":                                               "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargeBatchStatementSMALL[binary = FORCE, insertRewrite = true]":                                                "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargeBatchStatementSMALL[binary = REGULAR, insertRewrite = false]":                                             "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargeBatchStatementSMALL[binary = REGULAR, insertRewrite = true]":                                              "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargeBatchValuesInsertSMALL[binary = FORCE, insertRewrite = false]":                                            "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargeBatchValuesInsertSMALL[binary = FORCE, insertRewrite = true]":                                             "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargeBatchValuesInsertSMALL[binary = REGULAR, insertRewrite = false]":                                          "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargeBatchValuesInsertSMALL[binary = REGULAR, insertRewrite = true]":                                           "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargePreparedStatementStatementLoopSMALL[binary = FORCE, insertRewrite = false]":                               "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargePreparedStatementStatementLoopSMALL[binary = FORCE, insertRewrite = true]":                                "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargePreparedStatementStatementLoopSMALL[binary = REGULAR, insertRewrite = false]":                             "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargePreparedStatementStatementLoopSMALL[binary = REGULAR, insertRewrite = true]":                              "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargePreparedStatementStatementSMALL[binary = FORCE, insertRewrite = false]":                                   "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargePreparedStatementStatementSMALL[binary = FORCE, insertRewrite = true]":                                    "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargePreparedStatementStatementSMALL[binary = REGULAR, insertRewrite = false]":                                 "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargePreparedStatementStatementSMALL[binary = REGULAR, insertRewrite = true]":                                  "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargeUpdatePreparedStatementSELECT[binary = FORCE, insertRewrite = false]":                                     "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargeUpdatePreparedStatementSELECT[binary = FORCE, insertRewrite = true]":                                      "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargeUpdatePreparedStatementSELECT[binary = REGULAR, insertRewrite = false]":                                   "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargeUpdatePreparedStatementSELECT[binary = REGULAR, insertRewrite = true]":                                    "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargeUpdatePreparedStatementSMALL[binary = FORCE, insertRewrite = false]":                                      "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargeUpdatePreparedStatementSMALL[binary = FORCE, insertRewrite = true]":                                       "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargeUpdatePreparedStatementSMALL[binary = REGULAR, insertRewrite = false]":                                    "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargeUpdatePreparedStatementSMALL[binary = REGULAR, insertRewrite = true]":                                     "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargeUpdateStatementSELECT[binary = FORCE, insertRewrite = false]":                                             "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargeUpdateStatementSELECT[binary = FORCE, insertRewrite = true]":                                              "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargeUpdateStatementSELECT[binary = REGULAR, insertRewrite = false]":                                           "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargeUpdateStatementSELECT[binary = REGULAR, insertRewrite = true]":                                            "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargeUpdateStatementSMALL[binary = FORCE, insertRewrite = false]":                                              "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargeUpdateStatementSMALL[binary = FORCE, insertRewrite = true]":                                               "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargeUpdateStatementSMALL[binary = REGULAR, insertRewrite = false]":                                            "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testExecuteLargeUpdateStatementSMALL[binary = REGULAR, insertRewrite = true]":                                             "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testGetLargeUpdateCountPreparedStatementSELECT[binary = FORCE, insertRewrite = false]":                                    "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testGetLargeUpdateCountPreparedStatementSELECT[binary = FORCE, insertRewrite = true]":                                     "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testGetLargeUpdateCountPreparedStatementSELECT[binary = REGULAR, insertRewrite = false]":                                  "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testGetLargeUpdateCountPreparedStatementSELECT[binary = REGULAR, insertRewrite = true]":                                   "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testGetLargeUpdateCountPreparedStatementSMALL[binary = FORCE, insertRewrite = false]":                                     "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testGetLargeUpdateCountPreparedStatementSMALL[binary = FORCE, insertRewrite = true]":                                      "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testGetLargeUpdateCountPreparedStatementSMALL[binary = REGULAR, insertRewrite = false]":                                   "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testGetLargeUpdateCountPreparedStatementSMALL[binary = REGULAR, insertRewrite = true]":                                    "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testGetLargeUpdateCountStatementSELECT[binary = FORCE, insertRewrite = false]":                                            "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testGetLargeUpdateCountStatementSELECT[binary = FORCE, insertRewrite = true]":                                             "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testGetLargeUpdateCountStatementSELECT[binary = REGULAR, insertRewrite = false]":                                          "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testGetLargeUpdateCountStatementSELECT[binary = REGULAR, insertRewrite = true]":                                           "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testGetLargeUpdateCountStatementSMALL[binary = FORCE, insertRewrite = false]":                                             "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testGetLargeUpdateCountStatementSMALL[binary = FORCE, insertRewrite = true]":                                              "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testGetLargeUpdateCountStatementSMALL[binary = REGULAR, insertRewrite = false]":                                           "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testGetLargeUpdateCountStatementSMALL[binary = REGULAR, insertRewrite = true]":                                            "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testNullExecuteLargeBatchPreparedStatement[binary = FORCE, insertRewrite = false]":                                        "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testNullExecuteLargeBatchPreparedStatement[binary = FORCE, insertRewrite = true]":                                         "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testNullExecuteLargeBatchPreparedStatement[binary = REGULAR, insertRewrite = false]":                                      "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testNullExecuteLargeBatchPreparedStatement[binary = REGULAR, insertRewrite = true]":                                       "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testNullExecuteLargeBatchStatement[binary = FORCE, insertRewrite = false]":                                                "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testNullExecuteLargeBatchStatement[binary = FORCE, insertRewrite = true]":                                                 "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testNullExecuteLargeBatchStatement[binary = REGULAR, insertRewrite = false]":                                              "43352",
	"org.postgresql.test.jdbc42.LargeCountJdbc42Test.testNullExecuteLargeBatchStatement[binary = REGULAR, insertRewrite = true]":                                               "43352",
	"org.postgresql.test.jdbc42.PreparedStatementTest.testLocalTimeMax":                                                                                                        "26097",
	"org.postgresql.test.jdbc42.PreparedStatementTest.testSetNumber":                                                                                                           "26097",
	"org.postgresql.test.jdbc42.PreparedStatementTest.testTimeTzSetNull":                                                                                                       "26097",
	"org.postgresql.test.jdbc42.PreparedStatementTest.testTimestampTzSetNull":                                                                                                  "26097",
	"org.postgresql.test.jdbc42.SetObject310Test.testLocalDateTimeRounding[binary = FORCE]":                                                                                    "26097",
	"org.postgresql.test.jdbc42.SetObject310Test.testLocalDateTimeRounding[binary = REGULAR]":                                                                                  "26097",
	"org.postgresql.test.jdbc42.SetObject310Test.testSetLocalDateTimeBc[binary = FORCE]":                                                                                       "26097",
	"org.postgresql.test.jdbc42.SetObject310Test.testSetLocalDateTimeBc[binary = REGULAR]":                                                                                     "26097",
	"org.postgresql.test.jdbc42.SetObject310Test.testSetLocalDateTime[binary = FORCE]":                                                                                         "26097",
	"org.postgresql.test.jdbc42.SetObject310Test.testSetLocalDateTime[binary = REGULAR]":                                                                                       "26097",
	"org.postgresql.test.jdbc42.SetObject310Test.testSetLocalDateWithType[binary = FORCE]":                                                                                     "26097",
	"org.postgresql.test.jdbc42.SetObject310Test.testSetLocalDateWithType[binary = REGULAR]":                                                                                   "26097",
	"org.postgresql.test.jdbc42.SetObject310Test.testSetLocalDateWithoutType[binary = FORCE]":                                                                                  "26097",
	"org.postgresql.test.jdbc42.SetObject310Test.testSetLocalDateWithoutType[binary = REGULAR]":                                                                                "26097",
	"org.postgresql.test.jdbc42.SetObject310Test.testSetLocalTimeAndReadBack[binary = FORCE]":                                                                                  "26097",
	"org.postgresql.test.jdbc42.SetObject310Test.testSetLocalTimeAndReadBack[binary = REGULAR]":                                                                                "26097",
	"org.postgresql.test.jdbc42.SetObject310Test.testSetLocalTimeWithType[binary = FORCE]":                                                                                     "26097",
	"org.postgresql.test.jdbc42.SetObject310Test.testSetLocalTimeWithType[binary = REGULAR]":                                                                                   "26097",
	"org.postgresql.test.jdbc42.SetObject310Test.testSetLocalTimeWithoutType[binary = FORCE]":                                                                                  "26097",
	"org.postgresql.test.jdbc42.SetObject310Test.testSetLocalTimeWithoutType[binary = REGULAR]":                                                                                "26097",
	"org.postgresql.test.jdbc42.SetObject310Test.testSetOffsetDateTime[binary = FORCE]":                                                                                        "26097",
	"org.postgresql.test.jdbc42.SetObject310Test.testSetOffsetDateTime[binary = REGULAR]":                                                                                      "26097",
	"org.postgresql.test.jdbc42.SetObject310Test.testTimeStampRoundingWithType[binary = FORCE]":                                                                                "26097",
	"org.postgresql.test.jdbc42.SetObject310Test.testTimeStampRoundingWithType[binary = REGULAR]":                                                                              "26097",
	"org.postgresql.test.jdbc42.SetObject310Test.testTimeStampRounding[binary = FORCE]":                                                                                        "26097",
	"org.postgresql.test.jdbc42.SetObject310Test.testTimeStampRounding[binary = REGULAR]":                                                                                      "26097",
	"org.postgresql.test.xa.XADataSourceTest.testAutoCommit":                                                                                                                   "22329",
	"org.postgresql.test.xa.XADataSourceTest.testCloseBeforeCommit":                                                                                                            "22329",
	"org.postgresql.test.xa.XADataSourceTest.testCommitByDifferentConnection":                                                                                                  "22329",
	"org.postgresql.test.xa.XADataSourceTest.testCommitUnknownXid":                                                                                                             "22329",
	"org.postgresql.test.xa.XADataSourceTest.testCommitingCommittedXid":                                                                                                        "22329",
	"org.postgresql.test.xa.XADataSourceTest.testDatabaseRemovesPreparedBeforeCommit":                                                                                          "22329",
	"org.postgresql.test.xa.XADataSourceTest.testDatabaseRemovesPreparedBeforeRollback":                                                                                        "22329",
	"org.postgresql.test.xa.XADataSourceTest.testEndThenJoin":                                                                                                                  "22329",
	"org.postgresql.test.xa.XADataSourceTest.testMappingOfConstraintViolations":                                                                                                "22329",
	"org.postgresql.test.xa.XADataSourceTest.testNetworkIssueOnCommit":                                                                                                         "22329",
	"org.postgresql.test.xa.XADataSourceTest.testNetworkIssueOnOnePhaseCommit":                                                                                                 "22329",
	"org.postgresql.test.xa.XADataSourceTest.testNetworkIssueOnRollback":                                                                                                       "22329",
	"org.postgresql.test.xa.XADataSourceTest.testOnePhase":                                                                                                                     "22329",
	"org.postgresql.test.xa.XADataSourceTest.testOnePhaseCommitOfPrepared":                                                                                                     "22329",
	"org.postgresql.test.xa.XADataSourceTest.testOnePhaseCommitUnknownXid":                                                                                                     "22329",
	"org.postgresql.test.xa.XADataSourceTest.testOnePhaseCommitingCommittedXid":                                                                                                "22329",
	"org.postgresql.test.xa.XADataSourceTest.testPrepareUnknownXid":                                                                                                            "22329",
	"org.postgresql.test.xa.XADataSourceTest.testPreparingPreparedXid":                                                                                                         "22329",
	"org.postgresql.test.xa.XADataSourceTest.testRecover":                                                                                                                      "22329",
	"org.postgresql.test.xa.XADataSourceTest.testRepeatedRolledBack":                                                                                                           "22329",
	"org.postgresql.test.xa.XADataSourceTest.testRestoreOfAutoCommit":                                                                                                          "22329",
	"org.postgresql.test.xa.XADataSourceTest.testRestoreOfAutoCommitEndThenJoin":                                                                                               "22329",
	"org.postgresql.test.xa.XADataSourceTest.testRollback":                                                                                                                     "22329",
	"org.postgresql.test.xa.XADataSourceTest.testRollbackByDifferentConnection":                                                                                                "22329",
	"org.postgresql.test.xa.XADataSourceTest.testRollbackUnknownXid":                                                                                                           "22329",
	"org.postgresql.test.xa.XADataSourceTest.testRollbackWithoutPrepare":                                                                                                       "22329",
	"org.postgresql.test.xa.XADataSourceTest.testTwoPhaseCommit":                                                                                                               "22329",
	"org.postgresql.test.xa.XADataSourceTest.testWrapperEquals":                                                                                                                "22329",
}

var pgjdbcIgnoreList21_1 = pgjdbcIgnoreList20_2

var pgjdbcIgnoreList20_2 = pgjdbcIgnoreList20_1

var pgjdbcIgnoreList20_1 = pgjdbcIgnoreList19_2

var pgjdbcIgnoreList19_2 = blocklist{
	"org.postgresql.replication.ReplicationTestSuite.org.postgresql.replication.ReplicationTestSuite":                                               "expected fail - no replication",
	"org.postgresql.test.core.LogServerMessagePropertyTest.testWithDefaults":                                                                        "expected fail - checks error message",
	"org.postgresql.test.core.LogServerMessagePropertyTest.testWithExplicitlyEnabled":                                                               "expected fail - checks error message",
	"org.postgresql.test.core.LogServerMessagePropertyTest.testWithLogServerErrorDetailDisabled":                                                    "expected fail - checks error message",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchEscapeProcessing[binary = FORCE, insertRewrite = false]":                                   "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchEscapeProcessing[binary = FORCE, insertRewrite = true]":                                    "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchEscapeProcessing[binary = REGULAR, insertRewrite = false]":                                 "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchEscapeProcessing[binary = REGULAR, insertRewrite = true]":                                  "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchReturningMixedNulls[binary = FORCE, insertRewrite = false]":                                "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchReturningMixedNulls[binary = FORCE, insertRewrite = true]":                                 "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchReturningMixedNulls[binary = REGULAR, insertRewrite = false]":                              "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchReturningMixedNulls[binary = REGULAR, insertRewrite = true]":                               "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithAlternatingAndUnknownTypes0[binary = FORCE, insertRewrite = false]":                    "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithAlternatingAndUnknownTypes0[binary = FORCE, insertRewrite = true]":                     "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithAlternatingAndUnknownTypes0[binary = REGULAR, insertRewrite = false]":                  "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithAlternatingAndUnknownTypes0[binary = REGULAR, insertRewrite = true]":                   "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithAlternatingAndUnknownTypes1[binary = FORCE, insertRewrite = false]":                    "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithAlternatingAndUnknownTypes1[binary = FORCE, insertRewrite = true]":                     "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithAlternatingAndUnknownTypes1[binary = REGULAR, insertRewrite = false]":                  "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithAlternatingAndUnknownTypes1[binary = REGULAR, insertRewrite = true]":                   "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithAlternatingAndUnknownTypes2[binary = FORCE, insertRewrite = false]":                    "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithAlternatingAndUnknownTypes2[binary = FORCE, insertRewrite = true]":                     "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithAlternatingAndUnknownTypes2[binary = REGULAR, insertRewrite = false]":                  "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithAlternatingAndUnknownTypes2[binary = REGULAR, insertRewrite = true]":                   "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithAlternatingAndUnknownTypes3[binary = FORCE, insertRewrite = false]":                    "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithAlternatingAndUnknownTypes3[binary = FORCE, insertRewrite = true]":                     "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithAlternatingAndUnknownTypes3[binary = REGULAR, insertRewrite = false]":                  "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithAlternatingAndUnknownTypes3[binary = REGULAR, insertRewrite = true]":                   "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithAlternatingAndUnknownTypes4[binary = FORCE, insertRewrite = false]":                    "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithAlternatingAndUnknownTypes4[binary = FORCE, insertRewrite = true]":                     "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithAlternatingAndUnknownTypes4[binary = REGULAR, insertRewrite = false]":                  "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithAlternatingAndUnknownTypes4[binary = REGULAR, insertRewrite = true]":                   "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithAlternatingAndUnknownTypes5[binary = FORCE, insertRewrite = false]":                    "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithAlternatingAndUnknownTypes5[binary = FORCE, insertRewrite = true]":                     "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithAlternatingAndUnknownTypes5[binary = REGULAR, insertRewrite = false]":                  "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithAlternatingAndUnknownTypes5[binary = REGULAR, insertRewrite = true]":                   "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithAlternatingAndUnknownTypes6[binary = FORCE, insertRewrite = false]":                    "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithAlternatingAndUnknownTypes6[binary = FORCE, insertRewrite = true]":                     "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithAlternatingAndUnknownTypes6[binary = REGULAR, insertRewrite = false]":                  "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithAlternatingAndUnknownTypes6[binary = REGULAR, insertRewrite = true]":                   "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithMultiInsert[binary = FORCE, insertRewrite = false]":                                    "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithMultiInsert[binary = FORCE, insertRewrite = true]":                                     "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithMultiInsert[binary = REGULAR, insertRewrite = false]":                                  "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithMultiInsert[binary = REGULAR, insertRewrite = true]":                                   "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithRepeatedInsertStatement[binary = FORCE, insertRewrite = false]":                        "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithRepeatedInsertStatement[binary = FORCE, insertRewrite = true]":                         "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithRepeatedInsertStatement[binary = REGULAR, insertRewrite = false]":                      "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithRepeatedInsertStatement[binary = REGULAR, insertRewrite = true]":                       "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithTwoMultiInsertStatements[binary = FORCE, insertRewrite = false]":                       "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithTwoMultiInsertStatements[binary = FORCE, insertRewrite = true]":                        "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithTwoMultiInsertStatements[binary = REGULAR, insertRewrite = false]":                     "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testBatchWithTwoMultiInsertStatements[binary = REGULAR, insertRewrite = true]":                      "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testClearBatch[binary = FORCE, insertRewrite = false]":                                              "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testClearBatch[binary = FORCE, insertRewrite = true]":                                               "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testClearBatch[binary = REGULAR, insertRewrite = false]":                                            "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testClearBatch[binary = REGULAR, insertRewrite = true]":                                             "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testClearPreparedEmptyBatch[binary = FORCE, insertRewrite = false]":                                 "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testClearPreparedEmptyBatch[binary = FORCE, insertRewrite = true]":                                  "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testClearPreparedEmptyBatch[binary = REGULAR, insertRewrite = false]":                               "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testClearPreparedEmptyBatch[binary = REGULAR, insertRewrite = true]":                                "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testClearPreparedNoArgBatch[binary = FORCE, insertRewrite = false]":                                 "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testClearPreparedNoArgBatch[binary = FORCE, insertRewrite = true]":                                  "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testClearPreparedNoArgBatch[binary = REGULAR, insertRewrite = false]":                               "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testClearPreparedNoArgBatch[binary = REGULAR, insertRewrite = true]":                                "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testEmptyClearBatch[binary = FORCE, insertRewrite = false]":                                         "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testEmptyClearBatch[binary = FORCE, insertRewrite = true]":                                          "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testEmptyClearBatch[binary = REGULAR, insertRewrite = false]":                                       "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testEmptyClearBatch[binary = REGULAR, insertRewrite = true]":                                        "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testExecuteEmptyBatch[binary = FORCE, insertRewrite = false]":                                       "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testExecuteEmptyBatch[binary = FORCE, insertRewrite = true]":                                        "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testExecuteEmptyBatch[binary = REGULAR, insertRewrite = false]":                                     "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testExecuteEmptyBatch[binary = REGULAR, insertRewrite = true]":                                      "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testExecuteEmptyPreparedBatch[binary = FORCE, insertRewrite = false]":                               "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testExecuteEmptyPreparedBatch[binary = FORCE, insertRewrite = true]":                                "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testExecuteEmptyPreparedBatch[binary = REGULAR, insertRewrite = false]":                             "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testExecuteEmptyPreparedBatch[binary = REGULAR, insertRewrite = true]":                              "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testNoServerPrepareOneRow[binary = FORCE, insertRewrite = false]":                                   "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testNoServerPrepareOneRow[binary = FORCE, insertRewrite = true]":                                    "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testNoServerPrepareOneRow[binary = REGULAR, insertRewrite = false]":                                 "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testNoServerPrepareOneRow[binary = REGULAR, insertRewrite = true]":                                  "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testPreparedNoParameters[binary = FORCE, insertRewrite = false]":                                    "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testPreparedNoParameters[binary = FORCE, insertRewrite = true]":                                     "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testPreparedNoParameters[binary = REGULAR, insertRewrite = false]":                                  "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testPreparedNoParameters[binary = REGULAR, insertRewrite = true]":                                   "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testPreparedStatement[binary = FORCE, insertRewrite = false]":                                       "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testPreparedStatement[binary = FORCE, insertRewrite = true]":                                        "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testPreparedStatement[binary = REGULAR, insertRewrite = false]":                                     "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testPreparedStatement[binary = REGULAR, insertRewrite = true]":                                      "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testSelectInBatchThrows[binary = FORCE, insertRewrite = false]":                                     "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testSelectInBatchThrows[binary = FORCE, insertRewrite = true]":                                      "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testSelectInBatchThrows[binary = REGULAR, insertRewrite = false]":                                   "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testSelectInBatchThrows[binary = REGULAR, insertRewrite = true]":                                    "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testServerPrepareMultipleRows[binary = FORCE, insertRewrite = false]":                               "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testServerPrepareMultipleRows[binary = FORCE, insertRewrite = true]":                                "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testServerPrepareMultipleRows[binary = REGULAR, insertRewrite = false]":                             "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testServerPrepareMultipleRows[binary = REGULAR, insertRewrite = true]":                              "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testSmallBatchUpdateFailureSimple[binary = FORCE, insertRewrite = true]":                            "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testSmallBatchUpdateFailureSimple[binary = REGULAR, insertRewrite = true]":                          "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testStringAddBatchOnPreparedStatement[binary = FORCE, insertRewrite = false]":                       "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testStringAddBatchOnPreparedStatement[binary = FORCE, insertRewrite = true]":                        "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testStringAddBatchOnPreparedStatement[binary = REGULAR, insertRewrite = false]":                     "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testStringAddBatchOnPreparedStatement[binary = REGULAR, insertRewrite = true]":                      "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testSupportsBatchUpdates[binary = FORCE, insertRewrite = false]":                                    "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testSupportsBatchUpdates[binary = FORCE, insertRewrite = true]":                                     "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testSupportsBatchUpdates[binary = REGULAR, insertRewrite = false]":                                  "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testSupportsBatchUpdates[binary = REGULAR, insertRewrite = true]":                                   "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testTransactionalBehaviour[binary = FORCE, insertRewrite = false]":                                  "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testTransactionalBehaviour[binary = FORCE, insertRewrite = true]":                                   "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testTransactionalBehaviour[binary = REGULAR, insertRewrite = false]":                                "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testTransactionalBehaviour[binary = REGULAR, insertRewrite = true]":                                 "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testWarningsAreCleared[binary = FORCE, insertRewrite = false]":                                      "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testWarningsAreCleared[binary = FORCE, insertRewrite = true]":                                       "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testWarningsAreCleared[binary = REGULAR, insertRewrite = false]":                                    "54477",
	"org.postgresql.test.jdbc2.BatchExecuteTest.testWarningsAreCleared[binary = REGULAR, insertRewrite = true]":                                     "54477",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.testBatchWithReWrittenBatchStatementWithSemiColon[2: autoCommit=NO, binary=REGULAR]": "54477",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.testBatchWithReWrittenBatchStatementWithSemiColon[3: autoCommit=NO, binary=FORCE]":   "54477",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.testBatchWithReWrittenMixedCaseValues[2: autoCommit=NO, binary=REGULAR]":             "54477",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.testBatchWithReWrittenMixedCaseValues[3: autoCommit=NO, binary=FORCE]":               "54477",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.testBatchWithReWrittenSpaceAfterValues[2: autoCommit=NO, binary=REGULAR]":            "54477",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.testBatchWithReWrittenSpaceAfterValues[3: autoCommit=NO, binary=FORCE]":              "54477",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.testReWriteDisabledForPlainBatch[2: autoCommit=NO, binary=REGULAR]":                  "54477",
	"org.postgresql.test.jdbc2.BatchedInsertReWriteEnabledTest.testReWriteDisabledForPlainBatch[3: autoCommit=NO, binary=FORCE]":                    "54477",
}
