// Code generated by execgen; DO NOT EDIT.
// Copyright 2020 The Cockroach Authors.
// Use of this software is governed by the Business Source License
// included in the file licenses/BSL.txt.
// As of the Change Date specified in that file, in accordance with
// the Business Source License, use of this software will be governed
// by the Apache License, Version 2.0, included in the file
// licenses/APL.txt.

package colexec

import (
	"bytes"
	"math"

	"github.com/cockroachdb/cockroach/pkg/col/coldata"
	"github.com/cockroachdb/cockroach/pkg/col/coldataext"
	"github.com/cockroachdb/cockroach/pkg/col/typeconv"
	"github.com/cockroachdb/cockroach/pkg/sql/sem/tree"
	"github.com/cockroachdb/cockroach/pkg/sql/types"
)

// checkCol determines if the current key column in the groupID buckets matches
// the specified equality column key. If there is no match, then the key is
// added to differs. If the bucket has reached the end, the key is rejected. If
// the hashTable disallows null equality, then if any element in the key is
// null, there is no match.
func (ht *hashTable) checkCol(
	probeVec, buildVec coldata.Vec, keyColIdx int, nToCheck uint64, probeSel []int,
) {
	switch probeVec.CanonicalTypeFamily() {
	case types.BoolFamily:
		switch probeVec.Type().Width() {
		case -1:
		default:
			switch buildVec.CanonicalTypeFamily() {
			case types.BoolFamily:
				switch buildVec.Type().Width() {
				case -1:
				default:
					probeKeys := probeVec.Bool()
					buildKeys := buildVec.Bool()
					if probeSel != nil {
						if probeVec.MaybeHasNulls() {
							if buildVec.MaybeHasNulls() {
								if ht.allowNullEquality {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = probeSel[toCheck]
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull && buildIsNull {
												// Both values are NULLs, and since we're allowing null equality, we
												// proceed to the next value to check.
												continue
											} else if probeIsNull {
												// Only probing value is NULL, so it is different from the build value
												// (which is non-NULL). We mark it as "different" and proceed to the
												// next value to check. This behavior is special in case of allowing
												// null equality because we don't want to reset the groupID of the
												// current probing tuple.
												ht.probeScratch.differs[toCheck] = true
												continue
											}
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int

													if !probeVal && buildVal {
														cmpResult = -1
													} else if probeVal && !buildVal {
														cmpResult = 1
													} else {
														cmpResult = 0
													}

													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								} else {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = probeSel[toCheck]
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int

													if !probeVal && buildVal {
														cmpResult = -1
													} else if probeVal && !buildVal {
														cmpResult = 1
													} else {
														cmpResult = 0
													}

													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = probeSel[toCheck]
										probeIsNull = probeVec.Nulls().NullAt(probeIdx)
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												if !probeVal && buildVal {
													cmpResult = -1
												} else if probeVal && !buildVal {
													cmpResult = 1
												} else {
													cmpResult = 0
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						} else {
							if buildVec.MaybeHasNulls() {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = probeSel[toCheck]
										buildIdx = int(keyID - 1)
										buildIsNull = buildVec.Nulls().NullAt(buildIdx)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												if !probeVal && buildVal {
													cmpResult = -1
												} else if probeVal && !buildVal {
													cmpResult = 1
												} else {
													cmpResult = 0
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = probeSel[toCheck]
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												if !probeVal && buildVal {
													cmpResult = -1
												} else if probeVal && !buildVal {
													cmpResult = 1
												} else {
													cmpResult = 0
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						}
					} else {
						if probeVec.MaybeHasNulls() {
							if buildVec.MaybeHasNulls() {
								if ht.allowNullEquality {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = int(toCheck)
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull && buildIsNull {
												// Both values are NULLs, and since we're allowing null equality, we
												// proceed to the next value to check.
												continue
											} else if probeIsNull {
												// Only probing value is NULL, so it is different from the build value
												// (which is non-NULL). We mark it as "different" and proceed to the
												// next value to check. This behavior is special in case of allowing
												// null equality because we don't want to reset the groupID of the
												// current probing tuple.
												ht.probeScratch.differs[toCheck] = true
												continue
											}
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int

													if !probeVal && buildVal {
														cmpResult = -1
													} else if probeVal && !buildVal {
														cmpResult = 1
													} else {
														cmpResult = 0
													}

													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								} else {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = int(toCheck)
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int

													if !probeVal && buildVal {
														cmpResult = -1
													} else if probeVal && !buildVal {
														cmpResult = 1
													} else {
														cmpResult = 0
													}

													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = int(toCheck)
										probeIsNull = probeVec.Nulls().NullAt(probeIdx)
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												if !probeVal && buildVal {
													cmpResult = -1
												} else if probeVal && !buildVal {
													cmpResult = 1
												} else {
													cmpResult = 0
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						} else {
							if buildVec.MaybeHasNulls() {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = int(toCheck)
										buildIdx = int(keyID - 1)
										buildIsNull = buildVec.Nulls().NullAt(buildIdx)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												if !probeVal && buildVal {
													cmpResult = -1
												} else if probeVal && !buildVal {
													cmpResult = 1
												} else {
													cmpResult = 0
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = int(toCheck)
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												if !probeVal && buildVal {
													cmpResult = -1
												} else if probeVal && !buildVal {
													cmpResult = 1
												} else {
													cmpResult = 0
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						}
					}
				}
			}
		}
	case types.BytesFamily:
		switch probeVec.Type().Width() {
		case -1:
		default:
			switch buildVec.CanonicalTypeFamily() {
			case types.BytesFamily:
				switch buildVec.Type().Width() {
				case -1:
				default:
					probeKeys := probeVec.Bytes()
					buildKeys := buildVec.Bytes()
					if probeSel != nil {
						if probeVec.MaybeHasNulls() {
							if buildVec.MaybeHasNulls() {
								if ht.allowNullEquality {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = probeSel[toCheck]
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull && buildIsNull {
												// Both values are NULLs, and since we're allowing null equality, we
												// proceed to the next value to check.
												continue
											} else if probeIsNull {
												// Only probing value is NULL, so it is different from the build value
												// (which is non-NULL). We mark it as "different" and proceed to the
												// next value to check. This behavior is special in case of allowing
												// null equality because we don't want to reset the groupID of the
												// current probing tuple.
												ht.probeScratch.differs[toCheck] = true
												continue
											}
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int
													cmpResult = bytes.Compare(probeVal, buildVal)
													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								} else {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = probeSel[toCheck]
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int
													cmpResult = bytes.Compare(probeVal, buildVal)
													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = probeSel[toCheck]
										probeIsNull = probeVec.Nulls().NullAt(probeIdx)
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int
												cmpResult = bytes.Compare(probeVal, buildVal)
												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						} else {
							if buildVec.MaybeHasNulls() {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = probeSel[toCheck]
										buildIdx = int(keyID - 1)
										buildIsNull = buildVec.Nulls().NullAt(buildIdx)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int
												cmpResult = bytes.Compare(probeVal, buildVal)
												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = probeSel[toCheck]
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int
												cmpResult = bytes.Compare(probeVal, buildVal)
												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						}
					} else {
						if probeVec.MaybeHasNulls() {
							if buildVec.MaybeHasNulls() {
								if ht.allowNullEquality {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = int(toCheck)
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull && buildIsNull {
												// Both values are NULLs, and since we're allowing null equality, we
												// proceed to the next value to check.
												continue
											} else if probeIsNull {
												// Only probing value is NULL, so it is different from the build value
												// (which is non-NULL). We mark it as "different" and proceed to the
												// next value to check. This behavior is special in case of allowing
												// null equality because we don't want to reset the groupID of the
												// current probing tuple.
												ht.probeScratch.differs[toCheck] = true
												continue
											}
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int
													cmpResult = bytes.Compare(probeVal, buildVal)
													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								} else {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = int(toCheck)
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int
													cmpResult = bytes.Compare(probeVal, buildVal)
													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = int(toCheck)
										probeIsNull = probeVec.Nulls().NullAt(probeIdx)
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int
												cmpResult = bytes.Compare(probeVal, buildVal)
												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						} else {
							if buildVec.MaybeHasNulls() {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = int(toCheck)
										buildIdx = int(keyID - 1)
										buildIsNull = buildVec.Nulls().NullAt(buildIdx)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int
												cmpResult = bytes.Compare(probeVal, buildVal)
												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = int(toCheck)
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int
												cmpResult = bytes.Compare(probeVal, buildVal)
												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						}
					}
				}
			}
		}
	case types.DecimalFamily:
		switch probeVec.Type().Width() {
		case -1:
		default:
			switch buildVec.CanonicalTypeFamily() {
			case types.DecimalFamily:
				switch buildVec.Type().Width() {
				case -1:
				default:
					probeKeys := probeVec.Decimal()
					buildKeys := buildVec.Decimal()
					if probeSel != nil {
						if probeVec.MaybeHasNulls() {
							if buildVec.MaybeHasNulls() {
								if ht.allowNullEquality {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = probeSel[toCheck]
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull && buildIsNull {
												// Both values are NULLs, and since we're allowing null equality, we
												// proceed to the next value to check.
												continue
											} else if probeIsNull {
												// Only probing value is NULL, so it is different from the build value
												// (which is non-NULL). We mark it as "different" and proceed to the
												// next value to check. This behavior is special in case of allowing
												// null equality because we don't want to reset the groupID of the
												// current probing tuple.
												ht.probeScratch.differs[toCheck] = true
												continue
											}
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int
													cmpResult = tree.CompareDecimals(&probeVal, &buildVal)
													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								} else {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = probeSel[toCheck]
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int
													cmpResult = tree.CompareDecimals(&probeVal, &buildVal)
													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = probeSel[toCheck]
										probeIsNull = probeVec.Nulls().NullAt(probeIdx)
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int
												cmpResult = tree.CompareDecimals(&probeVal, &buildVal)
												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						} else {
							if buildVec.MaybeHasNulls() {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = probeSel[toCheck]
										buildIdx = int(keyID - 1)
										buildIsNull = buildVec.Nulls().NullAt(buildIdx)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int
												cmpResult = tree.CompareDecimals(&probeVal, &buildVal)
												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = probeSel[toCheck]
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int
												cmpResult = tree.CompareDecimals(&probeVal, &buildVal)
												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						}
					} else {
						if probeVec.MaybeHasNulls() {
							if buildVec.MaybeHasNulls() {
								if ht.allowNullEquality {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = int(toCheck)
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull && buildIsNull {
												// Both values are NULLs, and since we're allowing null equality, we
												// proceed to the next value to check.
												continue
											} else if probeIsNull {
												// Only probing value is NULL, so it is different from the build value
												// (which is non-NULL). We mark it as "different" and proceed to the
												// next value to check. This behavior is special in case of allowing
												// null equality because we don't want to reset the groupID of the
												// current probing tuple.
												ht.probeScratch.differs[toCheck] = true
												continue
											}
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int
													cmpResult = tree.CompareDecimals(&probeVal, &buildVal)
													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								} else {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = int(toCheck)
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int
													cmpResult = tree.CompareDecimals(&probeVal, &buildVal)
													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = int(toCheck)
										probeIsNull = probeVec.Nulls().NullAt(probeIdx)
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int
												cmpResult = tree.CompareDecimals(&probeVal, &buildVal)
												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						} else {
							if buildVec.MaybeHasNulls() {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = int(toCheck)
										buildIdx = int(keyID - 1)
										buildIsNull = buildVec.Nulls().NullAt(buildIdx)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int
												cmpResult = tree.CompareDecimals(&probeVal, &buildVal)
												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = int(toCheck)
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int
												cmpResult = tree.CompareDecimals(&probeVal, &buildVal)
												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						}
					}
				}
			}
		}
	case types.IntFamily:
		switch probeVec.Type().Width() {
		case 16:
			switch buildVec.CanonicalTypeFamily() {
			case types.IntFamily:
				switch buildVec.Type().Width() {
				case 16:
					probeKeys := probeVec.Int16()
					buildKeys := buildVec.Int16()
					if probeSel != nil {
						if probeVec.MaybeHasNulls() {
							if buildVec.MaybeHasNulls() {
								if ht.allowNullEquality {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = probeSel[toCheck]
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull && buildIsNull {
												// Both values are NULLs, and since we're allowing null equality, we
												// proceed to the next value to check.
												continue
											} else if probeIsNull {
												// Only probing value is NULL, so it is different from the build value
												// (which is non-NULL). We mark it as "different" and proceed to the
												// next value to check. This behavior is special in case of allowing
												// null equality because we don't want to reset the groupID of the
												// current probing tuple.
												ht.probeScratch.differs[toCheck] = true
												continue
											}
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int

													{
														a, b := int64(probeVal), int64(buildVal)
														if a < b {
															cmpResult = -1
														} else if a > b {
															cmpResult = 1
														} else {
															cmpResult = 0
														}
													}

													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								} else {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = probeSel[toCheck]
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int

													{
														a, b := int64(probeVal), int64(buildVal)
														if a < b {
															cmpResult = -1
														} else if a > b {
															cmpResult = 1
														} else {
															cmpResult = 0
														}
													}

													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = probeSel[toCheck]
										probeIsNull = probeVec.Nulls().NullAt(probeIdx)
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												{
													a, b := int64(probeVal), int64(buildVal)
													if a < b {
														cmpResult = -1
													} else if a > b {
														cmpResult = 1
													} else {
														cmpResult = 0
													}
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						} else {
							if buildVec.MaybeHasNulls() {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = probeSel[toCheck]
										buildIdx = int(keyID - 1)
										buildIsNull = buildVec.Nulls().NullAt(buildIdx)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												{
													a, b := int64(probeVal), int64(buildVal)
													if a < b {
														cmpResult = -1
													} else if a > b {
														cmpResult = 1
													} else {
														cmpResult = 0
													}
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = probeSel[toCheck]
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												{
													a, b := int64(probeVal), int64(buildVal)
													if a < b {
														cmpResult = -1
													} else if a > b {
														cmpResult = 1
													} else {
														cmpResult = 0
													}
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						}
					} else {
						if probeVec.MaybeHasNulls() {
							if buildVec.MaybeHasNulls() {
								if ht.allowNullEquality {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = int(toCheck)
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull && buildIsNull {
												// Both values are NULLs, and since we're allowing null equality, we
												// proceed to the next value to check.
												continue
											} else if probeIsNull {
												// Only probing value is NULL, so it is different from the build value
												// (which is non-NULL). We mark it as "different" and proceed to the
												// next value to check. This behavior is special in case of allowing
												// null equality because we don't want to reset the groupID of the
												// current probing tuple.
												ht.probeScratch.differs[toCheck] = true
												continue
											}
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int

													{
														a, b := int64(probeVal), int64(buildVal)
														if a < b {
															cmpResult = -1
														} else if a > b {
															cmpResult = 1
														} else {
															cmpResult = 0
														}
													}

													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								} else {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = int(toCheck)
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int

													{
														a, b := int64(probeVal), int64(buildVal)
														if a < b {
															cmpResult = -1
														} else if a > b {
															cmpResult = 1
														} else {
															cmpResult = 0
														}
													}

													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = int(toCheck)
										probeIsNull = probeVec.Nulls().NullAt(probeIdx)
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												{
													a, b := int64(probeVal), int64(buildVal)
													if a < b {
														cmpResult = -1
													} else if a > b {
														cmpResult = 1
													} else {
														cmpResult = 0
													}
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						} else {
							if buildVec.MaybeHasNulls() {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = int(toCheck)
										buildIdx = int(keyID - 1)
										buildIsNull = buildVec.Nulls().NullAt(buildIdx)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												{
													a, b := int64(probeVal), int64(buildVal)
													if a < b {
														cmpResult = -1
													} else if a > b {
														cmpResult = 1
													} else {
														cmpResult = 0
													}
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = int(toCheck)
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												{
													a, b := int64(probeVal), int64(buildVal)
													if a < b {
														cmpResult = -1
													} else if a > b {
														cmpResult = 1
													} else {
														cmpResult = 0
													}
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						}
					}
				case 32:
					probeKeys := probeVec.Int16()
					buildKeys := buildVec.Int32()
					if probeSel != nil {
						if probeVec.MaybeHasNulls() {
							if buildVec.MaybeHasNulls() {
								if ht.allowNullEquality {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = probeSel[toCheck]
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull && buildIsNull {
												// Both values are NULLs, and since we're allowing null equality, we
												// proceed to the next value to check.
												continue
											} else if probeIsNull {
												// Only probing value is NULL, so it is different from the build value
												// (which is non-NULL). We mark it as "different" and proceed to the
												// next value to check. This behavior is special in case of allowing
												// null equality because we don't want to reset the groupID of the
												// current probing tuple.
												ht.probeScratch.differs[toCheck] = true
												continue
											}
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int

													{
														a, b := int64(probeVal), int64(buildVal)
														if a < b {
															cmpResult = -1
														} else if a > b {
															cmpResult = 1
														} else {
															cmpResult = 0
														}
													}

													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								} else {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = probeSel[toCheck]
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int

													{
														a, b := int64(probeVal), int64(buildVal)
														if a < b {
															cmpResult = -1
														} else if a > b {
															cmpResult = 1
														} else {
															cmpResult = 0
														}
													}

													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = probeSel[toCheck]
										probeIsNull = probeVec.Nulls().NullAt(probeIdx)
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												{
													a, b := int64(probeVal), int64(buildVal)
													if a < b {
														cmpResult = -1
													} else if a > b {
														cmpResult = 1
													} else {
														cmpResult = 0
													}
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						} else {
							if buildVec.MaybeHasNulls() {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = probeSel[toCheck]
										buildIdx = int(keyID - 1)
										buildIsNull = buildVec.Nulls().NullAt(buildIdx)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												{
													a, b := int64(probeVal), int64(buildVal)
													if a < b {
														cmpResult = -1
													} else if a > b {
														cmpResult = 1
													} else {
														cmpResult = 0
													}
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = probeSel[toCheck]
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												{
													a, b := int64(probeVal), int64(buildVal)
													if a < b {
														cmpResult = -1
													} else if a > b {
														cmpResult = 1
													} else {
														cmpResult = 0
													}
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						}
					} else {
						if probeVec.MaybeHasNulls() {
							if buildVec.MaybeHasNulls() {
								if ht.allowNullEquality {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = int(toCheck)
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull && buildIsNull {
												// Both values are NULLs, and since we're allowing null equality, we
												// proceed to the next value to check.
												continue
											} else if probeIsNull {
												// Only probing value is NULL, so it is different from the build value
												// (which is non-NULL). We mark it as "different" and proceed to the
												// next value to check. This behavior is special in case of allowing
												// null equality because we don't want to reset the groupID of the
												// current probing tuple.
												ht.probeScratch.differs[toCheck] = true
												continue
											}
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int

													{
														a, b := int64(probeVal), int64(buildVal)
														if a < b {
															cmpResult = -1
														} else if a > b {
															cmpResult = 1
														} else {
															cmpResult = 0
														}
													}

													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								} else {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = int(toCheck)
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int

													{
														a, b := int64(probeVal), int64(buildVal)
														if a < b {
															cmpResult = -1
														} else if a > b {
															cmpResult = 1
														} else {
															cmpResult = 0
														}
													}

													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = int(toCheck)
										probeIsNull = probeVec.Nulls().NullAt(probeIdx)
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												{
													a, b := int64(probeVal), int64(buildVal)
													if a < b {
														cmpResult = -1
													} else if a > b {
														cmpResult = 1
													} else {
														cmpResult = 0
													}
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						} else {
							if buildVec.MaybeHasNulls() {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = int(toCheck)
										buildIdx = int(keyID - 1)
										buildIsNull = buildVec.Nulls().NullAt(buildIdx)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												{
													a, b := int64(probeVal), int64(buildVal)
													if a < b {
														cmpResult = -1
													} else if a > b {
														cmpResult = 1
													} else {
														cmpResult = 0
													}
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = int(toCheck)
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												{
													a, b := int64(probeVal), int64(buildVal)
													if a < b {
														cmpResult = -1
													} else if a > b {
														cmpResult = 1
													} else {
														cmpResult = 0
													}
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						}
					}
				case -1:
				default:
					probeKeys := probeVec.Int16()
					buildKeys := buildVec.Int64()
					if probeSel != nil {
						if probeVec.MaybeHasNulls() {
							if buildVec.MaybeHasNulls() {
								if ht.allowNullEquality {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = probeSel[toCheck]
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull && buildIsNull {
												// Both values are NULLs, and since we're allowing null equality, we
												// proceed to the next value to check.
												continue
											} else if probeIsNull {
												// Only probing value is NULL, so it is different from the build value
												// (which is non-NULL). We mark it as "different" and proceed to the
												// next value to check. This behavior is special in case of allowing
												// null equality because we don't want to reset the groupID of the
												// current probing tuple.
												ht.probeScratch.differs[toCheck] = true
												continue
											}
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int

													{
														a, b := int64(probeVal), int64(buildVal)
														if a < b {
															cmpResult = -1
														} else if a > b {
															cmpResult = 1
														} else {
															cmpResult = 0
														}
													}

													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								} else {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = probeSel[toCheck]
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int

													{
														a, b := int64(probeVal), int64(buildVal)
														if a < b {
															cmpResult = -1
														} else if a > b {
															cmpResult = 1
														} else {
															cmpResult = 0
														}
													}

													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = probeSel[toCheck]
										probeIsNull = probeVec.Nulls().NullAt(probeIdx)
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												{
													a, b := int64(probeVal), int64(buildVal)
													if a < b {
														cmpResult = -1
													} else if a > b {
														cmpResult = 1
													} else {
														cmpResult = 0
													}
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						} else {
							if buildVec.MaybeHasNulls() {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = probeSel[toCheck]
										buildIdx = int(keyID - 1)
										buildIsNull = buildVec.Nulls().NullAt(buildIdx)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												{
													a, b := int64(probeVal), int64(buildVal)
													if a < b {
														cmpResult = -1
													} else if a > b {
														cmpResult = 1
													} else {
														cmpResult = 0
													}
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = probeSel[toCheck]
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												{
													a, b := int64(probeVal), int64(buildVal)
													if a < b {
														cmpResult = -1
													} else if a > b {
														cmpResult = 1
													} else {
														cmpResult = 0
													}
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						}
					} else {
						if probeVec.MaybeHasNulls() {
							if buildVec.MaybeHasNulls() {
								if ht.allowNullEquality {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = int(toCheck)
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull && buildIsNull {
												// Both values are NULLs, and since we're allowing null equality, we
												// proceed to the next value to check.
												continue
											} else if probeIsNull {
												// Only probing value is NULL, so it is different from the build value
												// (which is non-NULL). We mark it as "different" and proceed to the
												// next value to check. This behavior is special in case of allowing
												// null equality because we don't want to reset the groupID of the
												// current probing tuple.
												ht.probeScratch.differs[toCheck] = true
												continue
											}
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int

													{
														a, b := int64(probeVal), int64(buildVal)
														if a < b {
															cmpResult = -1
														} else if a > b {
															cmpResult = 1
														} else {
															cmpResult = 0
														}
													}

													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								} else {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = int(toCheck)
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int

													{
														a, b := int64(probeVal), int64(buildVal)
														if a < b {
															cmpResult = -1
														} else if a > b {
															cmpResult = 1
														} else {
															cmpResult = 0
														}
													}

													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = int(toCheck)
										probeIsNull = probeVec.Nulls().NullAt(probeIdx)
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												{
													a, b := int64(probeVal), int64(buildVal)
													if a < b {
														cmpResult = -1
													} else if a > b {
														cmpResult = 1
													} else {
														cmpResult = 0
													}
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						} else {
							if buildVec.MaybeHasNulls() {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = int(toCheck)
										buildIdx = int(keyID - 1)
										buildIsNull = buildVec.Nulls().NullAt(buildIdx)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												{
													a, b := int64(probeVal), int64(buildVal)
													if a < b {
														cmpResult = -1
													} else if a > b {
														cmpResult = 1
													} else {
														cmpResult = 0
													}
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = int(toCheck)
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												{
													a, b := int64(probeVal), int64(buildVal)
													if a < b {
														cmpResult = -1
													} else if a > b {
														cmpResult = 1
													} else {
														cmpResult = 0
													}
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						}
					}
				}
			}
		case 32:
			switch buildVec.CanonicalTypeFamily() {
			case types.IntFamily:
				switch buildVec.Type().Width() {
				case 16:
					probeKeys := probeVec.Int32()
					buildKeys := buildVec.Int16()
					if probeSel != nil {
						if probeVec.MaybeHasNulls() {
							if buildVec.MaybeHasNulls() {
								if ht.allowNullEquality {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = probeSel[toCheck]
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull && buildIsNull {
												// Both values are NULLs, and since we're allowing null equality, we
												// proceed to the next value to check.
												continue
											} else if probeIsNull {
												// Only probing value is NULL, so it is different from the build value
												// (which is non-NULL). We mark it as "different" and proceed to the
												// next value to check. This behavior is special in case of allowing
												// null equality because we don't want to reset the groupID of the
												// current probing tuple.
												ht.probeScratch.differs[toCheck] = true
												continue
											}
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int

													{
														a, b := int64(probeVal), int64(buildVal)
														if a < b {
															cmpResult = -1
														} else if a > b {
															cmpResult = 1
														} else {
															cmpResult = 0
														}
													}

													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								} else {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = probeSel[toCheck]
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int

													{
														a, b := int64(probeVal), int64(buildVal)
														if a < b {
															cmpResult = -1
														} else if a > b {
															cmpResult = 1
														} else {
															cmpResult = 0
														}
													}

													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = probeSel[toCheck]
										probeIsNull = probeVec.Nulls().NullAt(probeIdx)
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												{
													a, b := int64(probeVal), int64(buildVal)
													if a < b {
														cmpResult = -1
													} else if a > b {
														cmpResult = 1
													} else {
														cmpResult = 0
													}
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						} else {
							if buildVec.MaybeHasNulls() {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = probeSel[toCheck]
										buildIdx = int(keyID - 1)
										buildIsNull = buildVec.Nulls().NullAt(buildIdx)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												{
													a, b := int64(probeVal), int64(buildVal)
													if a < b {
														cmpResult = -1
													} else if a > b {
														cmpResult = 1
													} else {
														cmpResult = 0
													}
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = probeSel[toCheck]
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												{
													a, b := int64(probeVal), int64(buildVal)
													if a < b {
														cmpResult = -1
													} else if a > b {
														cmpResult = 1
													} else {
														cmpResult = 0
													}
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						}
					} else {
						if probeVec.MaybeHasNulls() {
							if buildVec.MaybeHasNulls() {
								if ht.allowNullEquality {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = int(toCheck)
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull && buildIsNull {
												// Both values are NULLs, and since we're allowing null equality, we
												// proceed to the next value to check.
												continue
											} else if probeIsNull {
												// Only probing value is NULL, so it is different from the build value
												// (which is non-NULL). We mark it as "different" and proceed to the
												// next value to check. This behavior is special in case of allowing
												// null equality because we don't want to reset the groupID of the
												// current probing tuple.
												ht.probeScratch.differs[toCheck] = true
												continue
											}
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int

													{
														a, b := int64(probeVal), int64(buildVal)
														if a < b {
															cmpResult = -1
														} else if a > b {
															cmpResult = 1
														} else {
															cmpResult = 0
														}
													}

													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								} else {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = int(toCheck)
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int

													{
														a, b := int64(probeVal), int64(buildVal)
														if a < b {
															cmpResult = -1
														} else if a > b {
															cmpResult = 1
														} else {
															cmpResult = 0
														}
													}

													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = int(toCheck)
										probeIsNull = probeVec.Nulls().NullAt(probeIdx)
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												{
													a, b := int64(probeVal), int64(buildVal)
													if a < b {
														cmpResult = -1
													} else if a > b {
														cmpResult = 1
													} else {
														cmpResult = 0
													}
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						} else {
							if buildVec.MaybeHasNulls() {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = int(toCheck)
										buildIdx = int(keyID - 1)
										buildIsNull = buildVec.Nulls().NullAt(buildIdx)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												{
													a, b := int64(probeVal), int64(buildVal)
													if a < b {
														cmpResult = -1
													} else if a > b {
														cmpResult = 1
													} else {
														cmpResult = 0
													}
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = int(toCheck)
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												{
													a, b := int64(probeVal), int64(buildVal)
													if a < b {
														cmpResult = -1
													} else if a > b {
														cmpResult = 1
													} else {
														cmpResult = 0
													}
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						}
					}
				case 32:
					probeKeys := probeVec.Int32()
					buildKeys := buildVec.Int32()
					if probeSel != nil {
						if probeVec.MaybeHasNulls() {
							if buildVec.MaybeHasNulls() {
								if ht.allowNullEquality {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = probeSel[toCheck]
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull && buildIsNull {
												// Both values are NULLs, and since we're allowing null equality, we
												// proceed to the next value to check.
												continue
											} else if probeIsNull {
												// Only probing value is NULL, so it is different from the build value
												// (which is non-NULL). We mark it as "different" and proceed to the
												// next value to check. This behavior is special in case of allowing
												// null equality because we don't want to reset the groupID of the
												// current probing tuple.
												ht.probeScratch.differs[toCheck] = true
												continue
											}
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int

													{
														a, b := int64(probeVal), int64(buildVal)
														if a < b {
															cmpResult = -1
														} else if a > b {
															cmpResult = 1
														} else {
															cmpResult = 0
														}
													}

													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								} else {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = probeSel[toCheck]
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int

													{
														a, b := int64(probeVal), int64(buildVal)
														if a < b {
															cmpResult = -1
														} else if a > b {
															cmpResult = 1
														} else {
															cmpResult = 0
														}
													}

													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = probeSel[toCheck]
										probeIsNull = probeVec.Nulls().NullAt(probeIdx)
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												{
													a, b := int64(probeVal), int64(buildVal)
													if a < b {
														cmpResult = -1
													} else if a > b {
														cmpResult = 1
													} else {
														cmpResult = 0
													}
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						} else {
							if buildVec.MaybeHasNulls() {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = probeSel[toCheck]
										buildIdx = int(keyID - 1)
										buildIsNull = buildVec.Nulls().NullAt(buildIdx)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												{
													a, b := int64(probeVal), int64(buildVal)
													if a < b {
														cmpResult = -1
													} else if a > b {
														cmpResult = 1
													} else {
														cmpResult = 0
													}
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = probeSel[toCheck]
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												{
													a, b := int64(probeVal), int64(buildVal)
													if a < b {
														cmpResult = -1
													} else if a > b {
														cmpResult = 1
													} else {
														cmpResult = 0
													}
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						}
					} else {
						if probeVec.MaybeHasNulls() {
							if buildVec.MaybeHasNulls() {
								if ht.allowNullEquality {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = int(toCheck)
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull && buildIsNull {
												// Both values are NULLs, and since we're allowing null equality, we
												// proceed to the next value to check.
												continue
											} else if probeIsNull {
												// Only probing value is NULL, so it is different from the build value
												// (which is non-NULL). We mark it as "different" and proceed to the
												// next value to check. This behavior is special in case of allowing
												// null equality because we don't want to reset the groupID of the
												// current probing tuple.
												ht.probeScratch.differs[toCheck] = true
												continue
											}
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int

													{
														a, b := int64(probeVal), int64(buildVal)
														if a < b {
															cmpResult = -1
														} else if a > b {
															cmpResult = 1
														} else {
															cmpResult = 0
														}
													}

													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								} else {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = int(toCheck)
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int

													{
														a, b := int64(probeVal), int64(buildVal)
														if a < b {
															cmpResult = -1
														} else if a > b {
															cmpResult = 1
														} else {
															cmpResult = 0
														}
													}

													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = int(toCheck)
										probeIsNull = probeVec.Nulls().NullAt(probeIdx)
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												{
													a, b := int64(probeVal), int64(buildVal)
													if a < b {
														cmpResult = -1
													} else if a > b {
														cmpResult = 1
													} else {
														cmpResult = 0
													}
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						} else {
							if buildVec.MaybeHasNulls() {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = int(toCheck)
										buildIdx = int(keyID - 1)
										buildIsNull = buildVec.Nulls().NullAt(buildIdx)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												{
													a, b := int64(probeVal), int64(buildVal)
													if a < b {
														cmpResult = -1
													} else if a > b {
														cmpResult = 1
													} else {
														cmpResult = 0
													}
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = int(toCheck)
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												{
													a, b := int64(probeVal), int64(buildVal)
													if a < b {
														cmpResult = -1
													} else if a > b {
														cmpResult = 1
													} else {
														cmpResult = 0
													}
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						}
					}
				case -1:
				default:
					probeKeys := probeVec.Int32()
					buildKeys := buildVec.Int64()
					if probeSel != nil {
						if probeVec.MaybeHasNulls() {
							if buildVec.MaybeHasNulls() {
								if ht.allowNullEquality {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = probeSel[toCheck]
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull && buildIsNull {
												// Both values are NULLs, and since we're allowing null equality, we
												// proceed to the next value to check.
												continue
											} else if probeIsNull {
												// Only probing value is NULL, so it is different from the build value
												// (which is non-NULL). We mark it as "different" and proceed to the
												// next value to check. This behavior is special in case of allowing
												// null equality because we don't want to reset the groupID of the
												// current probing tuple.
												ht.probeScratch.differs[toCheck] = true
												continue
											}
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int

													{
														a, b := int64(probeVal), int64(buildVal)
														if a < b {
															cmpResult = -1
														} else if a > b {
															cmpResult = 1
														} else {
															cmpResult = 0
														}
													}

													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								} else {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = probeSel[toCheck]
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int

													{
														a, b := int64(probeVal), int64(buildVal)
														if a < b {
															cmpResult = -1
														} else if a > b {
															cmpResult = 1
														} else {
															cmpResult = 0
														}
													}

													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = probeSel[toCheck]
										probeIsNull = probeVec.Nulls().NullAt(probeIdx)
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												{
													a, b := int64(probeVal), int64(buildVal)
													if a < b {
														cmpResult = -1
													} else if a > b {
														cmpResult = 1
													} else {
														cmpResult = 0
													}
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						} else {
							if buildVec.MaybeHasNulls() {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = probeSel[toCheck]
										buildIdx = int(keyID - 1)
										buildIsNull = buildVec.Nulls().NullAt(buildIdx)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												{
													a, b := int64(probeVal), int64(buildVal)
													if a < b {
														cmpResult = -1
													} else if a > b {
														cmpResult = 1
													} else {
														cmpResult = 0
													}
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = probeSel[toCheck]
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												{
													a, b := int64(probeVal), int64(buildVal)
													if a < b {
														cmpResult = -1
													} else if a > b {
														cmpResult = 1
													} else {
														cmpResult = 0
													}
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						}
					} else {
						if probeVec.MaybeHasNulls() {
							if buildVec.MaybeHasNulls() {
								if ht.allowNullEquality {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = int(toCheck)
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull && buildIsNull {
												// Both values are NULLs, and since we're allowing null equality, we
												// proceed to the next value to check.
												continue
											} else if probeIsNull {
												// Only probing value is NULL, so it is different from the build value
												// (which is non-NULL). We mark it as "different" and proceed to the
												// next value to check. This behavior is special in case of allowing
												// null equality because we don't want to reset the groupID of the
												// current probing tuple.
												ht.probeScratch.differs[toCheck] = true
												continue
											}
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int

													{
														a, b := int64(probeVal), int64(buildVal)
														if a < b {
															cmpResult = -1
														} else if a > b {
															cmpResult = 1
														} else {
															cmpResult = 0
														}
													}

													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								} else {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = int(toCheck)
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int

													{
														a, b := int64(probeVal), int64(buildVal)
														if a < b {
															cmpResult = -1
														} else if a > b {
															cmpResult = 1
														} else {
															cmpResult = 0
														}
													}

													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = int(toCheck)
										probeIsNull = probeVec.Nulls().NullAt(probeIdx)
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												{
													a, b := int64(probeVal), int64(buildVal)
													if a < b {
														cmpResult = -1
													} else if a > b {
														cmpResult = 1
													} else {
														cmpResult = 0
													}
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						} else {
							if buildVec.MaybeHasNulls() {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = int(toCheck)
										buildIdx = int(keyID - 1)
										buildIsNull = buildVec.Nulls().NullAt(buildIdx)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												{
													a, b := int64(probeVal), int64(buildVal)
													if a < b {
														cmpResult = -1
													} else if a > b {
														cmpResult = 1
													} else {
														cmpResult = 0
													}
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = int(toCheck)
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												{
													a, b := int64(probeVal), int64(buildVal)
													if a < b {
														cmpResult = -1
													} else if a > b {
														cmpResult = 1
													} else {
														cmpResult = 0
													}
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						}
					}
				}
			}
		case -1:
		default:
			switch buildVec.CanonicalTypeFamily() {
			case types.IntFamily:
				switch buildVec.Type().Width() {
				case 16:
					probeKeys := probeVec.Int64()
					buildKeys := buildVec.Int16()
					if probeSel != nil {
						if probeVec.MaybeHasNulls() {
							if buildVec.MaybeHasNulls() {
								if ht.allowNullEquality {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = probeSel[toCheck]
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull && buildIsNull {
												// Both values are NULLs, and since we're allowing null equality, we
												// proceed to the next value to check.
												continue
											} else if probeIsNull {
												// Only probing value is NULL, so it is different from the build value
												// (which is non-NULL). We mark it as "different" and proceed to the
												// next value to check. This behavior is special in case of allowing
												// null equality because we don't want to reset the groupID of the
												// current probing tuple.
												ht.probeScratch.differs[toCheck] = true
												continue
											}
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int

													{
														a, b := int64(probeVal), int64(buildVal)
														if a < b {
															cmpResult = -1
														} else if a > b {
															cmpResult = 1
														} else {
															cmpResult = 0
														}
													}

													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								} else {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = probeSel[toCheck]
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int

													{
														a, b := int64(probeVal), int64(buildVal)
														if a < b {
															cmpResult = -1
														} else if a > b {
															cmpResult = 1
														} else {
															cmpResult = 0
														}
													}

													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = probeSel[toCheck]
										probeIsNull = probeVec.Nulls().NullAt(probeIdx)
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												{
													a, b := int64(probeVal), int64(buildVal)
													if a < b {
														cmpResult = -1
													} else if a > b {
														cmpResult = 1
													} else {
														cmpResult = 0
													}
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						} else {
							if buildVec.MaybeHasNulls() {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = probeSel[toCheck]
										buildIdx = int(keyID - 1)
										buildIsNull = buildVec.Nulls().NullAt(buildIdx)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												{
													a, b := int64(probeVal), int64(buildVal)
													if a < b {
														cmpResult = -1
													} else if a > b {
														cmpResult = 1
													} else {
														cmpResult = 0
													}
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = probeSel[toCheck]
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												{
													a, b := int64(probeVal), int64(buildVal)
													if a < b {
														cmpResult = -1
													} else if a > b {
														cmpResult = 1
													} else {
														cmpResult = 0
													}
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						}
					} else {
						if probeVec.MaybeHasNulls() {
							if buildVec.MaybeHasNulls() {
								if ht.allowNullEquality {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = int(toCheck)
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull && buildIsNull {
												// Both values are NULLs, and since we're allowing null equality, we
												// proceed to the next value to check.
												continue
											} else if probeIsNull {
												// Only probing value is NULL, so it is different from the build value
												// (which is non-NULL). We mark it as "different" and proceed to the
												// next value to check. This behavior is special in case of allowing
												// null equality because we don't want to reset the groupID of the
												// current probing tuple.
												ht.probeScratch.differs[toCheck] = true
												continue
											}
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int

													{
														a, b := int64(probeVal), int64(buildVal)
														if a < b {
															cmpResult = -1
														} else if a > b {
															cmpResult = 1
														} else {
															cmpResult = 0
														}
													}

													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								} else {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = int(toCheck)
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int

													{
														a, b := int64(probeVal), int64(buildVal)
														if a < b {
															cmpResult = -1
														} else if a > b {
															cmpResult = 1
														} else {
															cmpResult = 0
														}
													}

													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = int(toCheck)
										probeIsNull = probeVec.Nulls().NullAt(probeIdx)
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												{
													a, b := int64(probeVal), int64(buildVal)
													if a < b {
														cmpResult = -1
													} else if a > b {
														cmpResult = 1
													} else {
														cmpResult = 0
													}
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						} else {
							if buildVec.MaybeHasNulls() {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = int(toCheck)
										buildIdx = int(keyID - 1)
										buildIsNull = buildVec.Nulls().NullAt(buildIdx)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												{
													a, b := int64(probeVal), int64(buildVal)
													if a < b {
														cmpResult = -1
													} else if a > b {
														cmpResult = 1
													} else {
														cmpResult = 0
													}
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = int(toCheck)
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												{
													a, b := int64(probeVal), int64(buildVal)
													if a < b {
														cmpResult = -1
													} else if a > b {
														cmpResult = 1
													} else {
														cmpResult = 0
													}
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						}
					}
				case 32:
					probeKeys := probeVec.Int64()
					buildKeys := buildVec.Int32()
					if probeSel != nil {
						if probeVec.MaybeHasNulls() {
							if buildVec.MaybeHasNulls() {
								if ht.allowNullEquality {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = probeSel[toCheck]
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull && buildIsNull {
												// Both values are NULLs, and since we're allowing null equality, we
												// proceed to the next value to check.
												continue
											} else if probeIsNull {
												// Only probing value is NULL, so it is different from the build value
												// (which is non-NULL). We mark it as "different" and proceed to the
												// next value to check. This behavior is special in case of allowing
												// null equality because we don't want to reset the groupID of the
												// current probing tuple.
												ht.probeScratch.differs[toCheck] = true
												continue
											}
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int

													{
														a, b := int64(probeVal), int64(buildVal)
														if a < b {
															cmpResult = -1
														} else if a > b {
															cmpResult = 1
														} else {
															cmpResult = 0
														}
													}

													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								} else {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = probeSel[toCheck]
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int

													{
														a, b := int64(probeVal), int64(buildVal)
														if a < b {
															cmpResult = -1
														} else if a > b {
															cmpResult = 1
														} else {
															cmpResult = 0
														}
													}

													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = probeSel[toCheck]
										probeIsNull = probeVec.Nulls().NullAt(probeIdx)
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												{
													a, b := int64(probeVal), int64(buildVal)
													if a < b {
														cmpResult = -1
													} else if a > b {
														cmpResult = 1
													} else {
														cmpResult = 0
													}
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						} else {
							if buildVec.MaybeHasNulls() {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = probeSel[toCheck]
										buildIdx = int(keyID - 1)
										buildIsNull = buildVec.Nulls().NullAt(buildIdx)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												{
													a, b := int64(probeVal), int64(buildVal)
													if a < b {
														cmpResult = -1
													} else if a > b {
														cmpResult = 1
													} else {
														cmpResult = 0
													}
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = probeSel[toCheck]
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												{
													a, b := int64(probeVal), int64(buildVal)
													if a < b {
														cmpResult = -1
													} else if a > b {
														cmpResult = 1
													} else {
														cmpResult = 0
													}
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						}
					} else {
						if probeVec.MaybeHasNulls() {
							if buildVec.MaybeHasNulls() {
								if ht.allowNullEquality {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = int(toCheck)
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull && buildIsNull {
												// Both values are NULLs, and since we're allowing null equality, we
												// proceed to the next value to check.
												continue
											} else if probeIsNull {
												// Only probing value is NULL, so it is different from the build value
												// (which is non-NULL). We mark it as "different" and proceed to the
												// next value to check. This behavior is special in case of allowing
												// null equality because we don't want to reset the groupID of the
												// current probing tuple.
												ht.probeScratch.differs[toCheck] = true
												continue
											}
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int

													{
														a, b := int64(probeVal), int64(buildVal)
														if a < b {
															cmpResult = -1
														} else if a > b {
															cmpResult = 1
														} else {
															cmpResult = 0
														}
													}

													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								} else {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = int(toCheck)
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int

													{
														a, b := int64(probeVal), int64(buildVal)
														if a < b {
															cmpResult = -1
														} else if a > b {
															cmpResult = 1
														} else {
															cmpResult = 0
														}
													}

													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = int(toCheck)
										probeIsNull = probeVec.Nulls().NullAt(probeIdx)
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												{
													a, b := int64(probeVal), int64(buildVal)
													if a < b {
														cmpResult = -1
													} else if a > b {
														cmpResult = 1
													} else {
														cmpResult = 0
													}
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						} else {
							if buildVec.MaybeHasNulls() {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = int(toCheck)
										buildIdx = int(keyID - 1)
										buildIsNull = buildVec.Nulls().NullAt(buildIdx)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												{
													a, b := int64(probeVal), int64(buildVal)
													if a < b {
														cmpResult = -1
													} else if a > b {
														cmpResult = 1
													} else {
														cmpResult = 0
													}
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = int(toCheck)
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												{
													a, b := int64(probeVal), int64(buildVal)
													if a < b {
														cmpResult = -1
													} else if a > b {
														cmpResult = 1
													} else {
														cmpResult = 0
													}
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						}
					}
				case -1:
				default:
					probeKeys := probeVec.Int64()
					buildKeys := buildVec.Int64()
					if probeSel != nil {
						if probeVec.MaybeHasNulls() {
							if buildVec.MaybeHasNulls() {
								if ht.allowNullEquality {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = probeSel[toCheck]
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull && buildIsNull {
												// Both values are NULLs, and since we're allowing null equality, we
												// proceed to the next value to check.
												continue
											} else if probeIsNull {
												// Only probing value is NULL, so it is different from the build value
												// (which is non-NULL). We mark it as "different" and proceed to the
												// next value to check. This behavior is special in case of allowing
												// null equality because we don't want to reset the groupID of the
												// current probing tuple.
												ht.probeScratch.differs[toCheck] = true
												continue
											}
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int

													{
														a, b := int64(probeVal), int64(buildVal)
														if a < b {
															cmpResult = -1
														} else if a > b {
															cmpResult = 1
														} else {
															cmpResult = 0
														}
													}

													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								} else {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = probeSel[toCheck]
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int

													{
														a, b := int64(probeVal), int64(buildVal)
														if a < b {
															cmpResult = -1
														} else if a > b {
															cmpResult = 1
														} else {
															cmpResult = 0
														}
													}

													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = probeSel[toCheck]
										probeIsNull = probeVec.Nulls().NullAt(probeIdx)
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												{
													a, b := int64(probeVal), int64(buildVal)
													if a < b {
														cmpResult = -1
													} else if a > b {
														cmpResult = 1
													} else {
														cmpResult = 0
													}
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						} else {
							if buildVec.MaybeHasNulls() {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = probeSel[toCheck]
										buildIdx = int(keyID - 1)
										buildIsNull = buildVec.Nulls().NullAt(buildIdx)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												{
													a, b := int64(probeVal), int64(buildVal)
													if a < b {
														cmpResult = -1
													} else if a > b {
														cmpResult = 1
													} else {
														cmpResult = 0
													}
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = probeSel[toCheck]
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												{
													a, b := int64(probeVal), int64(buildVal)
													if a < b {
														cmpResult = -1
													} else if a > b {
														cmpResult = 1
													} else {
														cmpResult = 0
													}
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						}
					} else {
						if probeVec.MaybeHasNulls() {
							if buildVec.MaybeHasNulls() {
								if ht.allowNullEquality {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = int(toCheck)
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull && buildIsNull {
												// Both values are NULLs, and since we're allowing null equality, we
												// proceed to the next value to check.
												continue
											} else if probeIsNull {
												// Only probing value is NULL, so it is different from the build value
												// (which is non-NULL). We mark it as "different" and proceed to the
												// next value to check. This behavior is special in case of allowing
												// null equality because we don't want to reset the groupID of the
												// current probing tuple.
												ht.probeScratch.differs[toCheck] = true
												continue
											}
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int

													{
														a, b := int64(probeVal), int64(buildVal)
														if a < b {
															cmpResult = -1
														} else if a > b {
															cmpResult = 1
														} else {
															cmpResult = 0
														}
													}

													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								} else {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = int(toCheck)
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int

													{
														a, b := int64(probeVal), int64(buildVal)
														if a < b {
															cmpResult = -1
														} else if a > b {
															cmpResult = 1
														} else {
															cmpResult = 0
														}
													}

													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = int(toCheck)
										probeIsNull = probeVec.Nulls().NullAt(probeIdx)
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												{
													a, b := int64(probeVal), int64(buildVal)
													if a < b {
														cmpResult = -1
													} else if a > b {
														cmpResult = 1
													} else {
														cmpResult = 0
													}
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						} else {
							if buildVec.MaybeHasNulls() {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = int(toCheck)
										buildIdx = int(keyID - 1)
										buildIsNull = buildVec.Nulls().NullAt(buildIdx)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												{
													a, b := int64(probeVal), int64(buildVal)
													if a < b {
														cmpResult = -1
													} else if a > b {
														cmpResult = 1
													} else {
														cmpResult = 0
													}
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = int(toCheck)
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												{
													a, b := int64(probeVal), int64(buildVal)
													if a < b {
														cmpResult = -1
													} else if a > b {
														cmpResult = 1
													} else {
														cmpResult = 0
													}
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						}
					}
				}
			}
		}
	case types.FloatFamily:
		switch probeVec.Type().Width() {
		case -1:
		default:
			switch buildVec.CanonicalTypeFamily() {
			case types.FloatFamily:
				switch buildVec.Type().Width() {
				case -1:
				default:
					probeKeys := probeVec.Float64()
					buildKeys := buildVec.Float64()
					if probeSel != nil {
						if probeVec.MaybeHasNulls() {
							if buildVec.MaybeHasNulls() {
								if ht.allowNullEquality {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = probeSel[toCheck]
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull && buildIsNull {
												// Both values are NULLs, and since we're allowing null equality, we
												// proceed to the next value to check.
												continue
											} else if probeIsNull {
												// Only probing value is NULL, so it is different from the build value
												// (which is non-NULL). We mark it as "different" and proceed to the
												// next value to check. This behavior is special in case of allowing
												// null equality because we don't want to reset the groupID of the
												// current probing tuple.
												ht.probeScratch.differs[toCheck] = true
												continue
											}
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int

													{
														a, b := float64(probeVal), float64(buildVal)
														if a < b {
															cmpResult = -1
														} else if a > b {
															cmpResult = 1
														} else if a == b {
															cmpResult = 0
														} else if math.IsNaN(a) {
															if math.IsNaN(b) {
																cmpResult = 0
															} else {
																cmpResult = -1
															}
														} else {
															cmpResult = 1
														}
													}

													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								} else {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = probeSel[toCheck]
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int

													{
														a, b := float64(probeVal), float64(buildVal)
														if a < b {
															cmpResult = -1
														} else if a > b {
															cmpResult = 1
														} else if a == b {
															cmpResult = 0
														} else if math.IsNaN(a) {
															if math.IsNaN(b) {
																cmpResult = 0
															} else {
																cmpResult = -1
															}
														} else {
															cmpResult = 1
														}
													}

													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = probeSel[toCheck]
										probeIsNull = probeVec.Nulls().NullAt(probeIdx)
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												{
													a, b := float64(probeVal), float64(buildVal)
													if a < b {
														cmpResult = -1
													} else if a > b {
														cmpResult = 1
													} else if a == b {
														cmpResult = 0
													} else if math.IsNaN(a) {
														if math.IsNaN(b) {
															cmpResult = 0
														} else {
															cmpResult = -1
														}
													} else {
														cmpResult = 1
													}
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						} else {
							if buildVec.MaybeHasNulls() {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = probeSel[toCheck]
										buildIdx = int(keyID - 1)
										buildIsNull = buildVec.Nulls().NullAt(buildIdx)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												{
													a, b := float64(probeVal), float64(buildVal)
													if a < b {
														cmpResult = -1
													} else if a > b {
														cmpResult = 1
													} else if a == b {
														cmpResult = 0
													} else if math.IsNaN(a) {
														if math.IsNaN(b) {
															cmpResult = 0
														} else {
															cmpResult = -1
														}
													} else {
														cmpResult = 1
													}
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = probeSel[toCheck]
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												{
													a, b := float64(probeVal), float64(buildVal)
													if a < b {
														cmpResult = -1
													} else if a > b {
														cmpResult = 1
													} else if a == b {
														cmpResult = 0
													} else if math.IsNaN(a) {
														if math.IsNaN(b) {
															cmpResult = 0
														} else {
															cmpResult = -1
														}
													} else {
														cmpResult = 1
													}
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						}
					} else {
						if probeVec.MaybeHasNulls() {
							if buildVec.MaybeHasNulls() {
								if ht.allowNullEquality {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = int(toCheck)
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull && buildIsNull {
												// Both values are NULLs, and since we're allowing null equality, we
												// proceed to the next value to check.
												continue
											} else if probeIsNull {
												// Only probing value is NULL, so it is different from the build value
												// (which is non-NULL). We mark it as "different" and proceed to the
												// next value to check. This behavior is special in case of allowing
												// null equality because we don't want to reset the groupID of the
												// current probing tuple.
												ht.probeScratch.differs[toCheck] = true
												continue
											}
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int

													{
														a, b := float64(probeVal), float64(buildVal)
														if a < b {
															cmpResult = -1
														} else if a > b {
															cmpResult = 1
														} else if a == b {
															cmpResult = 0
														} else if math.IsNaN(a) {
															if math.IsNaN(b) {
																cmpResult = 0
															} else {
																cmpResult = -1
															}
														} else {
															cmpResult = 1
														}
													}

													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								} else {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = int(toCheck)
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int

													{
														a, b := float64(probeVal), float64(buildVal)
														if a < b {
															cmpResult = -1
														} else if a > b {
															cmpResult = 1
														} else if a == b {
															cmpResult = 0
														} else if math.IsNaN(a) {
															if math.IsNaN(b) {
																cmpResult = 0
															} else {
																cmpResult = -1
															}
														} else {
															cmpResult = 1
														}
													}

													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = int(toCheck)
										probeIsNull = probeVec.Nulls().NullAt(probeIdx)
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												{
													a, b := float64(probeVal), float64(buildVal)
													if a < b {
														cmpResult = -1
													} else if a > b {
														cmpResult = 1
													} else if a == b {
														cmpResult = 0
													} else if math.IsNaN(a) {
														if math.IsNaN(b) {
															cmpResult = 0
														} else {
															cmpResult = -1
														}
													} else {
														cmpResult = 1
													}
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						} else {
							if buildVec.MaybeHasNulls() {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = int(toCheck)
										buildIdx = int(keyID - 1)
										buildIsNull = buildVec.Nulls().NullAt(buildIdx)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												{
													a, b := float64(probeVal), float64(buildVal)
													if a < b {
														cmpResult = -1
													} else if a > b {
														cmpResult = 1
													} else if a == b {
														cmpResult = 0
													} else if math.IsNaN(a) {
														if math.IsNaN(b) {
															cmpResult = 0
														} else {
															cmpResult = -1
														}
													} else {
														cmpResult = 1
													}
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = int(toCheck)
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												{
													a, b := float64(probeVal), float64(buildVal)
													if a < b {
														cmpResult = -1
													} else if a > b {
														cmpResult = 1
													} else if a == b {
														cmpResult = 0
													} else if math.IsNaN(a) {
														if math.IsNaN(b) {
															cmpResult = 0
														} else {
															cmpResult = -1
														}
													} else {
														cmpResult = 1
													}
												}

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						}
					}
				}
			}
		}
	case types.TimestampTZFamily:
		switch probeVec.Type().Width() {
		case -1:
		default:
			switch buildVec.CanonicalTypeFamily() {
			case types.TimestampTZFamily:
				switch buildVec.Type().Width() {
				case -1:
				default:
					probeKeys := probeVec.Timestamp()
					buildKeys := buildVec.Timestamp()
					if probeSel != nil {
						if probeVec.MaybeHasNulls() {
							if buildVec.MaybeHasNulls() {
								if ht.allowNullEquality {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = probeSel[toCheck]
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull && buildIsNull {
												// Both values are NULLs, and since we're allowing null equality, we
												// proceed to the next value to check.
												continue
											} else if probeIsNull {
												// Only probing value is NULL, so it is different from the build value
												// (which is non-NULL). We mark it as "different" and proceed to the
												// next value to check. This behavior is special in case of allowing
												// null equality because we don't want to reset the groupID of the
												// current probing tuple.
												ht.probeScratch.differs[toCheck] = true
												continue
											}
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int

													if probeVal.Before(buildVal) {
														cmpResult = -1
													} else if buildVal.Before(probeVal) {
														cmpResult = 1
													} else {
														cmpResult = 0
													}
													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								} else {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = probeSel[toCheck]
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int

													if probeVal.Before(buildVal) {
														cmpResult = -1
													} else if buildVal.Before(probeVal) {
														cmpResult = 1
													} else {
														cmpResult = 0
													}
													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = probeSel[toCheck]
										probeIsNull = probeVec.Nulls().NullAt(probeIdx)
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												if probeVal.Before(buildVal) {
													cmpResult = -1
												} else if buildVal.Before(probeVal) {
													cmpResult = 1
												} else {
													cmpResult = 0
												}
												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						} else {
							if buildVec.MaybeHasNulls() {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = probeSel[toCheck]
										buildIdx = int(keyID - 1)
										buildIsNull = buildVec.Nulls().NullAt(buildIdx)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												if probeVal.Before(buildVal) {
													cmpResult = -1
												} else if buildVal.Before(probeVal) {
													cmpResult = 1
												} else {
													cmpResult = 0
												}
												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = probeSel[toCheck]
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												if probeVal.Before(buildVal) {
													cmpResult = -1
												} else if buildVal.Before(probeVal) {
													cmpResult = 1
												} else {
													cmpResult = 0
												}
												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						}
					} else {
						if probeVec.MaybeHasNulls() {
							if buildVec.MaybeHasNulls() {
								if ht.allowNullEquality {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = int(toCheck)
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull && buildIsNull {
												// Both values are NULLs, and since we're allowing null equality, we
												// proceed to the next value to check.
												continue
											} else if probeIsNull {
												// Only probing value is NULL, so it is different from the build value
												// (which is non-NULL). We mark it as "different" and proceed to the
												// next value to check. This behavior is special in case of allowing
												// null equality because we don't want to reset the groupID of the
												// current probing tuple.
												ht.probeScratch.differs[toCheck] = true
												continue
											}
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int

													if probeVal.Before(buildVal) {
														cmpResult = -1
													} else if buildVal.Before(probeVal) {
														cmpResult = 1
													} else {
														cmpResult = 0
													}
													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								} else {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = int(toCheck)
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int

													if probeVal.Before(buildVal) {
														cmpResult = -1
													} else if buildVal.Before(probeVal) {
														cmpResult = 1
													} else {
														cmpResult = 0
													}
													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = int(toCheck)
										probeIsNull = probeVec.Nulls().NullAt(probeIdx)
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												if probeVal.Before(buildVal) {
													cmpResult = -1
												} else if buildVal.Before(probeVal) {
													cmpResult = 1
												} else {
													cmpResult = 0
												}
												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						} else {
							if buildVec.MaybeHasNulls() {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = int(toCheck)
										buildIdx = int(keyID - 1)
										buildIsNull = buildVec.Nulls().NullAt(buildIdx)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												if probeVal.Before(buildVal) {
													cmpResult = -1
												} else if buildVal.Before(probeVal) {
													cmpResult = 1
												} else {
													cmpResult = 0
												}
												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = int(toCheck)
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												if probeVal.Before(buildVal) {
													cmpResult = -1
												} else if buildVal.Before(probeVal) {
													cmpResult = 1
												} else {
													cmpResult = 0
												}
												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						}
					}
				}
			}
		}
	case types.IntervalFamily:
		switch probeVec.Type().Width() {
		case -1:
		default:
			switch buildVec.CanonicalTypeFamily() {
			case types.IntervalFamily:
				switch buildVec.Type().Width() {
				case -1:
				default:
					probeKeys := probeVec.Interval()
					buildKeys := buildVec.Interval()
					if probeSel != nil {
						if probeVec.MaybeHasNulls() {
							if buildVec.MaybeHasNulls() {
								if ht.allowNullEquality {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = probeSel[toCheck]
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull && buildIsNull {
												// Both values are NULLs, and since we're allowing null equality, we
												// proceed to the next value to check.
												continue
											} else if probeIsNull {
												// Only probing value is NULL, so it is different from the build value
												// (which is non-NULL). We mark it as "different" and proceed to the
												// next value to check. This behavior is special in case of allowing
												// null equality because we don't want to reset the groupID of the
												// current probing tuple.
												ht.probeScratch.differs[toCheck] = true
												continue
											}
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int
													cmpResult = probeVal.Compare(buildVal)
													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								} else {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = probeSel[toCheck]
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int
													cmpResult = probeVal.Compare(buildVal)
													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = probeSel[toCheck]
										probeIsNull = probeVec.Nulls().NullAt(probeIdx)
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int
												cmpResult = probeVal.Compare(buildVal)
												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						} else {
							if buildVec.MaybeHasNulls() {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = probeSel[toCheck]
										buildIdx = int(keyID - 1)
										buildIsNull = buildVec.Nulls().NullAt(buildIdx)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int
												cmpResult = probeVal.Compare(buildVal)
												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = probeSel[toCheck]
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int
												cmpResult = probeVal.Compare(buildVal)
												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						}
					} else {
						if probeVec.MaybeHasNulls() {
							if buildVec.MaybeHasNulls() {
								if ht.allowNullEquality {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = int(toCheck)
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull && buildIsNull {
												// Both values are NULLs, and since we're allowing null equality, we
												// proceed to the next value to check.
												continue
											} else if probeIsNull {
												// Only probing value is NULL, so it is different from the build value
												// (which is non-NULL). We mark it as "different" and proceed to the
												// next value to check. This behavior is special in case of allowing
												// null equality because we don't want to reset the groupID of the
												// current probing tuple.
												ht.probeScratch.differs[toCheck] = true
												continue
											}
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int
													cmpResult = probeVal.Compare(buildVal)
													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								} else {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = int(toCheck)
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int
													cmpResult = probeVal.Compare(buildVal)
													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = int(toCheck)
										probeIsNull = probeVec.Nulls().NullAt(probeIdx)
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int
												cmpResult = probeVal.Compare(buildVal)
												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						} else {
							if buildVec.MaybeHasNulls() {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = int(toCheck)
										buildIdx = int(keyID - 1)
										buildIsNull = buildVec.Nulls().NullAt(buildIdx)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int
												cmpResult = probeVal.Compare(buildVal)
												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = int(toCheck)
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int
												cmpResult = probeVal.Compare(buildVal)
												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						}
					}
				}
			}
		}
	case typeconv.DatumVecCanonicalTypeFamily:
		switch probeVec.Type().Width() {
		case -1:
		default:
			switch buildVec.CanonicalTypeFamily() {
			case typeconv.DatumVecCanonicalTypeFamily:
				switch buildVec.Type().Width() {
				case -1:
				default:
					probeKeys := probeVec.Datum()
					buildKeys := buildVec.Datum()
					if probeSel != nil {
						if probeVec.MaybeHasNulls() {
							if buildVec.MaybeHasNulls() {
								if ht.allowNullEquality {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = probeSel[toCheck]
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull && buildIsNull {
												// Both values are NULLs, and since we're allowing null equality, we
												// proceed to the next value to check.
												continue
											} else if probeIsNull {
												// Only probing value is NULL, so it is different from the build value
												// (which is non-NULL). We mark it as "different" and proceed to the
												// next value to check. This behavior is special in case of allowing
												// null equality because we don't want to reset the groupID of the
												// current probing tuple.
												ht.probeScratch.differs[toCheck] = true
												continue
											}
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int

													cmpResult = probeVal.(*coldataext.Datum).CompareDatum(probeKeys, buildVal)

													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								} else {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = probeSel[toCheck]
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int

													cmpResult = probeVal.(*coldataext.Datum).CompareDatum(probeKeys, buildVal)

													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = probeSel[toCheck]
										probeIsNull = probeVec.Nulls().NullAt(probeIdx)
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												cmpResult = probeVal.(*coldataext.Datum).CompareDatum(probeKeys, buildVal)

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						} else {
							if buildVec.MaybeHasNulls() {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = probeSel[toCheck]
										buildIdx = int(keyID - 1)
										buildIsNull = buildVec.Nulls().NullAt(buildIdx)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												cmpResult = probeVal.(*coldataext.Datum).CompareDatum(probeKeys, buildVal)

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = probeSel[toCheck]
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												cmpResult = probeVal.(*coldataext.Datum).CompareDatum(probeKeys, buildVal)

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						}
					} else {
						if probeVec.MaybeHasNulls() {
							if buildVec.MaybeHasNulls() {
								if ht.allowNullEquality {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = int(toCheck)
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull && buildIsNull {
												// Both values are NULLs, and since we're allowing null equality, we
												// proceed to the next value to check.
												continue
											} else if probeIsNull {
												// Only probing value is NULL, so it is different from the build value
												// (which is non-NULL). We mark it as "different" and proceed to the
												// next value to check. This behavior is special in case of allowing
												// null equality because we don't want to reset the groupID of the
												// current probing tuple.
												ht.probeScratch.differs[toCheck] = true
												continue
											}
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int

													cmpResult = probeVal.(*coldataext.Datum).CompareDatum(probeKeys, buildVal)

													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								} else {
									var (
										probeIdx, buildIdx       int
										probeIsNull, buildIsNull bool
									)
									for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
										// keyID of 0 is reserved to represent the end of the next chain.
										keyID := ht.probeScratch.groupID[toCheck]
										if keyID != 0 {
											// the build table key (calculated using keys[keyID - 1] = key) is
											// compared to the corresponding probe table to determine if a match is
											// found.

											probeIdx = int(toCheck)
											probeIsNull = probeVec.Nulls().NullAt(probeIdx)
											buildIdx = int(keyID - 1)
											buildIsNull = buildVec.Nulls().NullAt(buildIdx)
											if probeIsNull {
												ht.probeScratch.groupID[toCheck] = 0
											} else if buildIsNull {
												ht.probeScratch.differs[toCheck] = true
											} else {
												probeVal := probeKeys.Get(probeIdx)
												buildVal := buildKeys.Get(buildIdx)
												var unique bool

												{
													var cmpResult int

													cmpResult = probeVal.(*coldataext.Datum).CompareDatum(probeKeys, buildVal)

													unique = cmpResult != 0
												}

												ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
											}
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = int(toCheck)
										probeIsNull = probeVec.Nulls().NullAt(probeIdx)
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												cmpResult = probeVal.(*coldataext.Datum).CompareDatum(probeKeys, buildVal)

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						} else {
							if buildVec.MaybeHasNulls() {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = int(toCheck)
										buildIdx = int(keyID - 1)
										buildIsNull = buildVec.Nulls().NullAt(buildIdx)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												cmpResult = probeVal.(*coldataext.Datum).CompareDatum(probeKeys, buildVal)

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							} else {
								var (
									probeIdx, buildIdx       int
									probeIsNull, buildIsNull bool
								)
								for _, toCheck := range ht.probeScratch.toCheck[:nToCheck] {
									// keyID of 0 is reserved to represent the end of the next chain.
									keyID := ht.probeScratch.groupID[toCheck]
									if keyID != 0 {
										// the build table key (calculated using keys[keyID - 1] = key) is
										// compared to the corresponding probe table to determine if a match is
										// found.

										probeIdx = int(toCheck)
										buildIdx = int(keyID - 1)
										if probeIsNull {
											ht.probeScratch.groupID[toCheck] = 0
										} else if buildIsNull {
											ht.probeScratch.differs[toCheck] = true
										} else {
											probeVal := probeKeys.Get(probeIdx)
											buildVal := buildKeys.Get(buildIdx)
											var unique bool

											{
												var cmpResult int

												cmpResult = probeVal.(*coldataext.Datum).CompareDatum(probeKeys, buildVal)

												unique = cmpResult != 0
											}

											ht.probeScratch.differs[toCheck] = ht.probeScratch.differs[toCheck] || unique
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}
}
